/* -*- Mode: C++ ; Coding: euc-japan -*- */
/* Time-stamp: <2013-05-14 17:15:47 cyamauch> */

/**
 * @file   asarray_tstring.cc
 * @brief  ʸϢ򰷤 asarray_tstring 饹Υ
 */

#define CLASS_NAME "asarray_tstring"

#include "config.h"

#include "asarray_tstring.h"

#include <stdlib.h>

#include "private/err_report.h"


namespace sli
{

/* constructor */

/**
 * @brief  󥹥ȥ饯
 *
 */
asarray_tstring::asarray_tstring()
{
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  Ȥ elements[] ͤȤƽޤ<br>
 *  ¤ΤκǽǤˤɬ {NULL,NULL} ͿƤ
 * 
 * @param  elements asarrdef_tstring¤Τ
 * @throw  Хåեγݤ˼Ԥ
 */
asarray_tstring::asarray_tstring(const asarrdef_tstring elements[])
{
    this->assign(elements);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  Ϳ줿ʸʸǼȤޤ<br>
 *  κǸˤɬ NULL ͿƤ
 *  
 * @param  key0 ʸ
 * @param  val0 ʸ
 * @param  key1 ʸ
 * @param  ... ͤȤʤʸβĹγǥǡ
 * @throw  Хåեγݤ˼Ԥ
 */
asarray_tstring::asarray_tstring(const char *key0, const char *val0,
				 const char *key1, ...)
{
    va_list ap;
    va_start(ap,key1);
    try {
	this->vassign(key0,val0,key1,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vassign() failed");
    }
    va_end(ap);
    return;
}

/* copy constructor */

/**
 * @brief  ԡ󥹥ȥ饯
 *
 *  ȤobjƤǽޤ
 * 
 * @param  obj asarray_tstring֥
 * @throw  Хåեγݤ˼Ԥ
 * @throw  ˲򵯤Ȥ
 */
asarray_tstring::asarray_tstring(const asarray_tstring &obj)
{
    this->init(obj);
    return;
}

/* destructor */

/**
 * @brief  ǥȥ饯
 */
asarray_tstring::~asarray_tstring()
{
    return;
}

/**
 * @brief  ֥ȤΥԡ
 *
 *  黻Ҥα¦ǻꤵ줿 asarray_tstring 饹Υ֥Ȥ򼫿Ȥ˥ԡ
 *  ޤ
 * 
 * @param   obj asarray_tstringΥ֥
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ 
 * @throw   ˲򵯤Ȥ
 */
asarray_tstring &asarray_tstring::operator=(const asarray_tstring &obj)
{
    this->init(obj);
    return *this;
}

/**
 * @brief  [] ǻꤵ줿ͤλ(tstring)֤
 *
 *  бϢͤλȤ֤ޤ
 * 
 * @param   key ϢΥʸ
 * @return  бϢͤλ
 * @throw   ꤵ줿ʸNULLξ
 * @throw   Хåեγݤ˼Ԥ
 */
tstring &asarray_tstring::operator[]( const char *key )
{
    return this->at(key);
}

/**
 * @brief  [] ǻꤵ줿ͤλ(tstring)֤ (ɼ)
 *
 *  бϢͤλȤ֤ޤ
 * 
 * @param   key ϢΥʸ 
 * @return  бϢ
 * @throw   ꤵ줿ʸNULLξ
 * @throw   ¸ߤʤʸ󤬻ꤵ줿
 */
const tstring &asarray_tstring::operator[]( const char *key ) const
{
    return this->at_cs(key);
}

/*
 * public member functions
 */

/**
 * @brief  ֥Ȥν
 *
 *  ȤϢõ֥ȤνԤޤ
 * 
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::init()
{
    this->index_rec.init();
    this->key_rec.init();
    this->value_rec.init();
    this->regex_rec.init();
    return *this;
}

/**
 * @brief  ֥ȤΥԡ
 * 
 *  ꤵ줿֥ obj Ƥ򼫿Ȥ˥ԡޤ
 *
 * @param   obj asarray_tstringΥ֥
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 * @throw   ˲򵯤
 */
asarray_tstring &asarray_tstring::init(const asarray_tstring &obj)
{
    if ( &obj == this ) return *this;
    this->value_rec.init(obj.value_rec);
    this->key_rec.init(obj.key_rec);
    this->index_rec.init(obj.index_rec);
    /* this->regex_rec.init(obj.regex_rec); */
    this->regex_rec.init();
    return *this;
}

/**
 * @brief  ¸ͤ٤Ƥꤵ줿ʸ(const char *)ǥѥǥ
 *
 *  ȤϢͤ٤Ƥʸ str ǥѥǥ󥰤ޤ<br>
 *  str ά硤Ĺ0ʸ󤬻Ȥޤ
 * 
 * @param   str Ϣͤѥǥ󥰤ʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::clean(const char *str)
{
    this->value_rec.clean(str);
    return *this;
}

/**
 * @brief  ¸ͤ٤Ƥꤵ줿ʸ(tstring)ǥѥǥ
 *
 *  ȤϢͤ٤Ƥʸ str ǥѥǥ󥰤ޤ<br>
 * 
 * @param   str Ϣͤѥǥ󥰤ʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::clean(const tstring &str)
{
    this->value_rec.clean(str);
    return *this;
}

/**
 * @brief  ꤵ줿Ϣ(asarray_tstring)򼫿Ȥ
 *
 *  srcǻꤵ줿ʸϢ򡤼Ȥޤ
 * 
 * @param   src asarray_tstring֥
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 * 
 */
asarray_tstring &asarray_tstring::assign(const asarray_tstring &src)
{
    if ( &src == this ) return *this;
    this->erase();
    return this->append(src);
}

/**
 * @brief  ꤵ줿Ϣ(asarrdef_tstring [])򼫿Ȥ
 *
 *  elements ǻꤵ줿ʸϢ򡤼Ȥޤ<br>
 *  elements  {NULL,NULL} ǽüƤɬפޤ
 * 
 * @param   elements[] asarrdef_tstring
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign( const asarrdef_tstring elements[] )
{
    if ( elements != NULL ) {
	size_t i;
	for ( i=0 ; elements[i].key != NULL ; i++ );
	this->assign(elements, i);
    }
    else {
	this->erase();
    }
    return *this;
}

/**
 * @brief  ꤵ줿Ϣ(asarrdef_tstring [])nĤ򼫿Ȥ
 *
 *  elements ǻꤵ줿ʸϢƬ n ʬƤ򡤼Ȥ
 *  ޤ
 * 
 * @param   elements asarray_tstring֥
 * @param   n elementsο
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign( const asarrdef_tstring elements[],
					  size_t n )
{
    /* ȤƤ key, val Ƥ⤤褦ˤ */
    if ( 0 < n && elements != NULL ) { 
	size_t i, len_elem, org_len = this->length();
	for ( i=0 ; i < n && elements[i].key != NULL ; i++ );
	len_elem = i;
	/* ޤǸɲä */
	for ( i=0 ; i < len_elem ; i++ ) {
	    const char *val = elements[i].value;
	    if ( val == NULL ) val = "";
	    this->value_rec.append(val, 1);
	    this->key_rec.append(elements[i].key, 1);
	} 
	/* ΤĤõ */
	this->value_rec.erase(0, org_len);
	this->key_rec.erase(0, org_len);
	/* ǥåϤϤ */
	this->index_rec.init();
	for ( i=0 ; i < this->key_rec.length() ; ) {
	    if ( this->index_rec.index(this->key_rec.cstr(i),0) < 0 ) {
		this->index_rec.append(this->key_rec.cstr(i),i);
		i++;
	    }
	    else {
		err_report1(__FUNCTION__,"WARNING","cannot append key '%s'",
			    this->key_rec.cstr(i));
		this->value_rec.erase(i, 1);
		this->key_rec.erase(i, 1);
	    }
	} 
    } 
    else {
	this->erase();
    } 
    return *this;
}

/**
 * @brief  ꤵ줿(key,value) 1ĤΤߤϢȤ
 *
 *  Ȥ򡤻ꤵ줿 1ĤǤϢˤޤ
 *  
 * @param   key Ϣꤹ륭ʸ
 * @param   val Ϣꤹʸ 
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign( const char *key, const char *val )
{
    asarrdef_tstring el[] = { {key,val},{NULL,NULL} };
    return this->assign(el);
}

/**
 * @brief  ꤵ줿(key,value) 1ĤΤߤϢȤ
 *
 *  Ȥ򡤻ꤵ줿 1ĤǤϢˤޤ
 *  
 * @param   key Ϣꤹ륭ʸ
 * @param   val Ϣꤹʸ 
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign( const char *key, const tstring &val )
{
    asarrdef_tstring el[] = { {key,val.cstr()},{NULL,NULL} };
    return this->assign(el);
}

/**
 * @brief  ꤵ줿(key,value) 1ĤΤߤϢȤ
 *
 *  Ȥ򡤻ꤵ줿 1ĤǤϢˤޤ<br>
 *  ΥдؿǤϡꤷʸprintf()ؿƱͤΥեޥåȤ
 *  ѰǥåȤǤޤ.
 * 
 * @param   key Ϣꤹ륭ʸ
 * @param   fmt ꤹʸΤΥեޥåȻ
 * @param   ... fmtбĹγǥǡ
 * 
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assignf( const char *key, 
					   const char *fmt, ... )
{
    va_list ap;
    va_start(ap,fmt);
    try {
	this->vassignf(key,fmt,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vassignf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿(key,value) 1ĤΤߤϢȤ
 *
 *  Ȥ򡤻ꤵ줿 1ĤǤϢˤޤ<br>
 *  ΥдؿǤϡꤷʸprintf()ؿƱͤΥեޥåȤ
 *  ѰǥåȤǤޤ.
 *
 * @param   key Ϣꤹ륭ʸ
 * @param   fmt ꤹʸΤΥեޥåȻ
 * @param   ap fmtбĹΥꥹ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::vassignf( const char *key,
					    const char *fmt, va_list ap )
{
    tstring buf;

    if ( fmt == NULL ) return this->assign(key,fmt);

    buf.vprintf(fmt,ap);
    this->assign(key,buf.cstr());

    return *this;
}

/**
 * @brief  ꤵ줿ʣϢǤ򼫿Ȥ
 *
 *  ꤵ줿ʣϢǤ򼫿Ȥޤ<br>
 *  Ĺνü NULL ǽüƤɬפޤ
 *
 * @param   key0 Ϣꤹ륭ʸ
 * @param   key1 Ϣꤹ륭ʸ
 * @param   val0 Ϣꤹ륭ʸ
 * @param   ... ,ͤȤʤʸβĹγǥǡ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign( const char *key0, const char *val0,
					  const char *key1, ... )
{
    va_list ap;
    va_start(ap,key1);
    try {
	this->vassign(key0,val0,key1,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vassign() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿ʣϢǤ򼫿Ȥ
 *
 *  ꤵ줿ʣϢǤ򼫿Ȥޤ<br>
 *  Ĺνü NULL ǽüƤɬפޤ
 *
 * @param   key0 Ϣꤹ륭ʸ
 * @param   val0 Ϣꤹ륭ʸ
 * @param   ap ,ͤȤʤʸβĹγǥǡ
 * 
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::vassign( const char *key0, const char *val0,
					   const char *key1, va_list ap )
{
    /* ȤƤ key, val Ƥ⤤褦ˤ */
    if ( key0 != NULL ) { 
	size_t i, org_len = this->length();
	/* ޤǸɲä */
	this->value_rec.append((val0 == NULL) ? "" : val0, 1);
	this->key_rec.append(key0, 1);
	if ( key1 != NULL ) {
	    const char *val1 = va_arg(ap,char *);
	    this->value_rec.append((val1 == NULL) ? "" : val1, 1);
	    this->key_rec.append(key1, 1);
	    while ( 1 ) {
		const char *keyx = va_arg(ap,char *);
		const char *valx;
		if ( keyx == NULL ) break;
		valx = va_arg(ap,char *);
		this->value_rec.append((valx == NULL) ? "" : valx, 1);
		this->key_rec.append(keyx, 1);
	    }
	} 
	/* ΤĤõ */
	this->value_rec.erase(0, org_len);
	this->key_rec.erase(0, org_len);
	/* ǥåϤϤ */
	this->index_rec.init();
	for ( i=0 ; i < this->key_rec.length() ; ) {
	    if ( this->index_rec.index(this->key_rec.cstr(i),0) < 0 ) {
		this->index_rec.append(this->key_rec.cstr(i),i);
		i++;
	    }
	    else {
		err_report1(__FUNCTION__,"WARNING","cannot append key '%s'",
			    this->key_rec.cstr(i));
		this->value_rec.erase(i, 1);
		this->key_rec.erase(i, 1);
	    }
	} 
    } 
    else {
	this->erase();
    } 
    return *this;
}

/**
 * @brief  ꤵ줿ʣʸϢΥȤƼȤ
 *
 *  ꤵ줿ʣʸ򼫿ȤϢΥꤷޤ<br>
 *  Ѱνü NULL ǤʤФʤޤ
 * 
 * @param   key0 ʸ
 * @param   ... ʸβĹγǥǡ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign_keys( const char *key0, ... )
{
    va_list ap;
    va_start(ap,key0);
    try {
	this->vassign_keys(key0,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vassign_keys() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿ʣʸϢΥȤƼȤ
 *
 *  ꤵ줿ʣʸ򼫿ȤϢΥꤷޤ<br>
 *  Ѱνü NULL ǤʤФʤޤ
 * 
 * @param   key0 ʸ
 * @param   ap ʸβĹΥꥹ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::vassign_keys( const char *key0, va_list ap )
{
    tarray_tstring tmp_keys;
    if ( key0 != NULL ) {
	tmp_keys.append(key0,1);
	while ( 1 ) {
	    const char *keyx = va_arg(ap,char *);
	    if ( keyx == NULL ) break;
	    tmp_keys.append(keyx,1);
	}
    }
    this->assign_keys(tmp_keys);
    return *this;
}

/**
 * @brief  ꤵ줿ʸϢΥȤƼȤ
 *
 *  ꤵ줿ʣʸ keys 򼫿ȤϢΥꤷޤ<br>
 *  νü NULL ǤʤФʤޤ
 * 
 * @param   keys ʸꤹʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign_keys( const char *const *keys )
{
    tarray_tstring tmp_keys;
    if ( this->key_rec.cstrarray() == keys ) return *this;
    tmp_keys.assign(keys);
    this->assign_keys(tmp_keys);
    return *this;
}

/**
 * @brief  ꤵ줿ʸϢΥȤƼȤ
 *
 *  ꤵ줿ʣʸ keys 򼫿ȤϢΥꤷޤ<br>
 *
 * @param   keys ʸꤹʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign_keys( const tarray_tstring &keys )
{
    size_t i;

    if ( &(this->key_rec) == &keys ) return *this;

    this->key_rec.erase();
    this->index_rec.init();
    for ( i=0 ; i < keys.length() ; i++ ) {
	/* Ʊ̾硤name, name(1), name(2), ... Τ褦ˤ */
	int ix=0;
	tstring r_key;
	r_key.assign(keys.cstr(i));
	while ( 0 <= this->index_rec.index(r_key.cstr(),0) ) {
	    ix ++;
	    r_key.printf("%s(%d)",keys.cstr(i),ix);
	}
	this->key_rec.append(r_key.cstr(), 1);
	this->index_rec.append(r_key.cstr(), i);
    }
    this->value_rec.resize(this->key_rec.length());

    return *this;
}

/**
 * @brief  ʸʬ䤷ơ (¿ǽ)
 *
 *  ʸʬ䤷ơꤷޤ<br>
 *  delims ˤϡ" \t" Τ褦ñʸꥹȤ˲äɽѤ
 *  "[A-Z]" 뤤 "[^A-Z]" Τ褦ʻ꤬ǽǤ<br>
 *  ơ̤ΡʸפǰϤޤ줿ʸʬ䤷ʤ硤
 *  quotations ˡʸפꤷޤ
 * 
 * @param   src_str ʬоݤʸ
 * @param   delims ڤʸޤʸ
 * @param   zero_str Ĺ0η̤ʸɤΥե饰
 * @param   quotations ơ󡦥֥饱åʸޤʸ
 * @param   escape ʸ
 * @param   rm_escape ʸ뤫ɤΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::split_keys( const char *src_str, 
					 const char *delims, 
					 bool zero_str, const char *quotations,
					 int escape, bool rm_escape )
{
    tarray_tstring tmp_keys;

    tmp_keys.split(src_str,delims,zero_str,quotations,escape,rm_escape);
    this->assign_keys(tmp_keys);

    return *this;
}

/**
 * @brief  ʸʬ䤷ơ
 *
 *  ʸʬ䤷ơꤷޤ<br>
 *  delims ˤϡ" \t" Τ褦ñʸꥹȤ˲äɽѤ
 *  "[A-Z]" 뤤 "[^A-Z]" Τ褦ʻ꤬ǽǤ
 *
 * @param   src_str ʬоݤʸ
 * @param   delims ڤʸޤʸ
 * @param   zero_str Ĺ0η̤ʸɤΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::split_keys( const char *src_str, 
					      const char *delims,
					      bool zero_str )
{
    return this->split_keys(src_str,delims,zero_str,NULL,'\0',false);
}


/**
 * @brief  ʸʬ䤷ơ (¿ǽ)
 *
 *  ʸʬ䤷ơꤷޤ<br>
 *  delims ˤϡ" \t" Τ褦ñʸꥹȤ˲äɽѤ
 *  "[A-Z]" 뤤 "[^A-Z]" Τ褦ʻ꤬ǽǤ<br>
 *  ơ̤ΡʸפǰϤޤ줿ʸʬ䤷ʤ硤
 *  quotations ˡʸפꤷޤ
 * 
 * @param   src_str ʬоݤʸ
 * @param   delims ڤʸޤʸ
 * @param   zero_str Ĺ0η̤ʸɤΥե饰
 * @param   quotations ơ󡦥֥饱åʸޤʸ
 * @param   escape ʸ
 * @param   rm_escape ʸ뤫ɤΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::split_keys( const tstring &src_str, 
					 const char *delims, 
					 bool zero_str, const char *quotations,
					 int escape, bool rm_escape )
{
    tarray_tstring tmp_keys;

    tmp_keys.split(src_str,delims,zero_str,quotations,escape,rm_escape);
    this->assign_keys(tmp_keys);

    return *this;
}

/**
 * @brief  ʸʬ䤷ơ
 *
 *  ʸʬ䤷ơꤷޤ
 *  delims ˤϡ" \t" Τ褦ñʸꥹȤ˲äɽѤ 
 *  "[A-Z]" 뤤 "[^A-Z]" Τ褦ʻ꤬ǽǤ
 * 
 * @param   src_str ʬоݤʸ
 * @param   delims ڤʸޤʸ
 * @param   zero_str Ĺ0η̤ʸɤΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::split_keys( const tstring &src_str, 
					      const char *delims,
					      bool zero_str )
{
    return this->split_keys(src_str,delims,zero_str,NULL,'\0',false);
}

/**
 * @brief  ꤵ줿ʣʸϢʸȤƼȤ
 *
 *  ꤵ줿ʣʸ򡤼ȤϢͤꤷޤ<br>
 *  Ѱνü NULL ǤʤФʤޤ
 *
 * @param   value0 ʸ
 * @param   ... ʸβĹγǥǡ 
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign_values( const char *value0, ... )
{
    va_list ap;
    va_start(ap,value0);
    try {
	this->vassign_values(value0,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vassign_values() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿ʣʸϢʸȤƼȤ
 *
 *  ꤵ줿ʣʸ,ȤϢͤꤷޤ<br>
 *  Ѱνü NULL ǤʤФʤޤ
 *
 * @param   value0 ʸ
 * @param   ap ʸβĹΥꥹ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::vassign_values( const char *value0, va_list ap )
{
    tarray_tstring tmp_values;
    if ( value0 != NULL ) {
	tmp_values.append(value0,1);
	while ( 1 ) {
	    const char *valuex = va_arg(ap,char *);
	    if ( valuex == NULL ) break;
	    tmp_values.append(valuex,1);
	}
    }
    this->assign_values(tmp_values);
    return *this;
}

/**
 * @brief  ꤵ줿ʸϢʸȤƼȤ
 *
 *  ꤵ줿ʣʸ򡤼ȤϢͤꤷޤ<br>
 *  νü NULL ǤʤФʤޤ
 *
 * @param   values ʸꤹʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign_values( const char *const *values )
{
    if ( this->value_rec.cstrarray() == values ) return *this;
    this->value_rec.assign(values);
    this->value_rec.resize(this->key_rec.length());
    return *this;
}

/**
 * @brief  ꤵ줿ʸϢʸȤƼȤ
 *
 *  ꤵ줿ʣʸ򡤼ȤϢͤꤷޤ
 *
 * @param   values ʸꤹʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::assign_values( const tarray_tstring &values )
{
    if ( &(this->value_rec) == &values ) return *this;
    this->value_rec.assign(values);
    this->value_rec.resize(this->key_rec.length());
    return *this;
}

/**
 * @brief  ʸʬ䤷ơͤ (¿ǽ)
 *
 *  ʸʬ䤷ơͤꤷޤ
 *  delims ˤϡ" \t" Τ褦ñʸꥹȤ˲äɽѤ
 *  "[A-Z]" 뤤 "[^A-Z]" Τ褦ʻ꤬ǽǤ<br>
 *  ơ̤ΡʸפǰϤޤ줿ʸʬ䤷ʤ硤
 *  quotations ˡʸפꤷޤ
 *
 * @param   src_str ʬоȤʸ
 * @param   delims ڤʸޤʸ
 * @param   zero_str Ĺ0ζڤ̤ʸɤΥե饰
 * @param   quotations ơ󡦥֥饱åʸޤʸ
 * @param   escape ʸ
 * @param   rm_escape ʸ뤫ɤΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::split_values( const char *src_str, 
					 const char *delims, 
					 bool zero_str, const char *quotations,
					 int escape, bool rm_escape )
{
    this->value_rec.split(src_str,delims,zero_str,quotations,escape,rm_escape);
    this->value_rec.resize(this->key_rec.length());
    return *this;
}

/**
 * @brief  ʸʬ䤷ơͤ
 *
 *  ʸʬ䤷ơͤꤷޤ
 *  delims ˤϡ" \t" Τ褦ñʸꥹȤ˲äɽѤ
 *  "[A-Z]" 뤤 "[^A-Z]" Τ褦ʻ꤬ǽǤ
 * 
 * @param   src_str ʬоȤʸ
 * @param   delims ڤʸޤʸ
 * @param   zero_str Ĺ0ζڤ̤ʸɤΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::split_values( const char *src_str, 
						const char *delims,
						bool zero_str )
{
    return this->split_values(src_str,delims,zero_str,NULL,'\0',false);
}

/**
 * @brief  ʸʬ䤷ơͤ (¿ǽ)
 *
 *  ʸʬ䤷ơͤꤷޤ
 *  delims ˤϡ" \t" Τ褦ñʸꥹȤ˲äɽѤ
 *  "[A-Z]" 뤤 "[^A-Z]" Τ褦ʻ꤬ǽǤ<br>
 *  ơ̤ΡʸפǰϤޤ줿ʸʬ䤷ʤ硤
 *  quotations ˡʸפꤷޤ
 * 
 * @param   src_str ʬоȤʸ
 * @param   delims ڤʸޤʸ
 * @param   zero_str Ĺ0ζڤ̤ʸɤΥե饰
 * @param   quotations ơ󡦥֥饱åʸޤʸ
 * @param   escape ʸ
 * @param   rm_escape ʸ뤫ɤΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::split_values( const tstring &src_str, 
					 const char *delims, 
					 bool zero_str, const char *quotations,
					 int escape, bool rm_escape )
{
    this->value_rec.split(src_str,delims,zero_str,quotations,escape,rm_escape);
    this->value_rec.resize(this->key_rec.length());
    return *this;
}

/**
 * @brief  ʸʬ䤷ơͤ
 *
 *  ʸʬ䤷,ͤꤷޤ.
 *  delims ˤϡ" \t" Τ褦ñʸꥹȤ˲äɽѤ
 *  "[A-Z]" 뤤 "[^A-Z]" Τ褦ʻ꤬ǽǤ
 * 
 * @param   src_str ʬоȤʸ
 * @param   delims ڤʸޤʸ
 * @param   zero_str Ĺ0ζڤ̤ʸɤΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::split_values( const tstring &src_str, 
						const char *delims,
						bool zero_str )
{
    return this->split_values(src_str,delims,zero_str,NULL,'\0',false);
}

/**
 * @brief  ꤵ줿Ϣ(asarray_tstring)򡤼ȤϢɲ
 *
 *  ȤϢˡꤵ줿ʣǤɲäޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   src ȤʤǤasarray_tstringΥ֥
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::append( const asarray_tstring &src )
{
    size_t i;
    if ( &src == this ) {
	/* ʣΤǼȤɲä뤳ȤϤǤʤ */
	err_report(__FUNCTION__,"WARNING", "cannot append self-object");
	goto quit;
    }
    for ( i=0 ; i < src.length() ; i++ ) {
	this->append(src.key(i),src.cstr(i));
    }
 quit:
    return *this;
}

/**
 * @brief  ꤵ줿Ϣ(asarrdef_tstring)򡤼ȤϢɲ
 *
 *  ȤϢˡꤵ줿ʣǤɲäޤ<br>
 *  elements  {NULL,NULL} ǽüƤɬפޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   elements[] Ȥʤasarrdef_tstring
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::append( const asarrdef_tstring elements[] )
{
    if ( elements != NULL ) {
	size_t i;
	for ( i=0 ; elements[i].key != NULL ; i++ ) {
	    this->append(elements[i].key,elements[i].value);
	}
    }
    return *this;
}

/**
 * @brief  ꤵ줿Ϣ(asarrdef_tstring)nĤ򡤼ȤϢɲ
 *
 *  ȤϢˡelements Ƭ nĤǤɲäޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   elements[] Ȥʤasarrdef_tstring
 * @param   n elementsθĿ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::append( const asarrdef_tstring elements[],
					  size_t n )
{
    if ( 0 < n && elements != NULL ) {
	size_t i;
	for ( i=0 ; i < n && elements[i].key != NULL ; i++ ) {
	    this->append(elements[i].key,elements[i].value);
	}
    }
    return *this;
}

/**
 * @brief  ꤵ줿1(const char *)򡤼ȤϢɲ
 *
 *  ȤϢˡꤵ줿 1ĤǤɲäޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   key Ϣɲä륭ʸ
 * @param   val Ϣɲäʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::append( const char *key, const char *val )
{
    if ( key != NULL ) {
	if ( this->index_rec.index(key,0) < 0 ) {
	    if ( val == NULL ) val = "";
	    this->value_rec.append(val,1);
	    this->key_rec.append(key,1);
	    this->index_rec.append(key,this->key_rec.length()-1);
	}
	else {
	    err_report1(__FUNCTION__,"WARNING","cannot append key '%s'",key);
	}
    }
    return *this;
}

/**
 * @brief  ꤵ줿1(tstring)򡤼ȤϢɲ
 *
 *  ȤϢˡꤵ줿 1ĤǤɲäޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   key Ϣɲä륭ʸ
 * @param   val Ϣɲäʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::append( const char *key, const tstring &val )
{
    return this->append(key, val.cstr());
}

/**
 * @brief  ꤵ줿1(printf()εˡǻ)򡤼ȤϢɲ
 *
 *  ȤϢˡꤵ줿1ĤǤɲäޤ<br>
 *  ΥдؿǤϡꤷʸ printf() ؿƱͤΥեޥå
 *  ȲѰǥåȤǤޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   key Ϣɲä륭ʸ
 * @param   fmt ɲäʸΤΥեޥåȻ
 * @param   ... fmtбѰγǥǡ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::appendf( const char *key, 
					   const char *fmt, ... )
{
    va_list ap;
    va_start(ap,fmt);
    try {
	this->vappendf(key,fmt,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vappendf() failed");
    }
    va_end(ap);
    return *this;
}


/**
 * @brief  ꤵ줿1(printf()εˡǻ)򡤼ȤϢɲ
 *
 *  ȤϢˡꤵ줿1ĤǤɲäޤ<br>
 *  ΥдؿǤϡꤷʸ printf() ؿƱͤΥեޥå
 *  ȲѰǥåȤǤޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   key Ϣɲä륭ʸ
 * @param   fmt ɲäʸΤΥեޥåȻ
 * @param   ap fmtбѰΥꥹ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::vappendf( const char *key,
					    const char *fmt, va_list ap )
{
    tstring buf;

    if ( fmt == NULL ) return this->append(key,fmt);

    buf.vprintf(fmt,ap);
    this->append(key,buf.cstr());

    return *this;
}

/**
 * @brief  ꤵ줿ʣǤ򡤼ȤϢɲ
 *
 *  ȤϢˡꤵ줿ʣǤɲäޤ<br>
 *  ĹǥǡκǸ NULL Ǥɬפޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 *
 * @param   key0 Ϣɲä륭ʸ
 * @param   val0 Ϣɲäʸ
 * @param   key1 Ϣɲä륭ʸ
 * @param   ... ,ͤȤʤʸβĹγǥǡ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::append( const char *key0, const char *val0,
					  const char *key1, ... )
{
    va_list ap;
    va_start(ap,key1);
    try {
	this->vappend(key0,val0,key1,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vappend() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿ʣǤ򡤼ȤϢɲ
 *
 *  ȤϢˡꤵ줿ʣǤɲäޤ<br>
 *  ĹΥꥹȤνüΥǡNULLǤɬפޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 *
 * @param   key0 Ϣɲä륭ʸ
 * @param   val0 Ϣɲäʸ
 * @param   key1 Ϣɲä륭ʸ
 * @param   ap ,ͤȤʤʸβĹΥꥹ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::vappend( const char *key0, const char *val0,
					   const char *key1, va_list ap )
{
    this->append(key0,val0);
    if ( key0 != NULL && key1 != NULL ) {
	const char *val1 = va_arg(ap,char *);
	this->append(key1,val1);
	while ( 1 ) {
	    const char *keyx = va_arg(ap,char *);
	    const char *valx;
	    if ( keyx == NULL ) break;
	    valx = va_arg(ap,const char *);
	    this->append(keyx,valx);
	}
    }
    return *this;
}

/**
 * @brief  ꤵ줿Ϣ(asarray_tstring)򡤼ȤϢ
 *
 *  ȤϢΥ key ǰ֤ˡꤵ줿ʣǤ
 *  ޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   key ֤ˤϢΥʸ
 * @param   src ȤʤǤasarray_tstring饹Υ֥
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::insert( const char *key,
					  const asarray_tstring &src )
{
    size_t i;
    if ( &src == this ) {
	/* ʣΤǼȤ򥤥󥵡Ȥ뤳ȤϤǤʤ */
	err_report(__FUNCTION__,"WARNING", "cannot insert self-object");
	goto quit;
    }
    for ( i=0 ; i < src.length() ; i++ ) {
	this->insert(key,src.key(i),src.cstr(i));
    }
 quit:
    return *this;
}


/**
 * @brief  ꤵ줿Ϣ(asarrdef_tstring)򡤼ȤϢ
 *
 *  ȤϢΥ key ǰ֤ˡꤵ줿ʣǤ
 *  ޤ<br>
 *  elements κǸǤϡ{NULL,NULL} Ǥɬפޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 *
 * @param   key ֤ˤϢΥʸ
 * @param   elements[] ȤʤǤasarrdef_tstring
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::insert( const char *key, 
					  const asarrdef_tstring elements[] )
{
    if ( key != NULL && elements != NULL ) {
	size_t i;
	if ( this->index_rec.index(key,0) < 0 ) {
	    err_report1(__FUNCTION__,"WARNING","unknown key '%s'",key);
	    goto quit;
	}
	for ( i=0 ; elements[i].key != NULL ; i++ ) {
	    this->insert(key,elements[i].key,elements[i].value);
	}
    }
 quit:
    return *this;
}

/**
 * @brief  ꤵ줿Ϣ(asarrdef_tstring)nĤ򡤼ȤϢ
 *
 *  ȤϢΥ key ǰ֤ˡelements Ƭ nĤǤ
 *  ޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   key ֤ˤϢΥʸ
 * @param   elements[] ȤʤǤasarrdef_tstring
 * @param   n elementsθĿ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::insert( const char *key, 
					  const asarrdef_tstring elements[],
					  size_t n )
{
    if ( key != NULL && 0 < n && elements != NULL ) {
	size_t i;
	if ( this->index_rec.index(key,0) < 0 ) {
	    err_report1(__FUNCTION__,"WARNING","unknown key '%s'",key);
	    goto quit;
	}
	for ( i=0 ; i < n && elements[i].key != NULL ; i++ ) {
	    this->insert(key,elements[i].key,elements[i].value);
	}
    }
 quit:
    return *this;
}

/**
 * @brief  ꤵ줿1(const char *)򡤼ȤϢ
 *
 *  ȤϢΥ key ǰ֤ˡꤵ줿 1ĤǤ
 *  ޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   key ֤ˤϿ̤ϢΥʸ
 * @param   newkey Ϣ륭ʸ
 * @param   newval Ϣʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::insert( const char *key,
				       const char *newkey, const char *newval )
{
    if ( key != NULL && newkey != NULL ) {
	size_t i;
	ssize_t idx = this->index_rec.index(key,0);
	if ( idx < 0 ) {
	    err_report1(__FUNCTION__,"WARNING","unknown key '%s'",key);
	    goto quit;
	}
	if ( 0 <= this->index_rec.index(newkey,0) ) {
	    err_report1(__FUNCTION__,"WARNING","cannot insert key '%s'",newkey);
	    goto quit;
	}
	if ( newval == NULL ) newval = "";
	this->value_rec.insert(idx,newval,1);
	this->key_rec.insert(idx,newkey,1);
	this->index_rec.append(newkey,idx);
	for ( i=idx+1 ; i < this->key_rec.length() ; i++ ) {
	    this->index_rec.update(this->key_rec.cstr(i),i-1,i);
	}
    }
 quit:
    return *this;
}

/**
 * @brief  ꤵ줿1(tstring)򡤼ȤϢ
 *
 *  ȤϢΥ key ǰ֤ˡꤵ줿 1ĤǤ
 *  ޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   key ֤ˤϿ̤ϢΥʸ
 * @param   newkey Ϣ륭ʸ
 * @param   newval Ϣʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::insert( const char *key,
				    const char *newkey, const tstring &newval )
{
    return this->insert(key, newkey, newval.cstr());
}

/**
 * @brief  ꤵ줿1(printf()εˡǻ)򡤼ȤϢ
 *
 *  ȤϢΥ key ǰ֤ˡꤵ줿 1ĤǤ
 *  ޤ<br>
 *  ΥдؿǤϡꤷʸ printf() ؿƱͤΥեޥå
 *  ȲѰǥåȤǤޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   key ֤ˤϿ̤ϢΥʸ
 * @param   newkey Ϣ륭ʸ
 * @param   fmt ʸΤΥեޥåȻ
 * @param   ... fmtбĹγǥǡ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::insertf( const char *key,
					   const char *newkey, 
					   const char *fmt, ... )
{
    va_list ap;
    va_start(ap,fmt);
    try {
	this->vinsertf(key,newkey,fmt,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vinsertf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿1(printf()εˡǻ)򡤼ȤϢ
 *
 *  ȤϢΥ key ǰ֤ˡꤵ줿 1ĤǤ
 *  ޤ<br>
 *  ΥдؿǤϡꤷʸ printf() ؿƱͤΥեޥå
 *  ȲѰǥåȤǤޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 * 
 * @param   key ֤ˤ뼫ȤϢΥʸ
 * @param   newkey Ϣ륭ʸ
 * @param   fmt ʸΤΥեޥåȻ
 * @param   ap fmtбĹγǥǡ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::vinsertf( const char *key,
					    const char *newkey,
					    const char *fmt, va_list ap )
{
    tstring buf;

    if ( fmt == NULL ) return this->insert(key,newkey,fmt);

    buf.vprintf(fmt,ap);
    this->insert(key,newkey,buf.cstr());

    return *this;
}

/**
 * @brief  ꤵ줿ʣǤ򡤼ȤϢ
 *
 *  ȤϢΥ key ǰ֤ˡꤵ줿ʣǤ
 *  ޤ<br>
 *  ĹκǸǤ NULL Ǥɬפޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 *
 * @param   key ֤ˤϢΥʸ
 * @param   key0 Ϣ륭ʸ
 * @param   val0 Ϣʸ
 * @param   key1 Ϣ륭ʸ
 * @param   ... ,ͤȤʤʸβĹγǥǡ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::insert( const char *key,
					  const char *key0, const char *val0,
					  const char *key1, ... )
{
    va_list ap;
    va_start(ap,key1);
    try {
	this->vinsert(key,key0,val0,key1,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vinsert() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿ʣǤ򡤼ȤϢ
 *
 *  ȤϢΥ key ǰ֤ˡꤵ줿ʣǤ
 *  ޤ<br>
 *  ĹκǸǤ NULL Ǥɬפޤ<br>
 *  ʣ硤¹Ի˷ٹ𤬽Ϥ졤Ԥޤ
 *
 * @param   key ֤ˤϢΥʸ
 * @param   key0 Ϣ륭ʸ
 * @param   val0 Ϣʸ
 * @param   key1 Ϣ륭ʸ
 * @param   ap ,ͤȤʤʸβĹΥꥹ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::vinsert( const char *key,
					   const char *key0, const char *val0,
					   const char *key1, va_list ap )
{
    if ( key == NULL ) goto quit;
    if ( this->index_rec.index(key,0) < 0 ) {
	err_report1(__FUNCTION__,"WARNING","unknown key '%s'",key);
	goto quit;
    }
    this->insert(key,key0,val0);
    if ( key0 != NULL && key1 != NULL ) {
	const char *val1 = va_arg(ap,char *);
	this->insert(key,key1,val1);
	while ( 1 ) {
	    const char *keyx = va_arg(ap,char *);
	    const char *valx;
	    if ( keyx == NULL ) break;
	    valx = va_arg(ap,const char *);
	    this->insert(key,keyx,valx);
	}
    }
 quit:
    return *this;
}

/**
 * @brief  Ǥκ
 *
 *  ȤϢΤ٤ƤǤޤ
 * 
 * @return  Ȥλ
 * @throw   ХåեγݤԤ
 */
asarray_tstring &asarray_tstring::erase()
{
    this->index_rec.init();
    this->key_rec.erase();
    this->value_rec.erase();
    return *this;
}

/**
 * @brief  Ǥκ
 *
 *  ȤϢ key ǻꤵ줿бǤ num_elements Ĥ
 *  Ǥõޤ<br>
 *  õ줿ʬĹûʤޤ
 * 
 * @param   key ʸ
 * @param   num_elements ǤθĿ (ά 1)
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::erase( const char *key, size_t num_elements )
{
    size_t i, maxels;
    ssize_t idx;
    if ( key == NULL ) goto quit;
    idx = this->index_rec.index(key,0);
    if ( idx < 0 ) {
	err_report1(__FUNCTION__,"WARNING","unknown key '%s'",key);
	goto quit;
    }
    maxels = this->key_rec.length() - idx;
    if ( maxels < num_elements ) num_elements = maxels;

    for ( i=idx ; i < idx + num_elements ; i++ ) {
	this->index_rec.erase(this->key_rec.cstr(i),i);
    }
    for ( ; i < this->key_rec.length() ; i++ ) {
	this->index_rec.update(this->key_rec.cstr(i),i,i-num_elements);
    }

    this->key_rec.erase(idx,num_elements);
    this->value_rec.erase(idx,num_elements);

 quit:
    return *this;
}

/**
 * @brief  2ĤΥ֥ȴ֤ǤƤΥå
 *
 *  ֥sobj ƤȼȤƤȤؤޤ
 * 
 * @param   sobj Ƥؤ asarray_tstring 饹Υ֥
 * @return  Ȥλ
 */
asarray_tstring &asarray_tstring::swap( asarray_tstring &sobj )
{
    if ( &sobj == this ) return *this;
    this->key_rec.swap( sobj.key_rec );
    this->value_rec.swap( sobj.value_rec );
    this->index_rec.swap( sobj.index_rec );
    this->regex_rec.swap( sobj.regex_rec );
    return *this;
}

/**
 * @brief  ʸѹ
 *
 *  ȤϢΥʸ org_key  new_key ǻꤵ줿ʸѹ
 *  ޤ<br>
 *  org_key ¸ߤʤ䡤new_key ʣ륭ʸäϷٹ
 *  Ϥޤ
 * 
 * @param   org_key Υʸ
 * @param   new_key ѹΥʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::rename_a_key( const char *org_key, 
						const char *new_key )
{
    ssize_t idx;
    idx = this->index_rec.index(org_key,0);
    if ( idx < 0 ) {
	err_report1(__FUNCTION__,"WARNING","unknown key '%s'",org_key);
	goto quit;
    }
    if ( new_key == NULL || this->key_rec.at(idx).compare(new_key) == 0 )
	goto quit;
    if ( 0 <= this->index_rec.index(new_key,0) ) {
	err_report1(__FUNCTION__,"WARNING",
		    "already used: key '%s'. Not renamed.",new_key);
	goto quit;
    }
    this->index_rec.erase(org_key, idx);
    this->index_rec.append(new_key, idx);
    this->key_rec.at(idx).assign(new_key);
 quit:
    return *this;
}

/* */

/**
 * @brief  ǤˤĤƤñʸ󸡺ִ
 *
 *  ȤϢǤʸˤĤơʸκ¦ʸ org_str 
 *  Ĥäʸ new_str ֤ޤ
 * 
 * @param   org_str Фʸ
 * @param   new_str ִθȤʤʸ
 * @param   all ִΥե饰(άfalse)
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::strreplace( const char *org_str,
					      const char *new_str, bool all )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).strreplace(org_str, new_str, all);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤñʸ󸡺ִ
 *
 *  ȤϢǤʸˤĤơʸκ¦ʸ org_str 
 *  Ĥäʸ new_str ֤ޤ
 * 
 * @param   org_str Фʸ
 * @param   new_str ִθȤʤʸ
 * @param   all ִΥե饰(άfalse)
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::strreplace( const tstring &org_str,
					      const char *new_str, bool all )
{
    return this->strreplace(org_str.cstr(), new_str, all);
}

/**
 * @brief  ǤˤĤƤñʸ󸡺ִ
 *
 *  ȤϢǤʸˤĤơʸκ¦ʸ org_str 
 *  Ĥäʸ new_str ֤ޤ
 * 
 * @param   org_str Фʸ
 * @param   new_str ִθȤʤʸ
 * @param   all ִΥե饰(άfalse)
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::strreplace( const char *org_str,
					     const tstring &new_str, bool all )
{
    return this->strreplace(org_str, new_str.cstr(), all);
}

/**
 * @brief  ǤˤĤƤñʸ󸡺ִ
 *
 *  ȤϢǤʸˤĤơʸκ¦ʸ org_str 
 *  Ĥäʸ new_str ֤ޤ
 * 
 * @param   org_str Фʸ
 * @param   new_str ִθȤʤʸ
 * @param   all ִΥե饰(άfalse)
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::strreplace( const tstring &org_str,
					     const tstring &new_str, bool all )
{
    return this->strreplace(org_str.cstr(), new_str.cstr(), all);
}

/**
 * @brief  ǤˤĤƤʸν
 *
 *  ȤǤʸʸޤ
 * 
 * @return  Ȥλ
 * @throw   ꤵ줿ֹ椬ʾ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::chop()
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).chop();
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤαüβʸν
 *
 *  ȤϢǤʸαüβʸޤ
 * 
 * @param   rs ʸ (ά)
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::chomp( const char *rs )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).chomp(rs);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤαüβʸν
 *
 *  ȤϢǤʸαüβʸޤ
 * 
 * @param   rs ʸ (ά)
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::chomp( const tstring &rs )
{
    return this->chomp(rs.cstr());
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤʸǤˤĤơʸξüˤǤʸ(side_spaces
 *  ǻ)ޤ<br>
 *  side_spacesά硤" \t\n\r\f\v" ꤷΤȤߤʤޤ
 * 
 * @param   side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::trim( const char *side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).trim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤʸǤˤĤơʸξüˤǤʸ(side_spaces
 *  ǻ)ޤ
 * 
 * @param   side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::trim( const tstring &side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).trim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤƤǤʸξüˤǤʸޤ
 * 
 * @param   side_space оݤʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::trim( int side_space )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).trim(side_space);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤʸǤˤĤơʸüˤǤʸ(side_spaces
 *  ǻ)ޤ<br>
 *  side_spacesά硤" \t\n\r\f\v" ꤷΤȤߤʤޤ
 *
 * @param   side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::ltrim( const char *side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).ltrim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤʸǤˤĤơʸüˤǤʸ(side_spaces
 *  ǻ)ޤ<br>
 *
 * @param   side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::ltrim( const tstring &side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).ltrim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤƤǤʸκüˤǤʸޤ
 *
 * @param   side_space оݤʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::ltrim( int side_space )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).ltrim(side_space);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤʸǤˤĤơʸüˤǤʸ(side_spaces
 *  ǻ)ޤ<br>
 *  side_spacesά硤" \t\n\r\f\v" ꤷΤȤߤʤޤ
 *
 * @param   side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::rtrim( const char *side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).rtrim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤʸǤˤĤơʸüˤǤʸ(side_spaces
 *  ǻ)ޤ
 *
 * @param   side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::rtrim( const tstring &side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).rtrim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤƤǤʸαüˤǤʸޤ
 *
 * @param   side_space оݤʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::rtrim( int side_space )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).rtrim(side_space);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤʸǤˤĤơʸξüˤǤʸ(side_spaces
 *  ǻ)ޤ<br>
 *  side_spacesά硤" \t\n\r\f\v" ꤷΤȤߤʤޤ
 * 
 * @param   side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::strtrim( const char *side_spaces )
{
    return this->trim(side_spaces);
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤʸǤˤĤơʸξüˤǤʸ(side_spaces
 *  ǻ)ޤ
 * 
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::strtrim( const tstring &side_spaces )
{
    return this->trim(side_spaces);
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤƤǤʸξüˤǤʸޤ
 * 
 * @param   side_space оݤʸ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::strtrim( int side_space )
{
    return this->trim(side_space);
}

/**
 * @brief  ǤˤĤʸʸѴ
 *
 *  ȤϢǤΥե٥åȤʸʸѴޤ
 * 
 * @return  Ȥλ
 */
asarray_tstring &asarray_tstring::tolower()
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).tolower();
    }
    return *this;
}

/**
 * @brief  ǤˤĤƾʸʸѴ
 *
 *  ȤϢǤΥե٥åȤξʸʸѴޤ
 * 
 * @return  Ȥλ
 */
asarray_tstring &asarray_tstring::toupper()
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).toupper();
    }
    return *this;
}

/**
 * @brief  ǤˤĤƥʸ·ƶʸִ
 *
 *  ȤϢǤˤĤơʿʸ '\t' tab_width ͤ
 *  ·򤷤ƶʸִޤ
 * 
 * @param   tab_width ά8
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::expand_tabs( size_t tab_width )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).expand_tabs(tab_width);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƶʸ·ƥʸִ
 *
 *  ȤʸǤˤĤơ2ʸʾϢ³ʸ ' ' ٤Ƥ
 *  оݤˤꤵ줿 tab_width Ƿ· '\t' ִޤ
 * 
 * @param   tab_width ά8
 * @return  Ȥλ
 * @throws  Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::contract_spaces( size_t tab_width )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).contract_spaces(tab_width);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤϢǤʸpat ǻꤵ줿 POSIX ĥɽ
 *  ޥåʬʸ new_str ֤ޤ.
 * 
 * @param   pat ʸѥ(ɽ)
 * @param   new_str ִʸ
 * @param   all ִΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::regreplace( const char *pat, 
					      const char *new_str, bool all )
{
    size_t i;
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).regreplace(this->regex_rec, new_str, all);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤϢǤʸpat ǻꤵ줿 POSIX ĥɽ
 *  ޥåʬʸ new_str ֤ޤ.
 * 
 * @param   pat ʸѥ(ɽ)
 * @param   new_str ִʸ
 * @param   all ִΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::regreplace( const tstring &pat, 
					      const char *new_str, bool all )
{
    size_t i;
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).regreplace(this->regex_rec, new_str, all);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤϢǤʸpat ǻꤵ줿 POSIX ĥɽ
 *  ޥåʬʸ new_str ֤ޤ.
 * 
 * @param   pat tregexΥѥѤߥ֥
 * @param   new_str ִʸ
 * @param   all ִΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::regreplace( const tregex &pat, 
					      const char *new_str, bool all )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).regreplace(pat,new_str,all);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤϢǤʸpat ǻꤵ줿 POSIX ĥɽ
 *  ޥåʬʸ new_str ֤ޤ.
 * 
 * @param   pat ʸѥ
 * @param   new_str ִʸ
 * @param   all ִΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::regreplace( const char *pat, 
					     const tstring &new_str, bool all )
{
    return this->regreplace(pat, new_str.cstr(), all);
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤϢǤʸpat ǻꤵ줿 POSIX ĥɽ
 *  ޥåʬʸ new_str ֤ޤ.
 * 
 * @param   pat ʸѥ
 * @param   new_str ִʸ
 * @param   all ִΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::regreplace( const tstring &pat, 
					     const tstring &new_str, bool all )
{
    return this->regreplace(pat, new_str.cstr(), all);
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤϢǤʸpat ǻꤵ줿 POSIX ĥɽ
 *  ޥåʬʸ new_str ֤ޤ.
 * 
 * @param   pat tregex饹ΥѥѤߥ֥
 * @param   new_str ִʸ
 * @param   all ִΥե饰
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 */
asarray_tstring &asarray_tstring::regreplace( const tregex &pat, 
					     const tstring &new_str, bool all )
{
    return this->regreplace(pat, new_str.cstr(), all);
}

/* */

/**
 * @brief  ϢʸФݥ (ɼ)
 *
 *  ȤϢʸΥݥ֤ޤ<br>
 *  ݥϡɬ NULL ǽüƤޤ
 * 
 * @return  ϢʸؤΥݥ
 */
const char *const *asarray_tstring::cstrarray() const
{
    return this->value_rec.cstrarray();
}

/**
 * @brief  ꤵ줿бʸ֤ (ɼ)
 *
 *  ꤵ줿бϢǤʸΥɥ쥹֤ޤ
 * 
 * @param   key ϢΤΥʸ
 * @return  ｪλ: ꤵ줿бʸΥɥ쥹<br>
 *          ͤʾ: NULL
 * @note    asarray_tstring::cstr() Ȥΰ㤤Ϥޤ
 */
const char *asarray_tstring::c_str( const char *key ) const
{
    ssize_t idx;
    if ( key == NULL ) return NULL;
    idx = this->index_rec.index(key,0);
    if ( idx < 0 ) return NULL;
    return this->value_rec.c_str(idx);
}

/**
 * @brief  ꤵ줿бʸ֤ (ɼ)
 *
 *  ꤵ줿бϢǤʸΥɥ쥹֤ޤ
 * 
 * @param   key ϢΤΥʸ
 * @return  ｪλ: ꤵ줿бʸΥɥ쥹.<br>
 *          ͤʾ: NULL
 * @note    asarray_tstring::c_str() Ȥΰ㤤Ϥޤ
 */
const char *asarray_tstring::cstr( const char *key ) const
{
    ssize_t idx;
    if ( key == NULL ) return NULL;
    idx = this->index_rec.index(key,0);
    if ( idx < 0 ) return NULL;
    return this->value_rec.cstr(idx);
}

/**
 * @brief  ꤵ줿бʸ֤ (ɼѡprintf()εˡ)
 *
 *  ꤵ줿бϢǤʸΥɥ쥹֤ޤ<br>
 *  Υдؿϻꤷʸ printf() ؿƱͤΥեޥåȤ
 *  ѰǥåȤǤޤ
 * 
 * @param   fmt ʸΤΥեޥåʸ
 * @param   ... fmtбĹγǥǡ
 * @return  ｪλ: ꤵ줿бʸΥɥ쥹<br>
 *          ͤʾ: NULL
 */
const char *asarray_tstring::cstrf( const char *fmt, ... ) const
{
    const char *ret;
    va_list ap;
    va_start(ap,fmt);
    try {
	ret = this->vcstrf(fmt,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vcstrf() failed");
    }
    va_end(ap);
    return ret;
}

/**
 * @brief  ꤵ줿бʸ֤ (ɼѡprintf()εˡ)
 *
 *  ꤵ줿бϢǤʸΥɥ쥹֤ޤ<br>
 *  Υдؿϻꤷʸ printf() ؿƱͤΥեޥåȤ
 *  ѰǥåȤǤޤ
 * 
 * @param   fmt ʸΤΥեޥåʸ
 * @param   ap fmtбĹΥꥹ
 * @return  ｪλ: ꤵ줿бʸΥɥ쥹<br>
 *          ͤʾ: NULL
 */
const char *asarray_tstring::vcstrf( const char *fmt, va_list ap ) const
{
    tstring buf;

    if ( fmt == NULL ) return this->cstr(fmt);

    buf.vprintf(fmt,ap);
    return this->cstr(buf.cstr());
}

/**
 * @brief  ꤵ줿ʸбǤλ(tstring)֤
 *
 * @param   key ϢΤΥʸ
 * @return  ꤵ줿бͤλ
 * @throw   ꤵ줿ʸNULLξ
 * @throw   Хåեγݤ˼Ԥ
 * @note    asarray_tstring::at() Ȥΰ㤤Ϥޤ
 */
tstring &asarray_tstring::element( const char *key )
{
    return this->at(key);
}

/**
 * @brief  ꤵ줿ʸбǤλ(tstring)֤
 *
 * @param   key ϢΤΥʸ
 * @return  ꤵ줿бͤλ
 * @throw   ꤵ줿ʸNULLξ
 * @throw   Хåեγݤ˼Ԥ
 * @note    asarray_tstring::element() Ȥΰ㤤Ϥޤ
 */
tstring &asarray_tstring::at( const char *key )
{
    ssize_t idx;
    if ( key == NULL ) {
        err_throw(__FUNCTION__,"ERROR","NULL key...?");
    }
    idx = this->index_rec.index(key,0);
    if ( idx < 0 ) {
	this->append(key,"");
	idx = this->index_rec.index(key,0);
    }
    if ( idx < 0 ) {
        err_throw1(__FUNCTION__,"ERROR","not found key '%s'",key);
    }
    return this->value_rec.at(idx);
}

/**
 * @brief  ʸбǤλ(tstring)֤ (printf()εˡ)
 *
 *  ΥʸбͤλȤ֤ޤ<br>
 *  Υдؿϻꤷʸ printf() ؿƱͤΥեޥåȤ
 *  ѰǥåȤǤޤ
 * 
 * @param   fmt ʸΤΥեޥåȻ
 * @param   ... fmtбĹγǥǡ
 * @return  ꤵ줿бͤλ
 * @throw   ꤵ줿ʸNULLξ
 * @throw   Хåեγݤ˼Ԥ
 */
tstring &asarray_tstring::atf( const char *fmt, ... )
{
    va_list ap;
    va_start(ap,fmt);
    try {
	tstring &ret = this->vatf(fmt,ap);
	va_end(ap);
	return ret;
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vatf() failed");
    }
}

/**
 * @brief  ʸбǤλ(tstring)֤ (printf()εˡ)
 *
 *  ΥʸбͤλȤ֤ޤ<br>
 *  Υдؿϻꤷʸ printf() ؿƱͤΥեޥåȤ
 *  ѰǥåȤǤޤ
 * 
 * @param   fmt ʸΤΥեޥåȻ
 * @param   ap fmtбĹγǥǡ
 * @return  ꤵ줿бͤλ
 * @throw   ꤵ줿ʸNULLξ
 * @throw   Хåեγݤ˼Ԥ
 */
tstring &asarray_tstring::vatf( const char *fmt, va_list ap )
{
    tstring buf;

    if ( fmt == NULL ) return this->at(fmt);

    buf.vprintf(fmt,ap);
    return this->at(buf.cstr());
}

#ifdef SLI__OVERLOAD_CONST_AT

/**
 * @brief  ʸбǤλ(tstring)֤ (ɼ)
 *
 * @param   key ϢΥʸ
 * @return  ꤵ줿бͤλ
 * @throw   ꤵ줿ʸNULLʾ
 * @throw   Хåեγݤ˼Ԥ
 */
const tstring &asarray_tstring::at( const char *key ) const
{
    return this->at_cs(key);
}

/**
 * @brief  ʸбǤλȤ֤ (ɼѡprintf()εˡ)
 *
 *  Υʸбͤλ(ɤ߼)֤ޤ<br>
 *  Υдؿϻꤷʸ printf() ؿƱͤΥեޥåȤ
 *  ѰǥåȤǤޤ
 * 
 * @param   fmt ʸΤΥեޥåȻ
 * @param   ... fmtбĹγǥǡ
 * @return  ꤵ줿бͤλ
 * @throw   ꤵ줿ʸNULL¸ߤʤ
 * @throw   Хåեγݤ˼Ԥ
 */
const tstring &asarray_tstring::atf( const char *fmt, ... ) const
{
    va_list ap;
    va_start(ap,fmt);
    try {
	const tstring &ret = this->vatf_cs(fmt,ap);
	va_end(ap);
	return ret;
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vatf_cs() failed");
    }
}

/**
 * @brief  ʸбǤλȤ֤ (ɼѡprintf()εˡ)
 *
 *  Υʸбͤλ(ɤ߼)֤ޤ<br>
 *  Υдؿϻꤷʸ printf() ؿƱͤΥեޥåȤ
 *  ѰǥåȤǤޤ
 * 
 * @param   fmt ʸΤΥեޥåȻ
 * @param   ap fmtбĹΥꥹ
 * @return  ꤵ줿бͤλ
 * @throw   ꤵ줿ʸNULL¸ߤʤ
 * @throw   Хåեγݤ˼Ԥ
 */
const tstring &asarray_tstring::vatf( const char *fmt, va_list ap ) const
{
    return this->vatf_cs(fmt, ap);
}
#endif

/**
 * @brief  ʸбǤλ(tstring)֤ (ɼ)
 *
 * @param   key ϢΥʸ
 * @return  ꤵ줿бͤλ
 * @throw   ꤵ줿ʸNULL¸ߤʤ
 */
const tstring &asarray_tstring::at_cs( const char *key ) const
{
    ssize_t idx;
    if ( key == NULL ) {
        err_throw(__FUNCTION__,"ERROR","NULL key...?");
    }
    idx = this->index_rec.index(key,0);
    if ( idx < 0 ) {
        err_throw1(__FUNCTION__,"ERROR","not found key '%s'",key);
    }
    return this->value_rec.at_cs(idx);
}

/**
 * @brief  ʸбǤλȤ֤ (ɼѡprintf()εˡ)
 *
 *  Υʸбͤλ(ɤ߼)֤ޤ<br>
 *  Υдؿϻꤷʸ printf() ؿƱͤΥեޥåȤ
 *  ѰǥåȤǤޤ
 *
 * @param   fmt ʸΤΥեޥåȻ
 * @param   ... fmtбĹΥꥹ
 * @return  ꤵ줿бͤλ
 * @throw   ꤵ줿ʸNULL¸ߤʤ.
 * @throw   Хåեγݤ˼Ԥ
 */
const tstring &asarray_tstring::atf_cs( const char *fmt, ... ) const
{
    va_list ap;
    va_start(ap,fmt);
    try {
	const tstring &ret = this->vatf_cs(fmt,ap);
	va_end(ap);
	return ret;
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vatf_cs() failed");
    }
}

/**
 * @brief  ʸбǤλȤ֤ (ɼѡprintf()εˡ)
 *
 *  Υʸбͤλ(ɤ߼)֤ޤ<br>
 *  Υдؿϻꤷʸ printf() ؿƱͤΥեޥåȤ
 *  ѰǥåȤǤޤ
 *
 * @param   fmt ʸΤΥեޥåȻ
 * @param   ap fmtбĹΥꥹ
 * @return  ꤵ줿бͤλ
 * @throw   ꤵ줿ʸNULL¸ߤʤ.
 * @throw   Хåեγݤ˼Ԥ
 */
const tstring &asarray_tstring::vatf_cs( const char *fmt, va_list ap ) const
{
    tstring buf;

    if ( fmt == NULL ) return this->at_cs(fmt);

    buf.vprintf(fmt,ap);
    return this->at_cs(buf.cstr());
}

/**
 * @brief  ʸбʸγХåեؤΥԡ
 *
 *  ǻꤵ줿бͤʸ򡤳Хåե˥ԡ
 *  ޤ
 *
 * @param   key ʸ
 * @param   dest_buf ԡγХåեɥ쥹
 * @param   buf_size ХåեΥ
 * @return  : ХåեĹʬʾ˥ԡǤʸ<br>
 *          : dest_bufNULLꤷbuf_size0ʳͤꤷ硥
 */
ssize_t asarray_tstring::getstr( const char *key, 
				 char *dest_buf, size_t buf_size ) const
{
    ssize_t idx;
    if ( key == NULL ) return -1;
    idx = this->index_rec.index(key,0);
    if ( idx < 0 ) return -1;
    return this->value_rec.getstr(idx,dest_buf,buf_size);
}

/**
 * @brief  ϢĹ(Ŀ)
 *
 * @return  ȤϢǿ
 */
size_t asarray_tstring::length() const
{
    return this->key_rec.length();
}

/**
 * @brief  ϢĹ(Ŀ)
 * 
 * @return ȤϢǿ
 * @note   asarray_tstring::length() Ȥΰ㤤Ϥޤ
 */
size_t asarray_tstring::size() const
{
    return this->key_rec.size();
}

/**
 * @brief  ꤵ줿ʸбǤʸĹ֤
 *
 * @param   key ϢΥʸ
 * @return  ꤵ줿бͤʸĹ
 */
size_t asarray_tstring::length( const char *key ) const
{
    ssize_t idx;
    if ( key == NULL ) return 0;
    idx = this->index_rec.index(key,0);
    if ( idx < 0 ) return 0;
    return this->value_rec.length(idx);
}

/**
 * @brief  ꤵ줿ʸбǤʸĹ֤
 *
 * @param   key ϢΥʸ
 * @return  ꤵ줿бͤʸĹ
 */
size_t asarray_tstring::size( const char *key ) const
{
    ssize_t idx;
    if ( key == NULL ) return 0;
    idx = this->index_rec.index(key,0);
    if ( idx < 0 ) return 0;
    return this->value_rec.size(idx);
}

/**
 * @brief  ꤵ줿ʸбʸΰposˤʸ֤
 *
 *  ǻꤵ줿ʸбͤΡposˤʸ֤ޤ
 * 
 * @param   key ϢΥʸ
 * @param   pos ʸΰ
 * @return  : ꤷ֤ˤʸ<br>
 *          : 顼
 */
int asarray_tstring::cchr( const char *key, size_t pos ) const
{
    ssize_t idx;
    if ( key == NULL ) return -1;
    idx = this->index_rec.index(key,0);
    if ( idx < 0 ) return -1;
    return this->value_rec.cchr(idx,pos);
}

/**
 * @brief  ꤵ줿ʸбֹ֤
 * 
 * @param   key ʸ
 * @return  : ꤵ줿ʸ󤬸Ĥä硥<br>
 *          : Ĥʤä硥
 */
ssize_t asarray_tstring::index( const char *key ) const
{
    if ( key == NULL ) return -1;
    return this->index_rec.index(key,0);
}

/**
 * @brief  ꤵ줿ʸбֹ֤ (printf()εˡ)
 *
 *  ʸбֹ֤ޤ<br>
 *  ΥдؿǤ printf() ؿƱͤΥեޥåȤȲѰǡ
 *  ʸ򥻥åȤǤޤ
 * 
 * @param   fmt ʸΤΥեޥåȻ
 * @param   ... fmtбĹγǥǡ
 * @return  : ꤵ줿ʸ󤬸Ĥä硥<br>
 *          : Ĥʤä硥
 * @throw   Хåեγݤ˼Ԥ
 */
ssize_t asarray_tstring::indexf( const char *fmt, ... ) const
{
    ssize_t ret;
    va_list ap;
    va_start(ap,fmt);
    try {
	ret = this->vindexf(fmt,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vindexf() failed");
    }
    va_end(ap);
    return ret;
}

/**
 * @brief  ꤵ줿ʸбֹ֤ (printf()εˡ)
 *
 *  ʸбֹ֤ޤ<br>
 *  ΥдؿǤ printf() ؿƱͤΥեޥåȤȲѰǡ
 *  ʸ򥻥åȤǤޤ
 * 
 * @param   fmt ʸΤΥեޥåȻ
 * @param   ap fmtбĹΥꥹ
 * @return  : ꤵ줿ʸ󤬸Ĥä硥<br>
 *          : Ĥʤä硥
 * @throw   Хåեγݤ˼Ԥ
 */
ssize_t asarray_tstring::vindexf( const char *fmt, va_list ap ) const
{
    tstring buf;

    if ( fmt == NULL ) return this->index(fmt);

    buf.vprintf(fmt,ap);
    return this->index(buf.cstr());
}

/**
 * @brief  ꤵ줿ֹ˳륭ʸ֤
 * 
 *  ꤵ줿ֹ˳륭ʸΥɥ쥹֤ޤ
 * 
 * @param   index ֹ
 * @return   ʸХåեΥɥ쥹<br>
 *           Ĺʾֹ椬ꤵ줿NULL
 */
const char *asarray_tstring::key( size_t index ) const
{
    if ( index < 0 || this->length() <= index ) return NULL;
    else return this->key_rec.cstr(index);
}

/**
 * @brief  ꤵ줿ֹ˳ʸ֤ (ɼ)
 *
 *  ꤵ줿ֹ˳ϢʸΥɥ쥹֤ޤ
 * 
 * @param   index ֹ
 * @return  ֹ˳ʸΥɥ쥹<br>
 *          ֹ椬ʾNULL
 */
const char *asarray_tstring::cstr( size_t index ) const
{
    if ( index < 0 || this->length() <= index ) return NULL;
    else return this->value_rec.cstr(index);
}

/**
 * @brief  ꤵ줿ֹ˳ͤλ(tstring)֤
 *
 * @param   index ֹ
 * @return  ꤵ줿ֹ˳ͤλ
 * @throw   ꤵ줿ֹ椬ʾ
 */
tstring &asarray_tstring::at( size_t index )
{
    if ( index < 0 || this->length() <= index ) {
        err_throw1(__FUNCTION__,"ERROR","invalid index: %d",(int)index);
    }
    return this->value_rec.at(index);
}

#ifdef SLI__OVERLOAD_CONST_AT

/**
 * @brief  ꤵ줿ֹ˳ͤλ(tstring)֤ (ɼ)
 * 
 * @param   index ֹ
 * @return  ꤵ줿ֹ˳ͤλ
 * @throw   ꤵ줿ֹ椬ʾ
 */
const tstring &asarray_tstring::at( size_t index ) const
{
    if ( index < 0 || this->length() <= index ) {
        err_throw1(__FUNCTION__,"ERROR","invalid index: %d",(int)index);
    }
    return this->value_rec.at_cs(index);
}
#endif

/**
 * @brief  ꤵ줿ֹ˳ͤλ(tstring)֤
 * 
 * @param   index ֹ
 * @return  ꤵ줿ֹ˳ͤλ
 * @throw   ꤵ줿ֹ椬ʾ
 */
tstring &asarray_tstring::element( size_t index )
{
    if ( index < 0 || this->length() <= index ) {
        err_throw1(__FUNCTION__,"ERROR","invalid index: %d",(int)index);
    }
    return this->value_rec.at(index);
}

/**
 * @brief  ꤵ줿ֹ˳ͤλ(tstring)֤ (ɼ)
 * 
 * @param   index ֹ
 * @return  ꤵ줿ֹ˳ͤλ
 * @throw   ꤵ줿ֹ椬ʾ
 */
const tstring &asarray_tstring::at_cs( size_t index ) const
{
    if ( index < 0 || this->length() <= index ) {
        err_throw1(__FUNCTION__,"ERROR","invalid index: %d",(int)index);
    }
    return this->value_rec.at_cs(index);
}

/**
 * @brief  ʸ󥪥֥ȤλȤ (ɼ)
 *
 *  ֥ǴƤ륭ʸ󥪥֥Ȥλ(ɤ߼
 *  )֤ޤ
 * 
 * @return  ʸ󥪥֥Ȥλ
 */
const tarray_tstring &asarray_tstring::keys() const
{
    return this->key_rec;
}

/**
 * @brief  ʸ󥪥֥ȤλȤ (ɼ)
 *
 *  ֥ǴƤʸ󥪥֥Ȥλ(ɤ߼)
 *  ֤ޤ
 * 
 * @return  ʸ󥪥֥Ȥλ
 */
const tarray_tstring &asarray_tstring::values() const
{
    return this->value_rec;
}

/**
 * @brief  ɸ२顼Ϥsrc ()
 * 
 * @param  src tstring֥
 * @note   private ʴؿǤ
 */
static void dump_tstring( const tstring &src )
{
    if ( 0 <= src.strchr('"') ) {
	size_t j;
	sli__eprintf("\"");
	for ( j=0 ; j < src.length() ; j++ ) {
	    int ch = src.cchr(j);
	    if ( ch == '"' ) sli__eprintf("\\\"");
	    else sli__eprintf("%c", ch);
	}
	sli__eprintf("\"");
    }
    else {
	sli__eprintf("\"%s\"", src.cstr());
    }
    return;
}

/**
 * @brief  ƥݥꥪ֥ȤΤshallow copy°Ϳ (̤)
 * @deprecated  ̤
 *
 */
/* : Ȥ֤Ȥreturn ʸǤȥ󥹥 */
/*       2󥳥ԡȤʻˤʤΤ void ˤʤäƤ */
void asarray_tstring::set_scopy_flag()
{
    return;
}

/**
 * @brief  ֥Ⱦɸ२顼Ϥؽ
 *
 *  ֥Ⱦɸ२顼ϤؽϤޤ
 */
void asarray_tstring::dprint( const char *msg ) const
{
    size_t i;
    if ( msg != NULL ) {
	sli__eprintf("%s sli::%s[obj=0x%zx] = { ",
		     msg, CLASS_NAME, (const size_t)this);
    }
    else {
	sli__eprintf("sli::%s[obj=0x%zx] = { ",CLASS_NAME,(const size_t)this);
    }
    for ( i=0 ; i < this->length() ; i++ ) {
	if ( i != 0 ) sli__eprintf(", ");
	sli__eprintf("{");
	dump_tstring(this->key_rec.at_cs(i));
	sli__eprintf(", ");
	dump_tstring(this->value_rec.at_cs(i));
	sli__eprintf("}");
    }
    sli__eprintf(" }\n");
    return;
}

}	/* namespace sli */
