/* -*- Mode: C++ ; Coding: euc-japan -*- */
/* Time-stamp: <2013-05-14 17:50:41 cyamauch> */

/**
 * @file   mdarray_fcomplex.cc
 * @brief  fcomplex¿򰷤 mdarray_fcomplex 饹Υ
 */

#define CLASS_NAME "mdarray_fcomplex"

#include "config.h"

#include "mdarray_fcomplex.h"
#include "tarray_tstring.h"

#include <stdarg.h>

#include "sli_funcs.h"

#include "private/s_memset.h"
#include "private/s_memmove.h"
#include "private/err_report.h"

#ifndef debug_report
//#define debug_report(xx) err_report(__FUNCTION__,"DEBUG",xx)
#define debug_report(xx)
#endif

namespace sli
{

/**
 * @brief  󥹥ȥ饯
 *
 *  Ȥưꥵ⡼ɤǽޤ
 *
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex()
{
    this->class_level_rec ++;
    this->mdarray::init(FCOMPLEX_ZT, true);
    return;
}

/**
 * @brief  󥹥ȥ饯
 * 
 * @param  auto_r ưꥵ⡼ɤǽԤtrue.
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r )
{
    this->class_level_rec ++;
    this->mdarray::init(FCOMPLEX_ZT, auto_r);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 * @param      auto_r ưꥵ⡼ɤǽԤtrue.
 * @param      extptr_address 桼ΥݥѿΥɥ쥹
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 * @attention  桼ΥݥѿϿ shallow copy ǽʤʤ
 *             ޤ
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, fcomplex **extptr_address )
{
    this->class_level_rec ++;
    this->mdarray::init(FCOMPLEX_ZT, auto_r);
    this->mdarray::register_extptr((void *)extptr_address);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 * @param      auto_r ưꥵ⡼ɤǽԤtrue.
 * @param      extptr2d_address 桼Υݥѿ(2d)Υɥ쥹
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 * @attention  桼ΥݥѿϿ shallow copy ǽʤʤ
 *             ޤ
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, fcomplex *const **extptr2d_address )
{
    this->class_level_rec ++;
    this->mdarray::init(FCOMPLEX_ZT, auto_r);
    this->mdarray::register_extptr_2d((void *)extptr2d_address);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 * @param      auto_r ưꥵ⡼ɤǽԤtrue.
 * @param      extptr3d_address 桼Υݥѿ(3d)Υɥ쥹
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 * @attention  桼ΥݥѿϿ shallow copy ǽʤʤ
 *             ޤ
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, fcomplex *const *const **extptr3d_address )
{
    this->class_level_rec ++;
    this->mdarray::init(FCOMPLEX_ZT, auto_r);
    this->mdarray::register_extptr_3d((void *)extptr3d_address);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  ndimǼnaxisx[]ǳƼǿꤷƽԤޤ
 *
 * @param  auto_r ưꥵ⡼ɤǽԤtrue
 * @param  naxisx[] Ƽǿ
 * @param  ndim 
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, const size_t naxisx[], size_t ndim, bool init_buf )
{
    this->class_level_rec ++;
    this->mdarray::init(FCOMPLEX_ZT, auto_r, naxisx, ndim, init_buf);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  naxis01ܤǿꤷƽԤޤ
 *
 * @param  auto_r ưꥵ⡼ɤǽԤtrue
 * @param  naxis0 ֹ01)μ
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
*/
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, size_t naxis0 )
{
    const size_t naxisx[] = {naxis0};
    this->class_level_rec ++;
    this->mdarray::init(FCOMPLEX_ZT, auto_r, naxisx, 1, true);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  naxis0ǣܤǿnaxis12ܤǿꤷƽ
 *  Ԥޤ
 * 
 * @param  auto_r ưꥵ⡼ɤǽԤtrue
 * @param  naxis0 ֹ01)ǿ
 * @param  naxis1 ֹ1 2)ǿ
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, size_t naxis0, size_t naxis1 )
{
    const size_t naxisx[] = {naxis0, naxis1};
    this->class_level_rec ++;
    this->mdarray::init(FCOMPLEX_ZT, auto_r, naxisx, 2, true);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  naxis0ǣܤǿnaxis12ܤǿnaxis23ܤ
 *  ǿꤷƽԤޤ
 * 
 * @param  auto_r ưꥵ⡼ɤǽԤtrue
 * @param  naxis0 ֹ0(1)ǿ
 * @param  naxis1 ֹ1(2)ǿ
 * @param  naxis2 ֹ2(3)ǿ
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, size_t naxis0, size_t naxis1, size_t naxis2 )
{
    const size_t naxisx[] = {naxis0, naxis1, naxis2};
    this->class_level_rec ++;
    this->mdarray::init(FCOMPLEX_ZT, auto_r, naxisx, 3, true);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  naxis01ܤǿꤷvalsƤǽԤޤ
 * 
 * @param  auto_r ưꥵ⡼ɤǽԤtrue
 * @param  naxis0 ֹ0(1)ǿ
 * @param  vals[] ԡȤʤΥɥ쥹
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, size_t naxis0, 
			      const fcomplex vals[] )
{
    this->class_level_rec ++;
    this->init(auto_r, naxis0, vals);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  naxis01ܤǿnaxis12ܤǿꤷ
 *  valsƤǽԤޤ.
 * 
 * @param  auto_r ưꥵ⡼ɤǽԤtrue
 * @param  naxis0 ֹ0(1)ǿ
 * @param  naxis1 ֹ1(2)ǿ
 * @param  vals[] ԡȤʤΥɥ쥹
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, size_t naxis0, size_t naxis1,
			      const fcomplex vals[] )
{
    this->class_level_rec ++;
    this->init(auto_r, naxis0, naxis1, vals);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  naxis01ܤǿnaxis12ܤǿꤷ
 *  valsƤǽԤޤ
 * 
 * @param  auto_r ưꥵ⡼ɤǽԤtrue
 * @param  naxis0 ֹ0(1)ǿ
 * @param  naxis1 ֹ1(2)ǿ
 * @param  vals[] ԡȤʤΥɥ쥹
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, size_t naxis0, size_t naxis1,
			      const fcomplex *const vals[] )
{
    this->class_level_rec ++;
    this->init(auto_r, naxis0, naxis1, vals);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  naxis01ܤǿnaxis22ܤǿnaxis2ǻܤ
 *  ǿꤷvalsƤǽԤޤ
 * 
 * @param  auto_r ưꥵ⡼ɤǽԤtrue
 * @param  naxis0 ֹ0(1)ǿ
 * @param  naxis1 ֹ1(2)ǿ
 * @param  naxis2 ֹ2(3)ǿ
 * @param  vals[] ԡȤʤΥɥ쥹
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, size_t naxis0, size_t naxis1, size_t naxis2,
			      const fcomplex vals[] )
{
    this->class_level_rec ++;
    this->init(auto_r, naxis0, naxis1, naxis2, vals);
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  naxis01ܤǿnaxis22ܤǿnaxis2ǻܤ
 *  ǿꤷvalsƤǽԤޤ
 * 
 * @param  auto_r ưꥵ⡼ɤǽԤtrue
 * @param  naxis0 ֹ0(1)ǿ
 * @param  naxis1 ֹ1(2)ǿ
 * @param  naxis2 ֹ2(3)ǿ
 * @param  vals[] ԡȤʤΥɥ쥹
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, size_t naxis0, size_t naxis1, size_t naxis2,
			      const fcomplex *const *const vals[] )
{
    this->class_level_rec ++;
    this->init(auto_r, naxis0, naxis1, naxis2, vals);
    return;
}

#if 0

/**
 * @brief  󥹥ȥ饯
 *
 *  ȤȤͿ줿ǥǡǽޤ
 * 
 * @deprecated  Բġ
 * @param  auto_r ưꥵ⡼ɤǽԤtrue
 * @param  dim_info  Ƽǿ
 * @param  v0 ͥǡ
 * @param  ... ͥǡβĹꥹ
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( bool auto_r, const char *dim_info,
			      fcomplex v0, ... )
{
    va_list ap;

    this->class_level_rec ++;

    va_start(ap, v0);
    try {
	this->vinit(auto_r,dim_info,v0,ap);
    }
    catch (...) {
	va_end(ap);
 	err_throw(__FUNCTION__,"FATAL","this->vinit()");
    }
    va_end(ap);

    return;
}
#endif

/**
 * @brief  ԡ󥹥ȥ饯
 *
 *  ȤobjƤ򥳥ԡޤ
 * 
 * @param  obj ԡΥ֥
 * @throw  Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex::mdarray_fcomplex( const mdarray_fcomplex &obj )
{
    this->class_level_rec ++;
    this->mdarray::init(obj);
    return;
}

/**
 * @brief  ֥ȤΥԡޤ
 *
 *  ֥Ȥobj Ƥ򤹤٤(ĹƼ°) Ȥ˥ԡ
 *  ޤobj ؿˤä֤ƥݥꥪ֥Ȥξ硤Ĥ
 *   shallow  copy Ԥʤޤ<br>
 *  objηȤηȤϰۤʤ硤ʳΤ٤(ĹƼ°)򥳥ԡ
 *  ͤΥԡϥ顼ͤΡ=ױ黻ҤƱͤε§ǹԤʤޤ
 *
 * @param      obj mdarray(Ѿ) 饹Υ֥
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator=(const mdarray &obj)
{
    debug_report("(const mdarray &obj)");
    if ( &obj == this ) return *this;

    if ( obj.size_type() == FCOMPLEX_ZT ) {
	this->mdarray::init(obj);
    }
    else {

	if ( obj.dim_length() == 0 ) this->init();
	else {
	    this->init(true, obj.cdimarray(), obj.dim_length(), true);
	    this->ope_plus_equal(obj);
	}
	this->init_properties(obj);

    }

    return *this;
}

/**
 * @brief  Ȥˡꤵ줿û
 *
 *  黻Ҥα¦() ǻꤵ줿mdarray(Ѿ) 饹Υ֥Ȥ
 *  Ȥ˲ûޤ<br>
 *  ȤȤϰۤʤ뷿ꤵ줿֥Ȥꤵ줿硤̾Υ顼
 *  黻ξƱͤηѴԤʤޤ<br>
 * ּưꥵ⡼ɡפꤵƤ硤Ƽ˴ؤƼȤ
 *  obj 礭硤ưŪ˥ꥵޤ
 *
 * @param      obj mdarray(Ѿ) 饹Υ֥
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator+=(const mdarray &obj)
{
    debug_report("(const mdarray &obj)");
    this->ope_plus_equal(obj);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿Ǹ
 *
 *  黻Ҥα¦() ǻꤵ줿mdarray(Ѿ) 饹Υ֥Ȥ
 *  Ȥ鸺ޤ<br>
 *  ȤȤϰۤʤ뷿ꤵ줿֥Ȥꤵ줿硤̾Υ顼
 *  黻ξƱͤηѴԤʤޤ<br>
 *  ּưꥵ⡼ɡפꤵƤ硤Ƽ˴ؤƼȤ
 *  obj 礭硤ưŪ˥ꥵޤ
 *
 * @param      obj mdarray(Ѿ) 饹Υ֥
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator-=(const mdarray &obj)
{
    debug_report("(const mdarray &obj)");
    this->ope_minus_equal(obj);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿軻
 *
 *  黻Ҥα¦() ǻꤵ줿mdarray(Ѿ) 饹Υ֥Ȥ
 *  Ȥ˾軻ޤ<br>
 *  ȤȤϰۤʤ뷿ꤵ줿֥Ȥꤵ줿硤̾Υ顼
 *  黻ξƱͤηѴԤʤޤ<br>
 *  ּưꥵ⡼ɡפꤵƤ硤Ƽ˴ؤƼȤ
 *  obj 礭硤ưŪ˥ꥵޤ
 *
 * @param      obj mdarray(Ѿ) 饹Υ֥
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator*=(const mdarray &obj)
{
    debug_report("(const mdarray &obj)");
    this->ope_star_equal(obj);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿ǽ
 *
 *  黻Ҥα¦() ǻꤵ줿mdarray(Ѿ) 饹Υ֥Ȥ
 *  Ȥޤ<br>
 *  ȤȤϰۤʤ뷿ꤵ줿֥Ȥꤵ줿硤̾Υ顼
 *  黻ξƱͤηѴԤʤޤ<br>
 *  ּưꥵ⡼ɡפꤵƤ硤Ƽ˴ؤƼȤ
 *  obj 礭硤ưŪ˥ꥵޤ
 *
 * @param      obj mdarray(Ѿ) 饹Υ֥
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator/=(const mdarray &obj)
{
    debug_report("(const mdarray &obj)");
    this->ope_slash_equal(obj);
    return *this;
}

/**
 * @brief  Ȥˡ顼ͤ
 *
 *  黻Ҥα¦() ǻꤵ줿(顼) 򤷤ޤ.
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator=(dcomplex v)
{
    debug_report("(dcomplex v)");
    this->ope_equal(DCOMPLEX_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥˡ顼ͤ
 *
 *  黻Ҥα¦() ǻꤵ줿(顼) 򤷤ޤ.
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator=(double v)
{
    debug_report("(double v)");
    this->ope_equal(DOUBLE_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥˡ顼ͤ
 *
 *  黻Ҥα¦() ǻꤵ줿(顼) 򤷤ޤ.
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator=(long long v)
{
    debug_report("(long long v)");
    this->ope_equal(LLONG_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥˡ顼ͤ
 *
 *  黻Ҥα¦() ǻꤵ줿(顼) 򤷤ޤ.
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator=(long v)
{
    debug_report("(long v)");
    this->ope_equal(LONG_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥˡ顼ͤ
 *
 *  黻Ҥα¦() ǻꤵ줿(顼) 򤷤ޤ.
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator=(int v)
{
    debug_report("(int v)");
    this->ope_equal(INT_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǲû
 *
 *  黻Ҥα¦() ǻꤵ줿顼ͤ򼫿ȤǤ٤ƤФƲû
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator+=(dcomplex v)
{
    debug_report("(dcomplex v)");
    this->ope_plus_equal(DCOMPLEX_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǲû
 *
 *  黻Ҥα¦() ǻꤵ줿顼ͤ򼫿ȤǤ٤ƤФƲû
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator+=(double v)
{
    debug_report("(double v)");
    this->ope_plus_equal(DOUBLE_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǲû
 *
 *  黻Ҥα¦() ǻꤵ줿顼ͤ򼫿ȤǤ٤ƤФƲû
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator+=(long long v)
{
    debug_report("(long long v)");
    this->ope_plus_equal(LLONG_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǲû
 *
 *  黻Ҥα¦() ǻꤵ줿顼ͤ򼫿ȤǤ٤ƤФƲû
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator+=(long v)
{
    debug_report("(long v)");
    this->ope_plus_equal(LONG_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǲû
 *
 *  黻Ҥα¦() ǻꤵ줿顼ͤ򼫿ȤǤ٤ƤФƲû
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator+=(int v)
{
    debug_report("(int v)");
    this->ope_plus_equal(INT_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǸ
 *
 *  ȤǤ٤ƤФơ黻Ҥα¦() ǻꤵ줿顼ͤǸ
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator-=(dcomplex v)
{
    debug_report("(dcomplex v)");
    this->ope_minus_equal(DCOMPLEX_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǸ
 *
 *  ȤǤ٤ƤФơ黻Ҥα¦() ǻꤵ줿顼ͤǸ
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator-=(double v)
{
    debug_report("(double v)");
    this->ope_minus_equal(DOUBLE_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǸ
 *
 *  ȤǤ٤ƤФơ黻Ҥα¦() ǻꤵ줿顼ͤǸ
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator-=(long long v)
{
    debug_report("(long long v)");
    this->ope_minus_equal(LLONG_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǸ
 *
 *  ȤǤ٤ƤФơ黻Ҥα¦() ǻꤵ줿顼ͤǸ
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator-=(long v)
{
    debug_report("(long v)");
    this->ope_minus_equal(LONG_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǸ
 *
 *  ȤǤ٤ƤФơ黻Ҥα¦() ǻꤵ줿顼ͤǸ
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator-=(int v)
{
    debug_report("(int v)");
    this->ope_minus_equal(INT_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥˡ顼ͤ軻
 *
 *  黻Ҥα¦() ǻꤵ줿顼ͤ򼫿ȤǤ٤ƤФƾ軻
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator*=(dcomplex v)
{
    debug_report("(dcomplex v)");
    this->ope_star_equal(DCOMPLEX_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥˡ顼ͤ軻
 *
 *  黻Ҥα¦() ǻꤵ줿顼ͤ򼫿ȤǤ٤ƤФƾ軻
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator*=(double v)
{
    debug_report("(double v)");
    this->ope_star_equal(DOUBLE_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥˡ顼ͤ軻
 *
 *  黻Ҥα¦() ǻꤵ줿顼ͤ򼫿ȤǤ٤ƤФƾ軻
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator*=(long long v)
{
    debug_report("(long long v)");
    this->ope_star_equal(LLONG_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥˡ顼ͤ軻
 *
 *  黻Ҥα¦() ǻꤵ줿顼ͤ򼫿ȤǤ٤ƤФƾ軻
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator*=(long v)
{
    debug_report("(long v)");
    this->ope_star_equal(LONG_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥˡ顼ͤ軻
 *
 *  黻Ҥα¦() ǻꤵ줿顼ͤ򼫿ȤǤ٤ƤФƾ軻
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator*=(int v)
{
    debug_report("(int v)");
    this->ope_star_equal(INT_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǽ
 *
 *  ȤǤ٤ƤФơ黻Ҥα¦() ǻꤵ줿顼ͤǽ
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator/=(dcomplex v)
{
    debug_report("(dcomplex v)");
    this->ope_slash_equal(DCOMPLEX_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǽ
 *
 *  ȤǤ٤ƤФơ黻Ҥα¦() ǻꤵ줿顼ͤǽ
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator/=(double v)
{
    debug_report("(double v)");
    this->ope_slash_equal(DOUBLE_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǽ
 *
 *  ȤǤ٤ƤФơ黻Ҥα¦() ǻꤵ줿顼ͤǽ
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator/=(long long v)
{
    debug_report("(long long v)");
    this->ope_slash_equal(LLONG_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǽ
 *
 *  ȤǤ٤ƤФơ黻Ҥα¦() ǻꤵ줿顼ͤǽ
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator/=(long v)
{
    debug_report("(long v)");
    this->ope_slash_equal(LONG_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  Ȥ򡤥顼ͤǽ
 *
 *  ȤǤ٤ƤФơ黻Ҥα¦() ǻꤵ줿顼ͤǽ
 *  ޤ<br>
 *  ȤȤϷۤʤξ硤̾Υ顼黻ξƱͤηѴ
 *  Ԥʤޤ
 *
 * @param      v 顼
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::operator/=(int v)
{
    debug_report("(int v)");
    this->ope_slash_equal(INT_ZT,(const void *)&v);
    return *this;
}

/**
 * @brief  ֥Ȥν
 *
 *  Ȥ°ޤ<br>
 *  󥵥 0 Ȥƥ֥Ȥޤ
 *
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init()
{
    debug_report("()");
    this->mdarray::init();
    return *this;
}

/**
 * @brief  ֥Ȥν
 *
 *  Ȥ°ޤ
 *
 * @param      auto_resize ưꥵ⡼ɤꤹ true
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize )
{
    this->mdarray::init();
    this->mdarray::set_auto_resize(auto_resize);
    return *this;
}

/**
 * @brief  ֥Ȥν (n)
 *
 *  Ȥ°ޤ<br>
 *  ndim Ǽnaxisx[] ǳƼǿꤷޤ
 *
 * @param      auto_resize ưꥵ⡼ɤꤹ true
 * @param      ndim 󼡸
 * @param      naxisx[] Ƽǿ
 * @param      init_buf ͤǥեͤʤ true
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize, const size_t naxisx[], size_t ndim, bool init_buf )
{
    this->mdarray::init(FCOMPLEX_ZT, auto_resize, naxisx, ndim, init_buf);
    return *this;
}

/**
 * @brief  ν (1)
 *
 *  Ȥޤ<br>
 *  naxis0  1 ܤǿꤷ1 ĥ֥Ȥ
 *  ޤ
 *
 * @param      auto_resize ưꥵ⡼ɤꤹ true
 * @param      naxis0 ֹ0 μ(1 ) ǿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize, size_t naxis0 )
{
    const size_t naxisx[] = {naxis0};
    this->mdarray::init(FCOMPLEX_ZT, auto_resize, naxisx, 1, true);
    return *this;
}

/**
 * @brief  ν (2)
 *
 *  Ȥޤ<br>
 *  naxis0  1 ܤǿnaxis1  2 ܤǿꤷ2 
 *  ĥ֥Ȥޤ
 *
 * @param      auto_resize ưꥵ⡼ɤꤹ true
 * @param      naxis0 ֹ0 μ(1 ) ǿ
 * @param      naxis1 ֹ1 μ(2 ) ǿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize, size_t naxis0, size_t naxis1 )
{
    const size_t naxisx[] = {naxis0, naxis1};
    this->mdarray::init(FCOMPLEX_ZT, auto_resize, naxisx, 2, true);
    return *this;
}

/**
 * @brief  ν (3)
 *
 *  Ȥޤ<br>
 *  naxis0  1 ܤǿnaxis1  2 ܤǿnaxis2  3 
 *  ǿꤷ3 ĥ֥Ȥޤ
 *
 * @param      auto_resize ưꥵ⡼ɤꤹ true
 * @param      naxis0 ֹ0 μ(1 ) ǿ
 * @param      naxis1 ֹ1 μ(2 ) ǿ
 * @param      naxis2 ֹ2 μ(3 ) ǿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize, size_t naxis0, size_t naxis1, size_t naxis2 )
{
    const size_t naxisx[] = {naxis0, naxis1, naxis2};
    this->mdarray::init(FCOMPLEX_ZT, auto_resize, naxisx, 3, true);
    return *this;
}

/**
 * @brief  󥹥ȥ饯뤤 init() ΰμ parse (̤)
 * 
 * @deprecated  ̤
 * @param   dim_info Ƽǿξ
 * @return  ꤵ줿ο
 * @throw   Хåեγݤ˼Ԥ
 * @note    ΥдؿprotectedǤ<br>
 *          3ޤǤݡȤƤޤ.
 */
size_t mdarray_fcomplex::parse_dim_info( const char *dim_info )
{
    size_t i;
    tarray_tstring arr0;
    this->dinfo_dlen[0] = 0;
    this->dinfo_dlen[1] = 0;
    this->dinfo_dlen[2] = 0;
    arr0.split(dim_info,", ",false);
    /* 3ޤǤݡȤʤ */
    for ( i=0 ; i < arr0.length() && i < 3 ; i++ ) {
	this->dinfo_dlen[i] = arr0[i].atoll();
	if ( this->dinfo_dlen[i] == 0 ) break;
    }
    return i;
}

/**
 * @brief  ν
 *
 *  naxis01ܤǿꤷvalsƤǽԤޤ
 *
 * @param      auto_resize ưꥵ⡼ɤꤹ true
 * @param      naxis0 ֹ0 μ(1 ) ǿ
 * @param      vals ԡȤʤΥɥ쥹
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize, size_t naxis0, 
				    const fcomplex vals[] )
{
    const size_t naxisx[] = {naxis0};
    this->mdarray::init(FCOMPLEX_ZT, auto_resize, naxisx, 1, false);
    this->mdarray::putdata((const void *)vals, this->byte_length());
    return *this;
}

/**
 * @brief  ν
 *
 *  naxis01ܤǿnaxis12ܤǿꤷ
 *  valsƤǽԤޤ.
 *
 * @param      auto_resize ưꥵ⡼ɤꤹ true
 * @param      naxis0 ֹ0 μ(1 ) ǿ
 * @param      naxis1 ֹ1 μ(2 ) ǿ
 * @param      vals ԡȤʤΥɥ쥹
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize, size_t naxis0, size_t naxis1, 
				    const fcomplex vals[] )
{
    const size_t naxisx[] = {naxis0, naxis1};
    this->mdarray::init(FCOMPLEX_ZT, auto_resize, naxisx, 2, false);
    this->mdarray::putdata((const void *)vals, this->byte_length());
    return *this;
}

/**
 * @brief  ν
 *
 *  naxis01ܤǿnaxis12ܤǿꤷ
 *  valsƤǽԤޤ
 *
 * @param      auto_resize ưꥵ⡼ɤꤹ true
 * @param      naxis0 ֹ0 μ(1 ) ǿ
 * @param      naxis1 ֹ1 μ(2 ) ǿ
 * @param      vals ԡȤʤݥΥɥ쥹
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize, size_t naxis0, size_t naxis1, 
				    const fcomplex *const vals[] )
{
    const size_t naxisx[] = {naxis0, naxis1};
    size_t blen0, i;
    char *p_dst;
    /* */
    this->mdarray::init(FCOMPLEX_ZT, auto_resize, naxisx, 2, false);
    /* */
    blen0 = this->byte_length(0);
    p_dst = (char *)(this->mdarray::data_ptr());
    for ( i=0 ; i < naxis1 ; i++ ) {
	const void *p_src = (const void *)(vals[i]);
	if ( p_src == NULL ) break;
	s_memmove(p_dst, p_src, blen0);
	p_dst += blen0;
    }
    if ( i < naxis1 ) s_memset(p_dst, 0, blen0 * (naxis1 - i), 0);

    return *this;
}

/**
 * @brief  ν
 *
 *  naxis01ܤǿnaxis22ܤǿnaxis2ǻܤ
 *  ǿꤷvalsƤǽԤޤ
 *
 * @param      auto_resize ưꥵ⡼ɤꤹ true
 * @param      naxis0 ֹ0 μ(1 ) ǿ
 * @param      naxis1 ֹ1 μ(2 ) ǿ
 * @param      naxis2 ֹ2 μ(3 ) ǿ
 * @param      vals ԡȤʤΥɥ쥹
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize, size_t naxis0, size_t naxis1, size_t naxis2, 
				    const fcomplex vals[] )
{
    const size_t naxisx[] = {naxis0, naxis1, naxis2};
    this->mdarray::init(FCOMPLEX_ZT, auto_resize, naxisx, 3, false);
    this->mdarray::putdata((const void *)vals, this->byte_length());
    return *this;
}

/**
 * @brief  ν
 *
 *  naxis01ܤǿnaxis22ܤǿnaxis2ǻܤ
 *  ǿꤷvalsƤǽԤޤ
 *
 * @param      auto_resize ưꥵ⡼ɤꤹ true
 * @param      naxis0 ֹ0 μ(1 ) ǿ
 * @param      naxis1 ֹ1 μ(2 ) ǿ
 * @param      naxis2 ֹ2 μ(3 ) ǿ
 * @param      vals ԡȤʤݥΥɥ쥹
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize, size_t naxis0, size_t naxis1, size_t naxis2, 
				    const fcomplex *const *const vals[] )
{
    const size_t naxisx[] = {naxis0, naxis1, naxis2};
    size_t blen0, i, j;
    char *p_dst;
    /* */
    this->mdarray::init(FCOMPLEX_ZT, auto_resize, naxisx, 3, false);
    /* */
    blen0 = this->byte_length(0);
    p_dst = (char *)(this->mdarray::data_ptr());
    for ( i=0 ; i < naxis2 ; i++ ) {		/* layer */
	j = 0;					/* row */
	if ( vals[i] != NULL ) {
	    for ( ; j < naxis1 ; j++ ) {
		const void *p_src = (const void *)(vals[i][j]);
		if ( p_src == NULL ) break;
		s_memmove(p_dst, p_src, blen0);
		p_dst += blen0;
	    }
	}
	if ( j < naxis1 ) {
	    s_memset(p_dst, 0, blen0 * (naxis1 - j), 0);
	    p_dst += blen0 * (naxis1 - j);
	}
    }

    return *this;
}

#if 0

/**
 * @brief  ν
 *
 *  ȤȤͿ줿ǥǡǽޤ.
 * 
 * @deprecated  ̤
 * @param   auto_resize ưꥵ⡼ɤǽԤtrue
 * @param   dim_info Ƽǿ
 * @param   v0 ͥǡ
 * @param   ... ͥǡγ
 * 
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex &mdarray_fcomplex::init( bool auto_resize, const char *dim_info, fcomplex v0, ... )
{
    va_list ap;
    va_start(ap, v0);
    try {
	this->vinit(auto_resize, dim_info, v0, ap);
    }
    catch (...) {
	va_end(ap);
 	err_throw(__FUNCTION__,"FATAL","failed this->init()");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ν
 *
 *  ȤȤͿ줿ǥǡǽޤ.
 * 
 * @deprecated  ̤
 * @param   auto_resize ưꥵ⡼ɤǽԤtrue
 * @param   dim_info Ƽǿ
 * @param   v0 ͥǡ
 * @param   ap ͥǡβĹꥹ
 * 
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex &mdarray_fcomplex::vinit( bool auto_resize, const char *dim_info, fcomplex v0, va_list ap )
{
    size_t ndim = this->parse_dim_info(dim_info);
    if ( ndim < 1 ) {
	this->mdarray::init(FCOMPLEX_ZT, auto_resize);
    }
    else {
	size_t i;
	this->mdarray::init(FCOMPLEX_ZT, auto_resize, this->dinfo_dlen, ndim, true);
	i = 0;
	if ( i < this->length() ) this->fx(i) = v0;
	i++;
	for ( ; i < this->length() ; i++ ) {
	    this->fx(i) = va_arg(ap,fcomplex);
	}
    }
    return *this;
}
#endif

/**
 * @brief  ֥ȤΥԡ
 *
 *  obj Ƥ°٤Ƥ򼫿Ȥ˥ԡޤȤη obj
 *  ηϰפƤɬפޤ(ۤʤϡ=ױ黻Ҥ
 *  ޤ)<br>
 *  obj ؿˤä֤줿ƥݥꥪ֥Ȥξ硤ĤƤ
 *  shallow copy Ԥʤޤ
 *
 * @param      obj ԡȤʤ륪֥ (ϼȤƱ)
 * @return     Ȥλ
 * @throw      ۤʤ򥳥ԡ褦Ȥ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::init( const mdarray &obj )
{
    debug_report("( const mdarray &obj )");
    if ( obj.size_type() == this->size_type() ) {
	this->mdarray::init(obj);
    }
    else {
 	err_throw(__FUNCTION__,"FATAL",
		  "cannot use init() between different size_type");
    }
    return *this;
}

/* copy properties (auto_resize, auto_init, and rounding) */
/**
 * @brief  ưꥵưͼθˡ򥳥ԡ
 *
 *  src_obj  auto_resize, auto_init, rounding, alloc_strategy 
 *  ԡޤ
 *
 * @param   src_obj ԡ륪֥
 * @return  Ȥλ
 *            
 */
mdarray_fcomplex &mdarray_fcomplex::init_properties( const mdarray &src_obj )
{
    this->mdarray::init_properties(src_obj);
    return *this;
}

/**
 * @brief  ߤμưꥵβݤѹ
 *
 *  ꥵ⡼ɤ(true)ޤϵ(false) ꤷޤ<br>
 *  ư⡼ɤּưꥵ⡼ɡפξ true
 *  ư⡼ɤּưꥵ⡼ɡפξ false Ǥ
 *
 * @param     tf ꥵ⡼
 * @return    Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::set_auto_resize( bool tf )
{
    this->mdarray::set_auto_resize(tf);
    return *this;
}

/**
 * @brief  ߤμưβݤѹ
 *
 *  ư⡼ɤ(true)ޤϵ(false) ꤷޤ
 *
 * @param     tf ư⡼
 * @return    Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::set_auto_init( bool tf )
{
    this->mdarray::set_auto_init(tf);
    return *this;
}

/**
 * @brief  ߤλͼθβݤѹ
 *
 *  Ĥι٥дؿˤơưѴˡ
 *  ͼθԤݤꤷޤ<br>
 *  ͼθ褦ꤵƤϿ(true)
 *  ͼθʤ褦ꤵƤϵ(false) ꤷޤ
 *
 * @param   tf ͼθ
 * @return  Ȥλ
 * @note    ͼθ°ǽдؿϡ
 *          lvalue()llvalue() дؿassign default() дؿ
 *          assign() дؿconvert() дؿдؿ̡
 *
 */
mdarray_fcomplex &mdarray_fcomplex::set_rounding( bool tf )
{
    this->mdarray::set_rounding(tf);
    return *this;
}

/**
 * @brief  ˡѹ
 *
 *  ѥݤˡɤΤ褦ˡǹԤʤꤷޤ
 *   3 Ĥ򤷤ޤ<br>
 *    "min"  ... Ǿ¤ݡꥵɬ realloc() ƤФޤ<br>
 *    "pow"  ... 2nǳݡ<br>
 *    "auto" ... ưꥵ⡼ɤλˤ "pow"Ǥʤ "min" 
 *               ꥵ¹Ԥޤ<br>
 *    NULL¾ ... ߤˡݻޤ
 *
 * @param   strategy ˡ
 * @return  Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::set_alloc_strategy( const char *strategy )
{
    this->mdarray::set_alloc_strategy(strategy);
    return *this;
}

/*
static void fnc_for_convert( const void *v0p, void *v1p, void *p )
{
    mdarray_fcomplex *this_p = (mdarray_fcomplex *)p;
    fcomplex v0 = *((const fcomplex *)v0p);
    *((fcomplex *)v1p) = (*(this_p->convert_func_rec))(v0, this_p->convert_user_ptr_rec);
}
*/

/*
mdarray_fcomplex &mdarray_fcomplex::convert( fcomplex (*func)(fcomplex,void *),
				       void *user_ptr )
{
    this->convert_func_rec = func;
    this->convert_user_ptr_rec = user_ptr;
    this->mdarray::convert(FCOMPLEX_ZT, &fnc_for_convert, (void *)this);
    return *this;
}
*/

/**
 * @brief  Ǥͤν񤭴 (桼ؿͳ)
 *
 *  ȤǤͤ 桼ؿ func ͳǽ񤭴ޤ<br>
 *  桼ؿ1ˤθγǥɥ쥹2ˤѴ
 *  ǤΥɥ쥹3ˤ12Ϳ줿ǤθĿ
 *  4ˤѴ(ʤʤ)5ˤ user_ptr 
 *  Ϳޤ
 *
 * @param      func     桼ؿΥɥ쥹
 * @param      user_ptr 桼ؿκǸͿ桼Υݥ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 */
mdarray_fcomplex &mdarray_fcomplex::convert_via_udf( void (*func)(const fcomplex *,fcomplex *,size_t,int,void *),
				       void *user_ptr )
{
    this->mdarray::convert_via_udf(FCOMPLEX_ZT,
		   (void (*)(const void *,void *,size_t,int,void *))func,
		   user_ptr);
    return *this;
}

/**
 * @brief  2ĤΥ֥ȴ֤ǤƤΥå
 *
 *  ꤵ줿֥sobj ƤȼȤƤؤޤ
 *  ơΥ°٤Ƥξ֤ؤޤ<br>
 *  sobj ηϼȤηƱǤɬפޤ
 *
 * @param     sobj ȤƱ mdarray(Ѿ) 饹Υ֥
 * @return    Ȥλ    
 * @throw     sobj ηȤηȰۤʤ
 */
mdarray_fcomplex &mdarray_fcomplex::swap( mdarray &sobj )
{
    if ( sobj.size_type() == this->size_type() ) {
	this->mdarray::swap(sobj);
    }
    else {
 	err_throw(__FUNCTION__,"FATAL",
		  "cannot swap objects between different size_type");
    }
    return *this;
}

/**
 * @brief  ȤƤꥪ֥Ȥإԡ
 *
 *  ȤƤƤꤵ줿֥ dest إԡޤ
 *  ĹƤ°ԡޤ(ԡ) ϲѤ
 *  ޤ<br>
 *  Ĺ dest ȼȤȤϡѥХåեκƳݤ
 *  Ԥʤ줺¸ΥХåեƤԡޤ<br>
 *  =ױ黻Ҥ .init(obj) Ȥϰۤʤꡤ deep copy ¹Ԥޤ<br>
 *  dest ˤϡmdarray_fcomplex 饹Υ֥Ȥ뤤 mdarray 饹
 *  ֥ȤꤵʤФʤޤ
 *
 * @param     dest ԡΥ֥ȤΥɥ쥹
 * @return    ԡǿ(߹Կߥ쥤)<br>
 *            ʾ
 * @throw     dest ǻꤵ줿֥Ȥʾ
 * @throw     Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
ssize_t mdarray_fcomplex::copy( mdarray *dest ) const
{
    debug_report("( mdarray *dest )");
    return this->mdarray::copy(dest);
}

/**
 * @brief  ȤƤꥪ֥Ȥإԡ (侩)
 * @deprecated 侩<br>
 * ssize_t mdarray_fcomplex::copy( mdarray *dest ) const <br>
 * 򤪻Ȥ
 */
ssize_t mdarray_fcomplex::copy( mdarray &dest ) const
{
    debug_report("( mdarray &dest )");
    return this->mdarray::copy(dest);
}

/**
 * @brief  ȤƤꥪ֥Ȥذܴ
 *
 *  ȤƤdest ˤꤵ줿֥Ȥءְܴɡפޤ
 *  (ĹƼ°ꤵ줿֥Ȥ˥ԡޤ)ܴɤ
 *  ̡ȤĹϥˤʤޤ<br>
 *  dest ˤĤƤѥХåեκƳݤϹԤʤ줺ȤѥХåե
 *  ˤĤƤδ¤ dest ˾ϤˤʤäƤꡤ®ưޤ
 *  dest ˤϡmdarray_fcomplex 饹Υ֥Ȥ뤤 mdarray 饹
 *  ֥ȤꤵʤФʤޤ
 *
 * @param     dest ܴɡԡΥ֥ȤΥɥ쥹
 * @return    Ȥλ
 * @throw     dest ǻꤵ줿֥Ȥʾ
 * @throw     Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex &mdarray_fcomplex::cut( mdarray *dest )
{
    debug_report("( mdarray *dest )");
    this->mdarray::cut(dest);
    return *this;
}

/* interchange rows and columns */
/**
 * @brief  Ȥ (x,y) ǤΥȥ󥹥ݡ
 *
 *  ȤΥȥȤؤޤ
 * 
 * @note  ®ʥ르ꥺѤƤޤ
 */
mdarray_fcomplex &mdarray_fcomplex::transpose_xy()
{
    this->mdarray::transpose_xy();
    return *this;
}

/* interchange xyz to zxy */
/**
 * @brief  Ȥ (x,y,z)(z,x,y) Υȥ󥹥ݡ
 *
 *  Ȥμ (x,y,z)  (z,x,y) Ѵޤ
 * 
 * @note  ®ʥ르ꥺѤƤޤ
 */
mdarray_fcomplex &mdarray_fcomplex::transpose_xyz2zxy()
{
    this->mdarray::transpose_xyz2zxy();
    return *this;
}

/* rotate image                                              */
/*   angle: 90,-90, or 180                                   */
/*          (anticlockwise when image is bottom-left origin) */
/**
 * @brief  Ȥ (x,y) Ǥβž (90ñ)
 *
 *  Ȥ (x,y) ̤ˤĤƤβž(90ñ)Ԥʤޤ<br>
 *  Ȥ硤ȿפޤǻꤷޤ
 *
 * @param  angle 90,-90, 180 Τ줫
 * 
 */
mdarray_fcomplex &mdarray_fcomplex::rotate_xy( int angle )
{
    this->mdarray::rotate_xy( angle );
    return *this;
}


/**
 * @brief  ȤƤ桼Хåեإԡ (ǿǤλ)
 *
 *  ȤƤ dest_bufǻꤵ줿桼Хåեإԡޤ<br>
 *  Хåե礭 elem_size ǤθĿͿޤidx0, idx1, idx2 
 *  ȤǤγꤷޤ<br>
 *  ˡMDARRAY_INDEF ŪͿʤǤ
 *
 * @param      dest_buf 桼ХåեΥɥ쥹 (ԡ)
 * @param      elem_size ԡǤθĿ
 * @param      idx0 ֹ0 μ(1 ) ֹ(ԡά)
 * @param      idx1 ֹ1 μ(2 ) ֹ(ԡά)
 * @param      idx2 ֹ2 μ(3 ) ֹ(ԡά)
 * @return     桼ΥХåեĹʬʾ˥ԡǿ
 * @throw      ˲򵯤
 *
 */
ssize_t mdarray_fcomplex::get_elements( fcomplex *dest_buf, size_t elem_size, 
				     ssize_t idx0, ssize_t idx1, ssize_t idx2 ) const
{
    return this->mdarray::get_elements((void *)dest_buf,
				       elem_size, idx0,idx1,idx2);
}

/**
 * @brief  桼ХåեƤ򼫿Ȥإԡ (ǿǤλ)
 *
 *  src_buf ǻꤵ줿桼ХåեƤ򼫿Ȥإԡޤ<br>
 *  Хåե礭 elem_size ϡǤθĿͿޤidx0, idx1, idx2 
 *  ȤǤγꤷޤ<br>
 *  ˡMDARRAY_INDEF ŪͿʤǤ
 *
 * @param      src_buf 桼ХåեΥɥ쥹 (ԡ)
 * @param      elem_size ԡǤθĿ
 * @param      idx0 ֹ0 μ(1 ) ֹ(ԡ衤ά)
 * @param      idx1 ֹ1 μ(2 ) ֹ(ԡ衤ά)
 * @param      idx2 ֹ2 μ(3 ) ֹ(ԡ衤ά)
 * @return     桼ΥХåեĹʬʾ˥ԡǿ
 * @throw      ˲򵯤
 *
 */
ssize_t mdarray_fcomplex::put_elements( const fcomplex *src_buf, size_t elem_size,
				     ssize_t idx0, ssize_t idx1, ssize_t idx2 )
{
    return this->mdarray::put_elements((const void *)src_buf, 
				       elem_size, idx0,idx1,idx2);
}

/**
 * @brief  1ĳĥ
 *
 *  Ȥμ1 ĳĥޤ
 *
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::increase_dim()
{
    this->mdarray::increase_dim();
    return *this;
}

/**
 * @brief  1Ľ̾
 *
 *  Ȥμ1 Ľ̾ޤ
 *
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
mdarray_fcomplex &mdarray_fcomplex::decrease_dim()
{
    this->mdarray::decrease_dim();
    return *this;
}

/**
 * @brief  ǽμˤĤƤĹѹ
 *
 *  ȤĹѹޤ<br>
 *  Ĺĥ硤Ǥͤϥǥեͤޤ<br>
 *  Ĺ̤硤lenʹߤǤϺޤ<br>
 *  ˼ֹ 0 μ(1)оݤȤޤ
 *
 * @param      len ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::resize( size_t len )
{
    this->mdarray::resize(len);
    return *this;
}

/**
 * @brief  Ǥդ1ĤμˤĤƤĹѹ
 *
 *  ȤĹѹޤ<br>
 *  Ĺĥ硤Ǥͤϥǥեͤޤ<br>
 *  Ĺ̤硤lenʹߤǤϺޤ<br>
 *  ֹ dim_index ǽоݤȤ뼡Ǥޤ
 *
 * @param      dim_index ֹ
 * @param      len ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::resize( size_t dim_index, size_t len )
{
    this->mdarray::resize(dim_index,len);
    return *this;
}

/**
 * @brief  Ĺѹ (¾֥Ȥ饳ԡ)
 *
 *  ȤμĹ򡤥֥src ĤΤƱ礭ˤޤ
 *  Ĺĥ硤Ǥͤϥǥեͤޤ<br>
 *  Ĺ̤硤ĹʤʬǤϺޤ<br>
 *
 * @param     src ĹΥԡ
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::resize( const mdarray &src )
{
    debug_report("(const mdarray &src)");
    this->mdarray::resize(src);
    return *this;
}

/* change the length of the 1-d array */
/**
 * @brief  Ĺѹ (1)
 *
 *  ȤĹѹĹ x_len 1Ȥޤ
 */
mdarray_fcomplex &mdarray_fcomplex::resize_1d( size_t x_len )
{
    this->mdarray::resize_1d(x_len);
    return *this;
}

/* change the length of the 2-d array */
/**
 * @brief  Ĺѹ (2)
 *
 *  ȤĹѹĹ (x_len, y_len) 2Ȥޤ
 */
mdarray_fcomplex &mdarray_fcomplex::resize_2d( size_t x_len, size_t y_len )
{
    this->mdarray::resize_2d(x_len, y_len);
    return *this;
}

/* change the length of the 3-d array */
/**
 * @brief  Ĺѹ (3)
 *
 *  ȤĹѹĹ (x_len, y_len, z_len) 3
 *  ޤ
 */
mdarray_fcomplex &mdarray_fcomplex::resize_3d( size_t x_len, size_t y_len, size_t z_len )
{
    this->mdarray::resize_3d(x_len, y_len, z_len);
    return *this;
}

/**
 * @brief  Ĺѹ (ʣμ)
 *
 *  ȤĹѹޤ<br>
 *  Ĺĥ硤Ǥͤǥեͤ뤫ɤ init_buf 
 *  Ǥޤ<br>
 *  Ĺ̤硤ĹʤʬǤϺޤ<br>
 *
 * @param     naxisx[] Ƽǿ
 * @param     ndim 󼡸
 * @param     init_buf Ĺγĥͤǥեͤʤ true
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ
 * @note      2ʾΥꥵξ硤㥳ȤǹԤʤޤ1ꥵ
 *            ʤ顤resize(dim_index, ...) 㥳ȤǤ
 */
mdarray_fcomplex &mdarray_fcomplex::resize( const size_t naxisx[], size_t ndim, bool init_buf )
{
    this->mdarray::resize(naxisx,ndim,init_buf);
    return *this;
}

/**
 * @brief  Ĺѹ (IDLεˡ)
 *
 *  ȤĹѹޤĹλϡprintf() βĹ
 *  ǽʥ޶ڤʸ(㤨"10,5")ˤäƹԤʤޤ<br>
 *  ꤵ줿ʸǤǤϤʤ硤μĹѹޤ
 *  㤨С ",2" ꤵ줿硤ǽμĹѹޤ
 *
 * @param  exp_fmt csvĹʸΤΥեޥåȻ
 * @param  ...     formatбĹγǥǡ
 * @throw  Хåեγݤ˼Ԥ
 */
mdarray_fcomplex &mdarray_fcomplex::resizef( const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vresizef(exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vresizef() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ĺѹ (IDLεˡ)
 *
 *  ȤĹѹޤĹλϡprintf() βĹ
 *  ǽʥ޶ڤʸ(㤨"10,5")ˤäƹԤʤޤ<br>
 *  ꤵ줿ʸǤǤϤʤ硤μĹѹޤ
 *  㤨С ",2" ꤵ줿硤ǽμĹѹޤ
 *
 * @param  exp_fmt csvĹʸΤΥեޥåȻ
 * @param  ap      formatбĹΥꥹ
 * @throw  Хåեγݤ˼Ԥ
 */
mdarray_fcomplex &mdarray_fcomplex::vresizef( const char *exp_fmt, va_list ap )
{
    this->mdarray::vresizef(exp_fmt,ap);
    return *this;
}

/**
 * @brief  ǽμˤĤĹŪѹ
 *
 *  ȤĹ len λʬĥ̾ޤ<br>
 *  resizeby() 󥵥ϡĹ len äΤȤʤޤ
 *  ν̾ϡlen ˥ޥʥͤꤹ뤳ȤˤäƹԤޤ<br>
 *  ˼ֹ 0 μ(1)оݤȤޤ
 *
 * @param      len ǸĿʬʬ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::resizeby( ssize_t len )
{
    this->mdarray::resizeby(len);
    return *this;
}

/**
 * @brief  Ǥդ1ĤμˤĤĹŪѹ
 *
 *  ȤĹ len λʬĥ̾ޤ<br>
 *  resizeby() 󥵥ϡĹ len äΤȤʤޤ
 *  ν̾ϡlen ˥ޥʥͤꤹ뤳ȤˤäƹԤޤ<br>
 *  ֹ dim_index ǽоݤȤ뼡Ǥޤ
 *
 * @param      dim_index ֹ
 * @param      len ǸĿʬʬ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::resizeby( size_t dim_index, ssize_t len )
{
    this->mdarray::resizeby(dim_index,len);
    return *this;
}

/* change the length of the 1-d array relatively */
/**
 * @brief  ĹŪѹ (1)
 */
mdarray_fcomplex &mdarray_fcomplex::resizeby_1d( ssize_t x_len )
{
    this->mdarray::resizeby_1d(x_len);
    return *this;
}

/* change the length of the 2-d array relatively */
/**
 * @brief  ĹŪѹ (2)
 */
mdarray_fcomplex &mdarray_fcomplex::resizeby_2d( ssize_t x_len, ssize_t y_len )
{
    this->mdarray::resizeby_2d(x_len, y_len);
    return *this;
}

/* change the length of the 3-d array relatively */
/**
 * @brief  ĹŪѹ (3)
 */
mdarray_fcomplex &mdarray_fcomplex::resizeby_3d(ssize_t x_len, ssize_t y_len, ssize_t z_len)
{
    this->mdarray::resizeby_3d(x_len, y_len, z_len);
    return *this;
}

/**
 * @brief  ĹŪѹ (ʣμ)
 *
 *  ȤĹ naxisx_rel[] λʬĥ̾ޤ<br>
 *  resizeby() 󥵥ϡĹ naxisx_rel[] ä
 *  Ȥʤޤν̾ϡnaxisx_rel[] ˥ޥʥͤꤹ뤳Ȥˤä
 *  Ԥޤ<br>
 *  init_buf ǥĥ˿˺Ǥν򤹤뤫ɤ
 *  Ǥޤ
 *
 * @param     naxisx_rel ǸĿʬʬ
 * @param     ndim naxisx_rel[] θĿ
 * @param     init_buf ˺ǤνԤʤ true
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ
 */
mdarray_fcomplex &mdarray_fcomplex::resizeby( const ssize_t naxisx_rel[], size_t ndim, 
			    bool init_buf )
{
    this->mdarray::resizeby(naxisx_rel,ndim,init_buf);
    return *this;
}

/**
 * @brief  ĹŪѹ (IDLεˡ)
 *
 *  ȤĹʬĥ̾ޤĹλϡprintf() 
 *  βĹǻǽʥ޶ڤʸ(㤨"10,-5")ˤäƹԤʤ
 *  ޤ<br>
 *  resizebyf()󥵥ϡĹ˻ʬäΤȤʤޤ
 *  ν̾ϡޥʥͤꤹ뤳ȤˤäƹԤޤ<br>
 *  ꤵ줿ʸǤǤϤʤ硤μĹѹޤ
 *  㤨С ",2" ꤵ줿硤ǽμĹѹޤ
 *
 * @param  exp_fmt csvĹʸΤΥեޥåȻ
 * @param  ...     formatбĹγǥǡ
 * @throw  Хåեγݤ˼Ԥ
 */
mdarray_fcomplex &mdarray_fcomplex::resizebyf( const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vresizebyf(exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vresizebyf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ĹŪѹ (IDLεˡ)
 *
 *  ȤĹʬĥ̾ޤĹλϡprintf() 
 *  βĹǻǽʥ޶ڤʸ(㤨"10,-5")ˤäƹԤʤ
 *  ޤ<br>
 *  resizebyf()󥵥ϡĹ˻ʬäΤȤʤޤ
 *  ν̾ϡޥʥͤꤹ뤳ȤˤäƹԤޤ<br>
 *  ꤵ줿ʸǤǤϤʤ硤μĹѹޤ
 *  㤨С ",2" ꤵ줿硤ǽμĹѹޤ
 *
 * @param  exp_fmt csvĹʸΤΥեޥåȻ
 * @param  ap      formatбĹΥꥹ
 * @throw  Хåեγݤ˼Ԥ
 */
mdarray_fcomplex &mdarray_fcomplex::vresizebyf( const char *exp_fmt, va_list ap )
{
    this->mdarray::vresizebyf(exp_fmt,ap);
    return *this;
}

/* change length of array without adjusting buffer contents */
/**
 * @brief  ΥХåե֤Ĵ򤻤ˡѥХåեƳ
 *
 *  ΥХåե֤Ĵ򤻤ˡȤļ礭Ĺ
 *  ѹޤĤޤꡤѥХåեФƤñrealloc()Ƥ֤ν
 *  Ԥʤޤ
 *
 * @param     naxisx[] Ƽǿ
 * @param     ndim 󼡸
 * @param    init_buf ˳ݤʬͤǥեͤʤ true
 * @throw     Хåեγݤ˼Ԥ
 */
mdarray_fcomplex &mdarray_fcomplex::reallocate( const size_t naxisx[], size_t ndim, bool init_buf )
{
    this->mdarray::reallocate(naxisx,ndim,init_buf);
    return *this;
}

/* free current buffer and alloc new memory */
/**
 * @brief  ѥХåեö˳
 *
 *  Ƥö˴ĹѹޤĤޤꡤѥХåե
 *  Ф free()malloc() Ƥ֤νԤʤޤ
 *
 * @param    naxisx[] Ƽǿ
 * @param    ndim 󼡸
 * @param    init_buf ˳ݤʬͤǥեͤʤ true
 * @throw    Хåեγݤ˼Ԥ
 */
mdarray_fcomplex &mdarray_fcomplex::allocate( const size_t naxisx[], size_t ndim, bool init_buf )
{
    this->mdarray::allocate(naxisx,ndim,init_buf);
    return *this;
}

/**
 * @brief  ĥνͤ
 *
 *  󥵥ĥνͤꤷޤꤵ줿ͤϴ¸Ǥˤ
 *  ѤĥͭȤʤޤ
 *
 * @param     value 󥵥ĥν
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::assign_default( fcomplex value )
{
    this->mdarray::assign_default((const void *)&value);
    return *this;
}

/**
 * @brief  ǽμˤĤƿǤ
 *
 *  Ȥǰ idx ˡlen ʬǤޤʤ
 *  ǤͤϥǥեͤǤ<br>
 *  ˼ֹ 0 μ(1)оݤȤޤ
 *
 * @param      idx ֹ֤
 * @param      len ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::insert( ssize_t idx, size_t len )
{
    this->mdarray::insert(idx,len);
    return *this;
}

/**
 * @brief  Ǥդ1ĤμˤĤƿǤ
 *
 *  Ȥǰ idx ˡlen ʬǤޤʤ
 *  ǤͤϥǥեͤǤ<br>
 *  ֹ dim_index ǽоݤȤ뼡Ǥޤ
 *
 * @param      dim_index ֹ
 * @param      idx ֹ֤
 * @param      len ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::insert( size_t dim_index, ssize_t idx, size_t len )
{
    this->mdarray::insert(dim_index,idx,len);
    return *this;
}

/**
 * @brief  ǽμˤĤǤκ
 *
 *  Ȥ󤫤ꤵ줿ʬǤޤʬĹûʤ
 *  ޤ<br>
 *  ˼ֹ 0 μ(1)оݤȤޤ.
 *
 * @param      idx ϰֹ֤
 * @param      len ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::erase( ssize_t idx, size_t len )
{
    this->mdarray::erase(idx,len);
    return *this;
}

/**
 * @brief  Ǥդ1ĤμˤĤǤκ
 *
 *  Ȥ󤫤ꤵ줿ʬǤޤʬĹûʤ
 *  ޤ<br>
 *  ֹ dim_index ǽоݤȤ뼡Ǥޤ
 *
 * @param      dim_index ֹ
 * @param      idx ϰֹ֤
 * @param      len ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::erase( size_t dim_index, ssize_t idx, size_t len )
{
    this->mdarray::erase(dim_index,idx,len);
    return *this;
}

/**
 * @brief  ǽμˤĤǴ֤ǤͤΥԡ
 *
 * ȤǴ֤ͤ򥳥ԡޤ<br>
 *  clr  false ꤵ줿ϥԡͤϻĤޤtrue 
 * 줿ϥԡͤϻĤ餺ǥեͤޤ<br>
 * idx_dst ˴¸Ĺ礭ͤꤷƤ⡤󥵥Ѥޤ
 *  cpy() дؿȤϰۤʤޤ<br>
 * ˼ֹ 0 μ(1)оݤȤޤ
 *
 * @param      idx_src ԡֹ
 * @param      len ԡǤĹ
 * @param      idx_dst ԡֹ
 * @param      clr ԡͤΥꥢ
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::move( ssize_t idx_src, size_t len, ssize_t idx_dst,
			   bool clr )
{
    this->mdarray::move(idx_src,len,idx_dst,clr);
    return *this;
}

/**
 * @brief  Ǥդ1ĤμˤĤǴ֤ǤͤΥԡ
 *
 *  ȤǴ֤ͤ򥳥ԡޤ<br>
 *   clr  false ꤵ줿ϥԡͤϻĤޤtrue 
 *  줿ϥԡͤϻĤ餺ǥեͤޤ<br>
 *  idx_dst ˴¸Ĺ礭ͤꤷƤ⡤󥵥Ѥޤ
 *   cpy() дؿȤϰۤʤޤ<br>
 *  ֹ dim_index ǽоݤȤ뼡Ǥޤ
 *
 * @param      dim_index ֹ
 * @param      idx_src ԡֹ
 * @param      len ԡǤĹ
 * @param      idx_dst ԡֹ
 * @param      clr ԡͤΥꥢ
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::move( size_t dim_index, 
			   ssize_t idx_src, size_t len, ssize_t idx_dst,
			   bool clr )
{
    this->mdarray::move(dim_index,idx_src,len,idx_dst,clr);
    return *this;
}

/**
 * @brief  ǽμˤĤǴ֤ǤͤΥԡ (ϼưĥ)
 *
 *  ȤǴ֤ͤ򥳥ԡޤ<br>
 *   clr  false ꤵ줿ϥԡͤϻĤޤtrue 
 *  줿ϥԡͤϻĤ餺ǥեͤޤ<br>
 *  idx_dst + len ¸Ĺ礭硤󥵥ϼưĥ
 *  <br>
 *  ˼ֹ 0 μ(1)оݤȤޤ
 *
 * @param      idx_src ԡֹ
 * @param      len ԡǤĹ
 * @param      idx_dst ԡֹ
 * @param      clr ԡͤΥꥢ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::cpy( ssize_t idx_src, size_t len, ssize_t idx_dst,
			  bool clr )
{
    this->mdarray::cpy(idx_src,len,idx_dst,clr);
    return *this;
}

/**
 * @brief  Ǥդ1ĤμˤĤǴ֤ǤͤΥԡ (ϼưĥ)
 *
 *  ȤǴ֤ͤ򥳥ԡޤ<br>
 *   clr  false ꤵ줿ϥԡͤϻĤޤtrue 
 *  줿ϥԡͤϻĤ餺ǥեͤޤ<br>
 *  idx_dst + len ¸Ĺ礭硤󥵥ϼưĥ
 *  <br>
 *  ֹ dim_index ǽоݤȤ뼡Ǥޤ
 *
 * @param      dim_index ֹ
 * @param      idx_src ԡֹ
 * @param      len ԡǤĹ
 * @param      idx_dst ԡֹ
 * @param      clr ԡͤΥꥢ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::cpy( size_t dim_index, 
			  ssize_t idx_src, size_t len, ssize_t idx_dst,
			  bool clr )
{
    this->mdarray::cpy(dim_index,idx_src,len,idx_dst,clr);
    return *this;
}

/**
 * @brief  ǽμˤĤǴ֤Ǥͤ촹
 *
 *  ȤǴ֤ͤؤޤ<br>
 *  ֹ idx_src  len ʬǤֹ idx_dst  len ʬ
 *  Ǥؤޤ<br>
 *  idx_dst + len 󥵥Ķϡ󥵥ޤǤνԤ
 *  ؤΰ褬Ťʤä硤ŤʤäƤʤ src ΰФƤΤ
 *  ؤԤޤ
 *
 * @param      idx_src ؤֹ
 * @param      len ؤǤĹ
 * @param      idx_dst ؤֹ
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::swap( ssize_t idx_src, size_t len, ssize_t idx_dst )
{

    this->mdarray::swap(idx_src,len,idx_dst);
    return *this;
}

/**
 * @brief  Ǥդ1ĤμˤĤǴ֤Ǥͤ촹
 *
 *  ȤǴ֤ͤؤޤ<br>
 *  ֹ dim_index ֹ idx_src  len ʬǤֹ 
 *  idx_dst  len ʬǤؤޤ<br>
 *  idx_dst + len 󥵥Ķϡ󥵥ޤǤνԤ
 *  ؤΰ褬Ťʤä硤ŤʤäƤʤ src ΰФƤΤ
 *  ؤԤޤ
 *
 * @param      dim_index ֹ
 * @param      idx_src ؤֹ
 * @param      len ؤǤĹ
 * @param      idx_dst ؤֹ
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::swap( size_t dim_index, 
		      ssize_t idx_src, size_t len, ssize_t idx_dst )
{
    this->mdarray::swap(dim_index,idx_src,len,idx_dst);
    return *this;
}

/**
 * @brief  ǽμˤĤʬξõ
 *
 *  Ȥǰ idx  len ĤǤˤޤ<br>
 *  ˼ֹ 0 μ(1)оݤȤޤ
 *
 * @param      idx ڤФϰֹ֤
 * @param      len ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::crop( ssize_t idx, size_t len )
{
    this->mdarray::crop(idx,len);
    return *this;
}

/**
 * @brief  Ǥդ1ĤμˤĤʬξõ
 *
 *  Ȥǰ idx  len ĤǤˤޤ<br>
 *  ֹ dim_index ǽоݤȤ뼡Ǥޤ
 *
 * @param      dim_index ֹ
 * @param      idx ڤФϰֹ֤
 * @param      len ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::crop( size_t dim_index, ssize_t idx, size_t len )
{
    this->mdarray::crop(dim_index,idx,len);
    return *this;
}

#if 0
/* crop(), vcrop() : ̤ */
/**
 *
 * @deprecated ̤Ǥ.
 */
mdarray_fcomplex &mdarray_fcomplex::cropf( const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vcropf(exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vcropf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 *
 * @deprecated ̤Ǥ.
 */
mdarray_fcomplex &mdarray_fcomplex::vcropf( const char *exp_fmt, va_list ap )
{
    this->mdarray::vcropf(exp_fmt,ap);
    return *this;
}
#endif	/* 0 */

/**
 * @brief  ǽμˤĤ¤Ӥȿž
 *
 *  Ȥǰ idx  len ĤǤȿžޤ<br>
 *  ˼ֹ 0 μ(1)оݤȤޤ
 *
 * @param     idx ϰֹ֤
 * @param     len ǤθĿ
 * @return    Ȥλ
 */
mdarray_fcomplex &mdarray_fcomplex::flip( ssize_t idx, size_t len )
{
    this->mdarray::flip(idx,len);
    return *this;
}

/**
 * @brief  Ǥդ1ĤμˤĤ¤Ӥȿž
 *
 *  Ȥǰ idx  len ĤǤȿžޤ<br>
 *  ֹ dim_index ǽоݤȤ뼡Ǥޤ
 *
 * @param     dim_index ֹ
 * @param     idx ϰֹ֤
 * @param     len ǤθĿ
 * @return    Ȥλ
 */
mdarray_fcomplex &mdarray_fcomplex::flip( size_t dim_index, ssize_t idx, size_t len )
{
    this->mdarray::flip(dim_index,idx,len);
    return *this;
}


/* 
 * member functions for image processing using IDL style argument 
 * such as "0:99,*".  The expression is set to exp_fmt argument in 
 * member functions.
 *
 * Number of dimension in the expression is unlimited.
 * Note that integer numbers in the string is 0-indexed. 
 *
 * [example]
 *   array1 = array0.sectionf("0:99,*");
 *   array1 = array0.sectionf("%ld:%ld,*", begin, end);
 *
 * Flipping elements in dimensions is supported in sectionf(), copyf(),
 * trimf(), and flipf().  Here is an example to perform flipping elements
 * in first 2 dimensions:
 *   array1 = array0.sectionf("99:0,-*");
 * 
 */

/**
 * @brief  Ǥ̥֥Ȥإԡ (IDLεˡ)
 *
 *  ǡΥдؿǡȤƤΰʬꤵ줿֥
 *   dest_obj إԡޤ<br>
 *  ԡϰϤǤդμޤǻǽ "0:99,*" Τ褦 IDL  IRAF 
 *  Ʊͤʸǻꤷޤʸֹ 0-indexed Ǥ<br>
 *  ԡؤϡͤȥԡηǥե͡ݤե饰°
 *  ɤ٤Ƥ򥳥ԡޤ(ԡ) ϲѤޤ<br>
 *  dest_obj ˼ȤͿ硤trimf()¹ԤƱ̤ˤʤޤ
 *
 * @param  dest_obj ԡΥ֥
 * @param  exp_fmt  csvϰϻʸΤΥեޥåȻ
 * @param  ...      exp_fmtбĹγǥǡ
 * @return    ԡǿ(  Կ  쥤  ...)
 * @throw     Хåեγݤ˼Ԥ硥˲򵯤硥
 */
ssize_t mdarray_fcomplex::copyf( mdarray *dest_obj, const char *exp_fmt, ... ) const
{
    ssize_t ret;
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	ret = this->mdarray::vcopyf(dest_obj, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vcopyf() failed");
    }
    va_end(ap);
    return ret;
}

/**
 * @brief  Ǥ̥֥Ȥإԡ (IDLεˡ)
 *
 *  ǡΥдؿǡȤƤΰʬꤵ줿֥
 *   dest_obj إԡޤ<br>
 *  ԡϰϤǤդμޤǻǽ "0:99,*" Τ褦 IDL  IRAF 
 *  Ʊͤʸǻꤷޤʸֹ 0-indexed Ǥ<br>
 *  ԡؤϡͤȥԡηǥե͡ݤե饰°
 *  ɤ٤Ƥ򥳥ԡޤ(ԡ) ϲѤޤ<br>
 *  dest_obj ˼ȤͿ硤trimf()¹ԤƱ̤ˤʤޤ
 *
 * @param  dest_obj ԡΥ֥
 * @param  exp_fmt  csvϰϻʸΤΥեޥåȻ
 * @param  ap       exp_fmtбĹΥꥹ
 * @return    ԡǿ(  Կ  쥤  ...)
 * @throw     Хåեγݤ˼Ԥ硥˲򵯤硥
 */
ssize_t mdarray_fcomplex::vcopyf( mdarray *dest_obj, const char *exp_fmt, va_list ap ) const
{
    return this->mdarray::vcopyf(dest_obj, exp_fmt, ap);
}

/* copy an convet all or a section to another mdarray object */
/* Flipping elements is supported                            */
/* [not implemented] */
/**
 * @brief  ȤΰǤѴ֤ (IDLεˡ)
 * @deprecated  ̤
 */
ssize_t mdarray_fcomplex::convertf_copy( mdarray *dest_obj, const char *exp_fmt, ... ) const
{
    ssize_t ret;
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	ret = this->mdarray::vconvertf_copy(dest_obj, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vconvertf_copy() failed");
    }
    va_end(ap);
    return ret;
}

/**
 * @brief  ȤΰǤѴ֤ (IDLεˡ)
 * @deprecated  ̤
 */
ssize_t mdarray_fcomplex::vconvertf_copy( mdarray *dest_obj, const char *exp_fmt, va_list ap ) const
{
    return this->mdarray::vconvertf_copy(dest_obj, exp_fmt, ap);
}

/**
 * @brief  ʬʳǤξõ (ǡΥȥߥ󥰡IDLεˡ)
 *
 *  ǡΥдؿǡȤΤꤵ줿ʬĤ
 *  곰ʬõޤ<br>
 *  ڤФ뤵ϰϤǤդμޤǻǽ "0:99,*" Τ褦 IDL 
 *  IRAF Ʊͤʸǻꤷޤʸֹ 0-indexed Ǥ
 *
 * @param  exp_fmt  csvϰϻʸΤΥեޥåȻ
 * @param  ...      exp_fmtбĹγǥǡ
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex &mdarray_fcomplex::trimf( const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vtrimf(exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vtrimf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ʬʳǤξõ (ǡΥȥߥ󥰡IDLεˡ)
 *
 *  ǡΥдؿǡȤΤꤵ줿ʬĤ
 *  곰ʬõޤ<br>
 *  ڤФ뤵ϰϤǤդμޤǻǽ "0:99,*" Τ褦 IDL 
 *  IRAF Ʊͤʸǻꤷޤʸֹ 0-indexed Ǥ
 *
 * @param  exp_fmt  csvϰϻʸΤΥեޥåȻ
 * @param  ap       exp_fmtбĹΥꥹ
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex &mdarray_fcomplex::vtrimf( const char *exp_fmt, va_list ap )
{
    this->mdarray::vtrimf(exp_fmt, ap);
    return *this;
}

/* flip elements in a section specified by IDL-style expression */
/**
 * @brief  Ǥդμ(ʣ)¤Ӥȿž (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::flipf( const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vflipf(exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vflipf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ǥդμ(ʣ)¤Ӥȿž (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vflipf( const char *exp_fmt, va_list ap )
{
    this->mdarray::vflipf(exp_fmt, ap);
    return *this;
}

/**
 * @brief  (x,y)Υȥ󥹥ݡԤʤä (IDLεˡ)
 */
ssize_t mdarray_fcomplex::transposef_xy_copy( mdarray *dest_obj, const char *exp_fmt, ... ) const
{
    ssize_t ret;
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	ret = this->mdarray::vtransposef_xy_copy(dest_obj, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vtransposef_xy_copy() failed");
    }
    va_end(ap);
    return ret;
}

/**
 * @brief  (x,y)Υȥ󥹥ݡԤʤä (IDLεˡ)
 */
ssize_t mdarray_fcomplex::vtransposef_xy_copy( mdarray *dest_obj, const char *exp_fmt, va_list ap ) const
{
    return this->mdarray::vtransposef_xy_copy(dest_obj, exp_fmt, ap);
}

/**
 * @brief  (x,y,z)(z,x,y)Υȥ󥹥ݡԤʤä (IDLεˡ)
 */
ssize_t mdarray_fcomplex::transposef_xyz2zxy_copy( mdarray *dest_obj, const char *exp_fmt, ... ) const
{
    ssize_t ret;
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	ret = this->mdarray::vtransposef_xyz2zxy_copy(dest_obj, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vtransposef_xyz2zxy_copy() failed");
    }
    va_end(ap);
    return ret;
}

/**
 * @brief  (x,y,z)(z,x,y)Υȥ󥹥ݡԤʤä (IDLεˡ)
 */
ssize_t mdarray_fcomplex::vtransposef_xyz2zxy_copy( mdarray *dest_obj, const char *exp_fmt, va_list ap ) const
{
    return this->mdarray::vtransposef_xyz2zxy_copy(dest_obj, exp_fmt, ap);
}

/* padding existing values in an array */
/**
 * @brief  Ȥǥեͤǥѥǥ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::cleanf( const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vcleanf(exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vcleanf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥǥեͤǥѥǥ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vcleanf( const char *exp_fmt, va_list ap )
{
    this->mdarray::vcleanf(exp_fmt, ap);
    return *this;
}

/* rewrite element values with a value in a section */
/**
 * @brief  Ȥꤵ줿顼ͤǽ񤭴 (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::fillf( double value, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vfillf(value, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vfillf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥꤵ줿顼ͤǽ񤭴 (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vfillf( double value, const char *exp_fmt, va_list ap )
{
    this->mdarray::vfillf(value, exp_fmt, ap);
    return *this;
}

/* rewrite element values with a value in a section */
/**
 * @brief  Ȥ򥹥顼ͤǽ񤭴 (桼ؿͳIDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::fillf_via_udf( double value, 
	void (*func)(double [],double,size_t, ssize_t,ssize_t,ssize_t,mdarray_fcomplex *,void *),
        void *user_ptr, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vfillf_via_udf(value, 
		(void (*)(double [],double,size_t, ssize_t,ssize_t,ssize_t,mdarray *,void *))func,
		user_ptr, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vfillf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥ򥹥顼ͤǽ񤭴 (桼ؿͳIDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vfillf_via_udf( double value, 
	void (*func)(double [],double,size_t, ssize_t,ssize_t,ssize_t,mdarray_fcomplex *,void *),
        void *user_ptr, const char *exp_fmt, va_list ap )
{
    this->mdarray::vfillf_via_udf(value, 
	(void (*)(double [],double,size_t, ssize_t,ssize_t,ssize_t,mdarray *,void *))func,
	user_ptr, exp_fmt, ap);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿顼ͤǲû (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::addf( double value, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vaddf(value, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vaddf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿顼ͤǲû (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vaddf( double value, const char *exp_fmt, va_list ap )
{
    this->mdarray::vaddf(value, exp_fmt, ap);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿顼ͤǸ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::subtractf( double value, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vsubtractf(value, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vsubtractf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿顼ͤǸ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vsubtractf( double value, const char *exp_fmt, va_list ap )
{
    this->mdarray::vsubtractf(value, exp_fmt, ap);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿顼ͤ軻 (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::multiplyf( double value, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vmultiplyf(value, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vmultiplyf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿顼ͤ軻 (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vmultiplyf( double value, const char *exp_fmt, va_list ap )
{
    this->mdarray::vmultiplyf(value, exp_fmt, ap);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿顼ͤǽ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::dividef( double value, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vdividef(value, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vdividef() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿顼ͤǽ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vdividef( double value, const char *exp_fmt, va_list ap )
{
    this->mdarray::vdividef(value, exp_fmt, ap);
    return *this;
}

/**
 * @brief  Ȥ˻ꤵ줿֥ȤŽդ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::pastef( const mdarray &src, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vpastef(src, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vpastef() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥ˻ꤵ줿֥ȤŽդ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vpastef( const mdarray &src, const char *exp_fmt, va_list ap )
{
    this->mdarray::vpastef(src, exp_fmt, ap);
    return *this;
}

/**
 * @brief  Ȥ˻ꤵ줿Žդ (桼ؿͳIDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::pastef_via_udf( const mdarray &src,
	void (*func)(double [],double [],size_t, ssize_t,ssize_t,ssize_t,mdarray_fcomplex *,void *),
	void *user_ptr,
        const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vpastef_via_udf(src, 
	       (void (*)(double [],double [],size_t, ssize_t,ssize_t,ssize_t,mdarray *,void *))func, user_ptr, 
		exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vpastef() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥ˻ꤵ줿Žդ (桼ؿͳIDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vpastef_via_udf( const mdarray &src,
	void (*func)(double [],double [],size_t, ssize_t,ssize_t,ssize_t,mdarray_fcomplex *,void *),
	void *user_ptr,
        const char *exp_fmt, va_list ap )
{
    this->mdarray::vpastef_via_udf(src, 
	(void (*)(double [],double [],size_t, ssize_t,ssize_t,ssize_t,mdarray *,void *))func, user_ptr, 
	exp_fmt, ap);
    return *this;
}

/* add an array object */
/**
 * @brief  Ȥˡꤵ줿֥Ȥû (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::addf( const mdarray &src, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vaddf(src, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vaddf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿֥Ȥû (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vaddf( const mdarray &src, const char *exp_fmt, va_list ap )
{
    this->mdarray::vaddf(src, exp_fmt, ap);
    return *this;
}

/* subtract an array object */
/**
 * @brief Ȥ򡤻ꤵ줿֥ȤǸ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::subtractf( const mdarray &src, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vsubtractf(src, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vsubtractf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief Ȥ򡤻ꤵ줿֥ȤǸ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vsubtractf( const mdarray &src, const char *exp_fmt, va_list ap )
{
    this->mdarray::vsubtractf(src, exp_fmt, ap);
    return *this;
}

/* multiply an array object */
/**
 * @brief  Ȥˡꤵ줿֥Ȥ軻 (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::multiplyf( const mdarray &src, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vmultiplyf(src, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vmultiplyf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿֥Ȥ軻 (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vmultiplyf( const mdarray &src, const char *exp_fmt, va_list ap )
{
    this->mdarray::vmultiplyf(src, exp_fmt, ap);
    return *this;
}

/* divide an array object */
/**
 * @brief  Ȥ򡤻ꤵ줿֥Ȥǽ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::dividef( const mdarray &src, const char *exp_fmt, ... )
{
    va_list ap;
    va_start(ap, exp_fmt);
    try {
	this->mdarray::vdividef(src, exp_fmt, ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","vdividef() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿֥Ȥǽ (IDLεˡ)
 */
mdarray_fcomplex &mdarray_fcomplex::vdividef( const mdarray &src, const char *exp_fmt, va_list ap )
{
    this->mdarray::vdividef(src, exp_fmt, ap);
    return *this;
}


/* 
 * member functions for image processing
 */


/**
 * @brief  Ǥ̥֥Ȥإԡ
 *
 *  ǡΥдؿǡȤƤΰʬꤵ줿֥
 *   dest إԡޤ<br>
 *  ԡؤϡͤȥԡηǥե͡ݤե饰°
 *  ɤ٤Ƥ򥳥ԡޤ(ԡ) ϲѤޤ<br>
 *  dest_obj ˼ȤͿ硤trim()¹ԤƱ̤ˤʤޤ
 *
 * @param      dest ԡΥ֥
 * @param      col_idx ԡ
 * @param      col_len ԡ󥵥
 * @param      row_idx ԡι԰
 * @param      row_len ԡιԥ
 * @param      layer_idx ԡΥ쥤
 * @param      layer_len ԡΥ쥤䥵
 * @return     ԡǿ
 * @throw      Хåեγݤ˼Ԥ硥˲򵯤硥
 *
 */
ssize_t mdarray_fcomplex::copy( mdarray *dest,
			     ssize_t col_idx, size_t col_len,
			     ssize_t row_idx, size_t row_len, 
			     ssize_t layer_idx, size_t layer_len ) const
{
    debug_report("( mdarray *dest, ssize_t, ... )");
    return this->mdarray::copy(dest, col_idx,col_len,
			       row_idx, row_len, 
			       layer_idx, layer_len);
}

/* convert and copy the value of selected array element. */
/* [not implemented] */
/**
 * @brief  ȤΰǤѴ֤
 * @deprecated  ̤
 */
ssize_t mdarray_fcomplex::convert_copy( mdarray *dest,
				    ssize_t col_idx, size_t col_len,
				    ssize_t row_idx, size_t row_len, 
				    ssize_t layer_idx, size_t layer_len ) const
{
    debug_report("( mdarray *dest )");
    return this->mdarray::convert_copy(dest, col_idx, col_len,
				       row_idx, row_len, layer_idx, layer_len);
}

/* set a section to be copied by move_to() */
/**
 * @brief   move_to() ˤưΰλ
 */
mdarray_fcomplex &mdarray_fcomplex::move_from(ssize_t col_idx, size_t col_len,
					  ssize_t row_idx, size_t row_len, 
					  ssize_t layer_idx, size_t layer_len)
{
    this->mdarray::move_from(col_idx,col_len, row_idx,row_len,
			     layer_idx,layer_len);
    return *this;
}

/* copy a section specified by move_from() */
/**
 * @brief  move_from() ǻꤵ줿ΰΰư
 */
mdarray_fcomplex &mdarray_fcomplex::move_to( 
		       ssize_t dest_col, ssize_t dest_row, ssize_t dest_layer )
{
    this->mdarray::move_to(dest_col, dest_row, dest_layer);
    return *this;
}

/* trim a section */
/**
 * @brief  ʬʳǤξõ (ǡΥȥߥ)
 *
 *  ǡΥдؿǡȤΤꤵ줿ʬĤ
 *  곰ʬõޤ<br>
 *
 * @param     col_idx 
 * @param     col_len 󥵥
 * @param     row_idx ԰
 * @param     row_len ԥ
 * @param     layer_idx 쥤
 * @param     layer_len 쥤䥵
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ硥˲򵯤硥
 */
mdarray_fcomplex &mdarray_fcomplex::trim( ssize_t col_idx, size_t col_len,
				      ssize_t row_idx, size_t row_len, 
				      ssize_t layer_idx, size_t layer_len )
{
    this->mdarray::trim(col_idx,col_len, row_idx,row_len, layer_idx,layer_len);
    return *this;
}


/* flip horizontal within a rectangular section */
/**
 * @brief  οʿǤȿž
 *
 * Ȥλꤵ줿ϰϤǤˤĤơƤʿȿžޤ
 *
 * @param     col_idx 
 * @param     col_len 󥵥
 * @param     row_idx ԰
 * @param     row_len ԥ
 * @param     layer_idx 쥤
 * @param     layer_len 쥤䥵
 * @return    Ȥλ
 */
mdarray_fcomplex &mdarray_fcomplex::flip_cols( ssize_t col_idx, size_t col_len,
					  ssize_t row_idx, size_t row_len, 
					  ssize_t layer_idx, size_t layer_len )
{
    this->mdarray::flip_cols(col_idx,col_len, row_idx,row_len, 
			     layer_idx,layer_len);
    return *this;
}

/* flip vertical within a rectangular section */
/**
 * @brief  οľǤȿž
 *
 * Ȥλꤵ줿ϰϤǤˤĤơƤľȿžޤ
 *
 * @param     col_idx 
 * @param     col_len 󥵥
 * @param     row_idx ԰
 * @param     row_len ԥ
 * @param     layer_idx 쥤
 * @param     layer_len 쥤䥵
 * @return    Ȥλ
 */
mdarray_fcomplex &mdarray_fcomplex::flip_rows( ssize_t col_idx, size_t col_len,
					  ssize_t row_idx, size_t row_len, 
					  ssize_t layer_idx, size_t layer_len )
{
    this->mdarray::flip_rows(col_idx,col_len, row_idx,row_len, 
			     layer_idx,layer_len);
    return *this;
}

/* interchange rows and columns and copy */
/**
 * @brief  (x,y)Υȥ󥹥ݡԤʤä
 */
ssize_t mdarray_fcomplex::transpose_xy_copy( mdarray *dest,
				    ssize_t col_idx, size_t col_len,
				    ssize_t row_idx, size_t row_len, 
				    ssize_t layer_idx, size_t layer_len ) const
{
    return this->mdarray::transpose_xy_copy( (mdarray *)dest, 
				       col_idx, col_len, row_idx, row_len, 
				       layer_idx, layer_len );
}

/* interchange x and z and copy */
/**
 * @brief  (x,y,z)(z,x,y)Υȥ󥹥ݡԤʤä
 */
ssize_t mdarray_fcomplex::transpose_xyz2zxy_copy( mdarray *dest,
				    ssize_t col_idx, size_t col_len,
				    ssize_t row_idx, size_t row_len, 
				    ssize_t layer_idx, size_t layer_len ) const
{
    return this->mdarray::transpose_xyz2zxy_copy( (mdarray *)dest, 
				       col_idx, col_len, row_idx, row_len, 
				       layer_idx, layer_len );
}

/* rotate and copy a section to another mdarray object       */
/*   angle: 90,-90, or 180                                   */
/*          (anticlockwise when image is bottom-left origin) */
/**
 * @brief  (x,y)ǲž (ž90ñ)
 */
ssize_t mdarray_fcomplex::rotate_xy_copy( mdarray *dest, int angle,
				    ssize_t col_idx, size_t col_len,
				    ssize_t row_idx, size_t row_len, 
				    ssize_t layer_idx, size_t layer_len ) const
{
    return this->mdarray::rotate_xy_copy( (mdarray *)dest, angle, 
					  col_idx, col_len, row_idx, row_len, 
					  layer_idx, layer_len);
}


/**
 * @brief  Ȥǥեͤǥѥǥ
 *
 *  ȤǤǥեͤǥѥǥ󥰤ޤ<br>
 *  ϻꤷʤƤѤǤޤξϡǤоݤǤ
 *  clean() ¹ԤƤĹѲޤ<br>
 *  ǡΥдؿǤ<br>
 *
 * @param      col_index 
 * @param      col_size 󥵥
 * @param      row_index ԰
 * @param      row_size ԥ
 * @param      layer_index 쥤
 * @param      layer_size 쥤䥵
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::clean( ssize_t col_index, size_t col_size,
				       ssize_t row_index, size_t row_size,
				       ssize_t layer_index, size_t layer_size )
{
    this->mdarray::clean(col_index,col_size,row_index,row_size,
			 layer_index,layer_size);
    return *this;
}


/**
 * @brief  Ȥꤵ줿顼ͤǽ񤭴
 *
 *  Ȥλꤵ줿ϰϤǤ򡤻ꤵ줿ͤǽ񴹤ޤ<br>
 *  ǡΥдؿǤ
 *
 * @param      value 񤭹
 * @param      col_index 
 * @param      col_size 󥵥
 * @param      row_index ԰
 * @param      row_size ԥ
 * @param      layer_index 쥤
 * @param      layer_size 쥤䥵
 * @param      func Ѵΰ٤Υ桼ؿΥɥ쥹
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::fill( double value, 
			 ssize_t col_index, size_t col_size,
			 ssize_t row_index, size_t row_size,
			 ssize_t layer_index, size_t layer_size )
{
    debug_report("( double value, ssize_t ... )");
    this->mdarray::fill(value, col_index, col_size, 
			row_index, row_size, layer_index, layer_size);
    return *this;
}

/**
 * @brief  Ȥꤵ줿顼ͤǽ񤭴 (桼ؿͳ)
 *
 *  Ȥλꤵ줿ϰϤǤ򡤻ꤵ줿ͤȥ桼ؿͳǽ
 *  ޤ<br>
 *  桼ؿ func ΰˤϽˡȤ()value Ϳ줿
 *  ͡(ǽΰ)θĿ֡԰֡쥤֡ȤΥ֥
 *  Υɥ쥹桼ݥ user_ptr ͡Ϳޤ<br>
 *  ǡΥдؿǤ
 *
 * @param      value 񤭹
 * @param      func Ѵΰ٤Υ桼ؿΥɥ쥹
 * @param      user_ptr func κǸͿ桼Υݥ
 * @param      col_index 
 * @param      col_size 󥵥
 * @param      row_index ԰
 * @param      row_size ԥ
 * @param      layer_index 쥤
 * @param      layer_size 쥤䥵
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::fill_via_udf( double value, 
	void (*func)(double [],double,size_t, ssize_t,ssize_t,ssize_t,mdarray_fcomplex *,void *),
	void *user_ptr,
	ssize_t col_index, size_t col_size,
	ssize_t row_index, size_t row_size,
	ssize_t layer_index, size_t layer_size )
{
    debug_report("( double value, double (*func)() ... )");
    this->mdarray::fill_via_udf(value, 
			(void (*)(double [],double,size_t, ssize_t,ssize_t,ssize_t,mdarray *,void *))func,
			user_ptr, col_index, col_size,
			row_index, row_size,
			layer_index, layer_size);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿顼ͤǲû
 *
 *  Ȥλꤵ줿ϰϤǤ value ûޤ
 *  ǡΥдؿǤ
 *
 * @param      value û
 * @param      col_index 
 * @param      col_size 󥵥
 * @param      row_index ԰
 * @param      row_size ԥ
 * @param      layer_index 쥤
 * @param      layer_size 쥤䥵
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::add( double value, 
		    ssize_t col_index, size_t col_size,
		    ssize_t row_index, size_t row_size,
		    ssize_t layer_index, size_t layer_size )
{
    this->mdarray::add(value,col_index,col_size,row_index,row_size,
		       layer_index,layer_size);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿顼ͤǸ
 *
 *  Ȥλꤵ줿ϰϤǤ value 򸺻ޤ
 *  ǡΥдؿǤ
 *
 * @param      value 
 * @param      col_index 
 * @param      col_size 󥵥
 * @param      row_index ԰
 * @param      row_size ԥ
 * @param      layer_index 쥤
 * @param      layer_size 쥤䥵
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::subtract( double value, 
				       ssize_t col_index, size_t col_size,
				       ssize_t row_index, size_t row_size,
				       ssize_t layer_index, size_t layer_size )
{
    this->mdarray::subtract(value,col_index,col_size,row_index,row_size,
			    layer_index,layer_size);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿顼ͤ軻
 *
 * Ȥλꤵ줿ϰϤǤͤvalue 軻ޤ
 * ǡΥдؿǤ
 *
 * @param      value 軻
 * @param      col_index 
 * @param      col_size 󥵥
 * @param      row_index ԰
 * @param      row_size ԥ
 * @param      layer_index 쥤
 * @param      layer_size 쥤䥵
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::multiply( double value, 
		    ssize_t col_index, size_t col_size,
		    ssize_t row_index, size_t row_size,
		    ssize_t layer_index, size_t layer_size )
{
    this->mdarray::multiply(value,col_index,col_size,row_index,row_size,
			    layer_index,layer_size);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿顼ͤǽ
 *
 *  Ȥλꤵ줿ϰϤǤˤĤ value ǽޤ
 *  ǡΥдؿǤ
 *
 * @param      value 
 * @param      col_index 
 * @param      col_size 󥵥
 * @param      row_index ԰
 * @param      row_size ԥ
 * @param      layer_index 쥤
 * @param      layer_size 쥤䥵
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::divide( double value, 
				       ssize_t col_index, size_t col_size,
				       ssize_t row_index, size_t row_size,
				       ssize_t layer_index, size_t layer_size )
{
    this->mdarray::divide(value,col_index,col_size,row_index,row_size,
			  layer_index,layer_size);
    return *this;
}

/**
 * @brief  Ȥ˻ꤵ줿֥ȤŽդ
 *
 *  Ȥλꤵ줿ϰϤͤˡsrc ǻꤵ줿֥Ȥ
 *  ͤŽդޤ<br>
 *  ǡΥдؿǤ
 *
 * @param      src Ȥʤĥ֥
 * @param      dest_col 
 * @param      dest_row ԰
 * @param      dest_layer 쥤
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::paste( const mdarray &src,
	ssize_t dest_col, ssize_t dest_row, ssize_t dest_layer )
{
    debug_report("( const mdarray &src, ssize_t ... )");
    this->mdarray::paste(src,dest_col,dest_row,dest_layer);
    return *this;
}

/**
 * @brief  Ȥ˻ꤵ줿֥ȤŽդ (桼ؿͳ)
 *
 *  Ȥλꤵ줿ϰϤͤˡsrc ǻꤵ줿֥Ȥγ
 *  ͤ桼ؿͳŽդޤ桼ؿͿŽդ
 *  ưѤ뤳ȤǤޤ<br>
 *  桼ؿ func ΰˤϽˡȤ()֥ src 
 *  ()ǽ2ĤΰθĿ֡԰֡쥤֡
 *  Υ֥ȤΥɥ쥹桼ݥ user_ptr  Ϳޤ<br>
 *  ǡΥдؿǤ
 *
 * @param      src Ȥʤĥ֥
 * @param      func ѴΤΥ桼ؿΥɥ쥹
 * @param      user_ptr func κǸͿ桼Υݥ
 * @param      dest_col 
 * @param      dest_row ԰
 * @param      dest_layer 쥤
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::paste_via_udf( const mdarray &src,
	void (*func)(double [],double [],size_t,ssize_t,ssize_t,ssize_t,mdarray_fcomplex *,void *),
	void *user_ptr,
	ssize_t dest_col, ssize_t dest_row, ssize_t dest_layer )
{
    debug_report("( const mdarray &src, double (*func)() ... )");
    this->mdarray::paste_via_udf(src,
		(void (*)(double [],double [],size_t,ssize_t,ssize_t,ssize_t,mdarray *,void *))func,
		user_ptr,
		dest_col, dest_row, dest_layer);
    return *this;
}


/**
 * @brief  Ȥˡꤵ줿֥Ȥû
 *
 *  ȤǤ˥֥ src_img ûޤ
 *  󡦹ԡ쥤ˤĤƤ줾βûŬѳϰ֤Ǥޤ<br>
 *  ǡΥдؿǤ
 *
 * @param      src_img 黻˻Ȥĥ֥
 * @param      dest_col ûϰ()
 * @param      dest_row ûϰ()
 * @param      dest_layer ûϰ(쥤)
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::add( const mdarray &src_img,
	  ssize_t dest_col, ssize_t dest_row, ssize_t dest_layer )
{
    this->mdarray::add(src_img,dest_col,dest_row,dest_layer);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿֥ȤǸ
 *
 *  Ȥͤ饪֥ src_img ͤ򸺻ޤ
 *  󡦹ԡ쥤ˤĤƤ줾θŬѳϰ֤Ǥޤ<br>
 *  ǡΥдؿǤ
 *
 * @param      src_img 黻˻Ȥĥ֥
 * @param      dest_col ϰ()
 * @param      dest_row ϰ()
 * @param      dest_layer ϰ(쥤)
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::subtract( const mdarray &src_img,
	  ssize_t dest_col, ssize_t dest_row, ssize_t dest_layer )
{
    this->mdarray::subtract(src_img,dest_col,dest_row,dest_layer);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿֥Ȥ軻
 *
 *  Ȥͤ˥֥ src_img 軻ޤ
 *  󡦹ԡ쥤ˤĤƤ줾ξ軻Ŭѳϰ֤Ǥޤ<br>
 *  ǡΥдؿǤ
 *
 * @param      src_img 黻˻Ȥĥ֥
 * @param      dest_col 軻ϰ()
 * @param      dest_row 軻ϰ()
 * @param      dest_layer 軻ϰ(쥤)
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::multiply( const mdarray &src_img,
	  ssize_t dest_col, ssize_t dest_row, ssize_t dest_layer )
{
    this->mdarray::multiply(src_img,dest_col,dest_row,dest_layer);
    return *this;
}

/**
 * @brief  Ȥ򡤻ꤵ줿֥Ȥǽ
 *
 *  Ȥͤ饪֥ src_img ޤ
 *  󡦹ԡ쥤ˤĤƤ줾νŬѳϰ֤Ǥޤ<br>
 *  ǡΥдؿǤ
 *
 * @param      src_img 黻˻Ȥĥ֥
 * @param      dest_col ϰ()
 * @param      dest_row ϰ()
 * @param      dest_layer ϰ(쥤)
 * @return     Ȥλ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::divide( const mdarray &src_img,
	  ssize_t dest_col, ssize_t dest_row, ssize_t dest_layer )
{
    this->mdarray::divide(src_img,dest_col,dest_row,dest_layer);
    return *this;
}


/**
 * @brief  桼ΥݥѿϿ
 *
 *  桼Υݥѿ򥪥֥ȤϿޤ<br>
 *  ΥдؿȤäƥ桼ΥݥѿΥɥ쥹ϿС֥
 *  ȤХåեƬɥ쥹˥桼Υݥѿݻ
 *  Ǥޤ
 *
 * @param   extptr_address 桼ΥݥѿΥɥ쥹
 * @return  Ȥλ
 * @note    Ϳˡݥѿˡ&פĤΤ˺ʤ褦
 *          ޤ礦
 * @attention  桼ΥݥѿϿ shallow copy ǽʤʤ
 *             ޤ
 */
mdarray_fcomplex &mdarray_fcomplex::register_extptr( fcomplex **extptr_address )
{
    this->mdarray::register_extptr((void *)extptr_address);
    return *this;
}

/**
 * @brief  桼Υݥѿ(2d)Ͽ
 *
 *  桼Υݥѿ(2d)򥪥֥ȤϿޤ<br>
 *  ΥдؿȤäƥ桼ΥݥѿΥɥ쥹ϿС֥
 *  Ȥ륢ɥ쥹ơ֥Ƭɥ쥹˥桼Υݥѿˤ
 *  ݻƤǤޤ
 *
 * @param   extptr2d_address 桼ΥݥѿΥɥ쥹
 * @return  Ȥλ
 * @note    Ϳˡݥѿˡ&פĤΤ˺ʤ褦
 *          ޤ礦
 * @attention  桼ΥݥѿϿ shallow copy ǽʤʤ
 *             ޤ
 */
mdarray_fcomplex &mdarray_fcomplex::register_extptr_2d( fcomplex *const **extptr2d_address )
{
    this->mdarray::register_extptr_2d((void *)extptr2d_address);
    return *this;
}

/**
 * @brief  桼Υݥѿ(3d)Ͽ
 *
 *  桼Υݥѿ(3d)򥪥֥ȤϿޤ<br>
 *  ΥдؿȤäƥ桼ΥݥѿΥɥ쥹ϿС֥
 *  Ȥ륢ɥ쥹ơ֥Ƭɥ쥹˥桼Υݥѿˤ
 *  ݻƤǤޤ
 *
 * @param   extptr3d_address 桼ΥݥѿΥɥ쥹
 * @return  Ȥλ
 * @note    Ϳˡݥѿˡ&פĤΤ˺ʤ褦
 *          ޤ礦
 * @attention  桼ΥݥѿϿ shallow copy ǽʤʤ
 *             ޤ
 */
mdarray_fcomplex &mdarray_fcomplex::register_extptr_3d( fcomplex *const *const **extptr3d_address )
{
    this->mdarray::register_extptr_3d((void *)extptr3d_address);
    return *this;
}

/**
 * @brief  ХȥĴ
 *
 *  ΥдؿϡȤХʥǡȤƥե¸
 *  뤤ϥեΥХʥǡ򼫿Ȥ˼ߤ˻Ȥޤ
 *  (ܺ٤ reverse_endian( bool, size_t, size_t ) 򻲾)
 *
 * @param     is_little_endian 1 ܤνΥΥǥ
 * @return    Ȥλ
 * @note      ®ΤᡤSIMD̿ȤäƤޤ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::reverse_endian( bool is_little_endian )
{
    this->mdarray::reverse_byte_order(is_little_endian, 0, 0, this->length());
    return *this;
}

/**
 * @brief  ХȥĴ
 *
 * ΥдؿϡȤХʥǡȤƥե¸
 * 뤤ϥեΥХʥǡ򼫿Ȥ˼ߤ˻Ȥޤ<br>
 * ե˥ǡ¸ϡΥдؿƤӽФƥե¸Ŭ
 * ǥѴarray_ptr() дؿʤɤǼɥ쥹򥹥
 * ꡼񤭹ѤδؿͿƤ񤭹塤٤ΥдؿƤӽ
 * ơǥ򸵤ᤷޤ<br>
 * ե뤫ǡɤ߹ߤϡarray_ptr() дؿʤɤǼ
 * ɥ쥹򥹥ȥ꡼ɤ߼ѤδؿͿƤɤ߹塤Υдؿ
 * ƤӽФƽϤŬǥѴޤ<br>
 * 嵭Τξ⡤ե¸٤ǡӥåǥʤ
 * С1 false 򥻥åȤޤ(ȥ륨ǥʤ true Ǥ)<br>
 * ΥдؿϡϤˤäƻȤʬɬפȤʤʤ褦˺Ƥ
 * 㤨Сե˥ӥåǥΥǡ¸Τǡ
 * is_little_endian  false ꤷΥдؿƤӽФȤޤ
 * λޥ󤬥ӥåǥǤСºݤˤȿžϹԤޤ
 * (ޥ󤬥ȥ륨ǥǤСȿžԤޤ)
 * ˡ֥ΥХʥǡ򤽤Τޤޥե¸С
 * ꤵ줿ХȥΥХʥե뤬Ǥޤ
 * θ塤ƱǤΥдؿƤӽФơǥȿžƤ
 * ϸ᤹Ԥޤ<br>
 * äơեؤ¸˺ݤƤϡΥдؿƱǣƤӽФ
 * Ǥ
 *
 * @param     is_little_endian 1 ܤνΥΥǥ
 * @param     begin 򳫻Ϥֹ
 * @param     length оݤȤʤĹ
 * @return    Ȥλ
 * @note      ®ΤᡤSIMD̿ȤäƤޤ
 *
 */
mdarray_fcomplex &mdarray_fcomplex::reverse_endian( bool is_little_endian, 
						size_t begin, size_t length )
{
    this->mdarray::reverse_byte_order(is_little_endian, 0, begin, length);
    return *this;
}

/* protected */

/**
 * @brief  Ѿ饹ˤ롤ǥեȷ
 *
 *  Ȥ٤쥯饹(mdarray)ΥдؿΤޤ
 * 
 * @return   (: fcomplex)
 * @note    ΥдؿprotectedǤ
 */
ssize_t mdarray_fcomplex::default_size_type()
{
    return FCOMPLEX_ZT;
}

/**
 * @brief  Ѿ饹ˤ롤ǽʷ
 *
 *  뷿ɤ쥯饹(mdarray)ΥдؿΤޤ
 * 
 * @param   sz_type 
 * @return  ǽʷ(fcomplex)ʤ鿿
 * @note    ΥдؿprotectedǤ
 */
bool mdarray_fcomplex::is_acceptable_size_type( ssize_t sz_type )
{
    if ( sz_type == FCOMPLEX_ZT ) return true;
    else return false;
}

}	/* namespace */

#include "private/s_memset.cc"
#include "private/s_memmove.cc"

#undef CLASS_NAME

