#include <string.h>

#include "_test_sse2.h"

#ifdef _SSE2_IS_OK
#include <emmintrin.h>
#include "_tune_sse2.h"
#endif

/**
 * @brief  SIMD̿(SSE2)Ȥä® memcpy() ؿ
 *
 *    total_n Ϣ³ s_memcpy() Ϣ³ƻȤȡžХ
 *   Ĺꤹ롥SSE2 ͭʾΤưڤؤ˻Ѥ롥
 *   total_n  _SSE2_CPU_CACHE_SIZE ʾξ硤񤭹¦Ǥ CPU å
 *   Ѥʤ®ž⡼ɤڤؤ롥󤭤θƤӽФξ total_n
 *    0 ꤷƤɤ
 *
 * @param  dest 񤭹ХåեΥɥ쥹
 * @param  src ɤ߹߸ХåեΥɥ쥹
 * @param  n ԡԤʤХȿ
 * @param  total_n s_memcpy()Ϣ³ƸƤӽФΥȡΥХȿ
 * @note  4ĤΰƤӽФˤͤn Ѳ褦ʾ
 *        ˺Τ total_n Ȥ
 */
inline static void *s_memcpy( void *dest, const void *src, size_t n,
			      size_t total_n )
{
    unsigned char *d_ptr = (unsigned char *)dest;
    const unsigned char *s_ptr = (const unsigned char *)src;

#ifdef _SSE2_IS_OK
    /* use SSE2 if n is large enough */
    if ( _SSE2_MIN_NBYTES <= n ) {
	const size_t n_bytes = n;
	const bool total_large = (_SSE2_CPU_CACHE_SIZE <= total_n);
	size_t mm;
	mm = ((size_t)d_ptr & 0x0f);
	if ( 0 < mm ) {		/* align with 16-byte for dest */
	    mm = (16 - mm);
	    n -= mm;
	    memcpy(d_ptr, s_ptr, mm);
	    d_ptr += mm;
	    s_ptr += mm;
	}
	if ( _SSE2_CPU_CACHE_SIZE <= n_bytes || total_large == true ) {
	    while ( 16 <= n ) {
		__m128i r0;
		n -= 16;
		r0 = _mm_loadu_si128((__m128i *)s_ptr);
		/* without polluting the cache */
		_mm_stream_si128((__m128i *)d_ptr, r0);
		d_ptr += 16;
		s_ptr += 16;
	    }
	}
	else {
	    while ( 16 <= n ) {
		__m128i r0;
		n -= 16;
		r0 = _mm_loadu_si128((__m128i *)s_ptr);
		_mm_store_si128((__m128i *)d_ptr, r0);
		d_ptr += 16;
		s_ptr += 16;
	    }
	}
    }
#endif	/* _SSE2_IS_OK */

    memcpy(d_ptr, s_ptr, n);

    return dest;
}
