/* -*- Mode: C++ ; Coding: euc-japan -*- */
/* Time-stamp: <2013-05-13 23:20:29 cyamauch> */

/**
 * @file  stdstreamio.cc
 * @brief ɸϤȥեΥȥ꡼򰷤 stdstreamio Υ
 */

#define CLASS_NAME "stdstreamio"

#include "config.h"

#include "stdstreamio.h"
#include <stdlib.h>
#include <sys/stat.h>
#include <assert.h>

#include "private/err_report.h"

#include "private/c_stdout.h"
#include "private/c_stdin.h"
#include "private/c_stderr.h"
#include "private/c_fopen.h"
#include "private/c_fclose.h"
#include "private/c_vfprintf.h"
#include "private/c_fflush.h"
#include "private/c_fileno.h"
#include "private/get_file_size.h"


namespace sli
{

/**
 * @brief  󥹥ȥ饯
 */
stdstreamio::stdstreamio()
{
    this->p_stdout = c_stdout();
    this->fp = this->p_stdout;
    return;
}

/**
 * @brief  󥹥ȥ饯
 *
 *  ɸϤΤɸ२顼ϤǥեȤνˤ˻Ȥޤ
 */
stdstreamio::stdstreamio(bool to_stderr)
{
    if ( to_stderr == true ) this->p_stdout = c_stderr();
    else this->p_stdout = c_stdout();
    this->fp = this->p_stdout;
    return;
}

/**
 * @brief  ǥȥ饯
 */
stdstreamio::~stdstreamio()
{
    this->close();
    if ( this->fp == this->p_stdout || this->fp == c_stdin() ) this->fp = NULL;
    return;
}

/* overridden member functions */

/**
 * @brief  ɸϤΥץ
 *
 *  ɸϤ򥪡ץ󤷤ޤ.<br>
 *  mode "r" ꤵ줿ɸϤ"w" ꤵ줿ɸϤ
 *  ץ󤷤ޤ.
 *
 * @param      mode ȥ꡼򳫤⡼ ("r" or "w")
 * @return     0<br>
 *             顼ξ
 * @throw      err_rec ɸϤΥե롦ǥץʣ˼Ԥ
 */
int stdstreamio::open( const char *mode )
{
    assert( mode != NULL );

    if ( this->fp == this->p_stdout || this->fp == c_stdin() ) this->fp = NULL;
    return this->cstreamio::open(mode);
}

/**
 * @brief  եΥץ
 *
 *  ե̾ꤷơȥ꡼򥪡ץ󤷤ޤ
 *
 * @param      mode ȥ꡼򳫤⡼ ("r" or "w")
 * @param      path   ե̾
 * @return     0<br>
 *             顼ξ
 * @throw      err_rec ɸϤΥե롦ǥץʣ˼Ԥ
 */
int stdstreamio::open( const char *mode, const char *path )
{
    assert( mode != NULL );

    int return_status = -1;
    struct stat st;

    if ( path == NULL ) return this->open(mode);

    if ( this->fp == this->p_stdout || this->fp == c_stdin() ) this->fp = NULL;
    if ( this->fp != NULL ) goto quit;
    this->fp = c_fopen(path,mode);
    if ( this->fp == NULL ) goto quit;

    if ( stat(path,&st) == 0 ) {
	if ( S_ISREG(st.st_mode) ) this->fp_seekable_rec = true;
    }

    return_status = 0;
 quit:
    return return_status;
}

/**
 * @brief  ǥץˤ륹ȥ꡼Υץ
 *
 *  ǥץꤷơȥ꡼򥪡ץ󤷤ޤ
 *
 * @param       mode ȥ꡼򳫤⡼ ("r" or "w")
 * @param       fd   եǥץ
 * @return      0<br>
 *              顼ξ
 */
int stdstreamio::open( const char *mode, int fd )
{
    assert( mode != NULL );

    if ( this->fp == this->p_stdout || this->fp == c_stdin() ) this->fp = NULL;
    return this->cstreamio::open(mode,fd);
}

/**
 * @brief  ȥ꡼Υ
 *
 *  open()ǳȥ꡼򥯥ޤ
 *
 * @return     0<br>
 *             顼ξ0ʳ
 */
int stdstreamio::close()
{
    int status = 0;
    if ( this->fp != NULL ) {
	if ( this->fp == this->p_stdout || this->fp == c_stdin() ) {
	    void *p_fp;
	    p_fp = this->fp;
	    this->fp = NULL;
	    this->cstreamio::close();
	    this->fp = p_fp;
	}
	else {
	    status = c_fclose(this->fp);
	    this->fp = NULL;
	    this->cstreamio::close();
	}
    }
    else this->cstreamio::close();

    return status;
}

/**
 * @brief  1ʸɤ߹
 *
 *  open()ǳȥ꡼फ鼡ʸɤ߹ߡint֤ޤ
 *
 * @return     ɤ߹ʸint˥㥹Ȥ<br>
 *             ȥ꡼νޤϥ顼ξEOF
 */
int stdstreamio::getchr()
{
    if ( this->fp == this->p_stdout ) this->fp = c_stdin();
    return this->cstreamio::getchr();
}

/**
 * @brief  ʸɤ߹
 *
 *  open() ǳȥ꡼फʸɤ߹ߡꤵ줿Хåե˳Ǽ
 *  <br>
 *  ɤ߹ߤ EOF ޤϲʸɤ߹ߤޤ
 *  ɤ߹ޤ줿ʸꤵ줿Хåե˳Ǽޤ
 *
 * @param      s ɤ߹ʸγǼ
 * @param      size ɤ߹ʸ
 * @return     ϳǼХåեΥɥ쥹<br>
 *             ȥ꡼νޤϥ顼ξNULL
 * @throw      ǡɤ߹Ѥΰγݤ˼Ԥ
 */
char *stdstreamio::getstr( char *s, size_t size )
{
    if ( this->fp == this->p_stdout ) this->fp = c_stdin();
    return this->cstreamio::getstr(s,size);
}

/**
 * @brief  ǡɤ߹
 *
 *  open()ǳȥ꡼फǡɤ߹ߡͿ줿˳Ǽޤ
 *
 * @param    buf ǡγǼ
 * @param    size ǡθĿ
 * @return   ϥХȿ<br>
 *           ȥ꡼बξ硤0ХȤɤ߹ߤꤵ줿0<br>
 *           顼ξ
 */
ssize_t stdstreamio::read( void *buf, size_t size )
{
    if ( this->fp == this->p_stdout ) this->fp = c_stdin();
    return this->cstreamio::read(buf,size);
}

/**
 * @brief  1ʸν񤭹
 *
 *  ꤵ줿ʸopen()ǳȥ꡼˽񤭹ߤޤ
 *
 * @param      c 񤭹ʸ
 * @return     Ͻ񤭹ޤ줿ʸint˥㥹Ȥ<br>
 *             顼ξEOF
 */
int stdstreamio::putchr( int c )
{
    if ( this->fp == c_stdin() ) this->fp = this->p_stdout;
    return this->cstreamio::putchr(c);
}

/**
 * @brief  ʸν񤭹
 *
 *  ꤵ줿ʸopen()ǳȥ꡼˽񤭹ߤޤ
 *
 * @param      s 񤭹ʸ
 * @return     ǤϤʤ<br>
 *             顼ξEOF
 */
int stdstreamio::putstr( const char *s )
{
    if ( this->fp == c_stdin() ) this->fp = this->p_stdout;
    return this->cstreamio::putstr(s);
}

/**
 * @brief  ǡν񤭹
 *
 *  ꤵ줿ǡopen()ǳȥ꡼˽񤭹ߤޤ
 *
 * @param      buf ǡγǼ
 * @param      size ǡθĿ
 * @return     ϥХȿ<br>
 *             顼ξ
 */
ssize_t stdstreamio::write( const void *buf, size_t size )
{
    if ( this->fp == c_stdin() ) this->fp = this->p_stdout;
    return this->cstreamio::write(buf,size);
}

/**
 * @brief  ɤФ(ǽʤ饷)
 *
 *  ɤ߹ѥȥ꡼Ф ǽǤ n ХȤΥԤʤޤ
 *  Ǥʤϡn ХȤɤФԤʤޤ
 *
 * @param   n Хȿ
 * @return  ϥХȿ<br>
 *          ȥ꡼बξ硤0ХȤɤ߹ߤꤵ줿0<br>
 *          顼ξ
 * @throw   ΰγݤ˼Ԥ
 */
ssize_t stdstreamio::rskip( size_t n )
{
    if ( this->fp == this->p_stdout ) this->fp = c_stdin();
    return this->cstreamio::rskip(n);
}

/**
 * @brief  Ф(ǽʤ饷)
 *
 *  񤭹ѥȥ꡼Ф ǽǤ n ХȤΥԤʤޤ
 *  Ǥʤϡn Хʬ饯 ch 񤭹ߤޤ
 *
 * @param      n Хȿ
 * @param      ch Ǥʤ˽񤭹७饯
 * @return     ϥХȿ<br>
 *             顼ξ
 * @throw      ΰγݤ˼Ԥ
 */
ssize_t stdstreamio::wskip( size_t n, int ch )
{
    if ( this->fp == c_stdin() ) this->fp = this->p_stdout;
    return this->cstreamio::wskip(n,ch);
}

/**
 * @brief  ȥ꡼ΰ֤ѹ
 *
 *  ȥ꡼ΰ֤ѹޤ
 *
 * @param      offset ȥ꡼ɽҤΥեå
 * @param      whence ȥ꡼ɽҤδ
 * @return     0<br>
 *             顼ξ
 */
int stdstreamio::seek( long offset, int whence )
{
    return this->cstreamio::seek(offset, whence);
}

/**
 * @brief  ȥ꡼ΰ֤Ƭѹ
 *
 *  ȥ꡼ΰ֤Ƭѹޤ
 *
 * @return     0<br>
 *             顼ξ
 */
int stdstreamio::rewind()
{
    return this->cstreamio::rewind();
}

/**
 * @brief  ȥ꡼֤μ
 *
 *  ȥ꡼ɽҤ֤ͤޤ
 *
 * @return     0ʾ<br>
 *             顼ξ
 */
long stdstreamio::tell()
{
    return this->cstreamio::tell();
}

/**
 * @brief  񤭹ѥȥ꡼Υեå
 *
 *  ɸϥȥ꡼˥Хåե˳ǼƤ뤹٤ƤΥǡ񤭹ߤޤ
 *
 * @return     0<br>
 *             顼ξ0ʳ
 */
int stdstreamio::flush()
{
    if ( this->fp == c_stdin() ) this->fp = this->p_stdout;
    return this->cstreamio::flush();
}

/**
 * @brief  EOFؼҤμ
 */
int stdstreamio::eof()
{
    if ( this->fp == this->p_stdout ) this->fp = c_stdin();
    return this->cstreamio::eof();
}

/**
 * @brief  顼ؼҤμ
 */
int stdstreamio::error()
{
    if ( this->fp == this->p_stdout ) this->fp = c_stdin();
    return this->cstreamio::error();
}

/**
 * @brief  EOFؼҤȥ顼ؼҤΥꥻå
 */
stdstreamio &stdstreamio::reseterr()
{
    if ( this->fp == this->p_stdout ) this->fp = c_stdin();
    this->cstreamio::reseterr();
    return *this;
}

/**
 * @brief  ɸ२顼ϤؤΥեޥåȽ񤭹
 *
 *  ɸ२顼ϥȥ꡼ˡեޥåȤ˽äƽ񤭹ߤޤ
 *
 * @param      format 񤭹ߥեޥåȻ
 * @param      ... 񤭹ǥǡ
 * @return     Ͻ񤭹ޤ줿ʸ<br>
 *             顼ξ
 */
int stdstreamio::eprintf(const char *format, ... )
{
    assert( format != NULL );

    va_list ap;
    int ret;
    va_start(ap,format);
    try {
	ret = c_vfprintf(c_stderr(),format,ap);
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","unexpected exception");
    }
    va_end(ap);
    return ret;
}

/**
 * @brief  ɸ२顼ϤؤΥեޥåȽ񤭹
 *
 *  ɸ२顼ϥȥ꡼ˡեޥåȤ˽äƽ񤭹ߤޤ
 *
 * @param      format 񤭹ߥեޥåȻ
 * @param      ap 񤭹ǥǡ
 * @return     Ͻ񤭹ޤ줿ʸ<br>
 *             顼ξ
 */
int stdstreamio::veprintf( const char *format, va_list ap )
{
    assert( format != NULL );

    return c_vfprintf(c_stderr(),format,ap);
}

/**
 * @brief  ɸ२顼ϥȥ꡼Υեå
 *
 *  ɸ२顼ϥȥ꡼ΥХåե˳ǼƤ뤹٤ƤΥǡ
 *  ߤޤ
 *
 * @return     0<br>
 *             顼ξ0ʳ
 */
int stdstreamio::eflush()
{
    return c_fflush(c_stderr());
}

/**
 * @brief  ե륵μ
 *
 *  եΥ֤ޤ
 *
 * @return     ϥե륵<br>
 *             顼ξ
 * @note       ɸϤФƤ 0 ֤ޤ
 */
long long stdstreamio::content_length() const
{
    void *fp_r = this->fp;
    if ( fp_r == this->p_stdout ) fp_r = c_stdin();
    if ( fp_r == NULL ) return -1;
    else return get_file_size(c_fileno(fp_r));
}

}	/* namespace sli */


#include "private/c_stdout.c"
#include "private/c_stdin.c"
#include "private/c_stderr.c"
#include "private/c_fopen.c"
#include "private/c_fclose.c"
#include "private/c_vfprintf.c"
#include "private/c_fflush.c"
#include "private/c_fileno.c"
#include "private/get_file_size.c"
