/* -*- Mode: C++ ; Coding: euc-japan -*- */
/* Time-stamp: <2013-04-27 20:18:52 cyamauch> */

#ifndef _SLI__TERMSCREENIO_H
#define _SLI__TERMSCREENIO_H 1

/**
 * @file   termscreenio.h
 * @brief  ǥڡͳǥȥ꡼򰷤 termscreenio 饹
 */

#include "cstreamio.h"

#include <sys/types.h>

#define TERMSCREENIO__SIZE_TMPFILENAME 128

namespace sli
{

/*
 * termscreenio class -- input/output on a tty screen.
 *                       execute pager for write, execute editor for read.
 *                       (concrete derived class of cstreamio)
 *
 * linker options : none
 *
 */

/**
 * @class  sli::termscreenio
 * @brief  ϻϥڡϻϥǥѤȥ꡼
 *
 *   termscreenio饹ϡߥʥǤΥǥͳǤϡڡؤ
 *   ϤԤʤޤw3m Τ褦ʥġǤ
 *
 * @attention  LIBC  stdio.h ʻѤ硤termstreamio.h 
 *             stdio.h  include Ƥ
 * @attention  ݴ쥯饹Ǥ cstreamio ѾƤޤ<br>
 *             Ū API ˤĤƤ cstreamio 饹 public дؿȤ
 *             ƤޤΤǡ
 * @author  Chisato YAMAUCHI
 * @date  2013-04-01 00:00:00
 */

  class termscreenio : public cstreamio
  {

  public:
    /* constructor & destructor */
    termscreenio();
    ~termscreenio();

    /*
     * overridden member functions:  See cstreamio.h for details.
     */
    /* set editor command to path for "r" mode, pager command for "w" mode */
    int open( const char *mode, const char *path );
    int open( const char *mode, int fd );
    int open( const char *mode );
    int close();

    /*
     * added member functions
     */
    /* set editor command to argv for "r" mode, pager command for "w" mode */
    virtual int open( const char *mode, const char *const argv[] );

  private:
    int pfds[2];			/*  */
    pid_t pid;
    char tmpfile[TERMSCREENIO__SIZE_TMPFILENAME];

  };
}

#ifndef _SLI__TERMSCREENIO_CC
#undef TERMSCREENIO__SIZE_TMPFILENAME
#endif

#endif	/* _SLI__TERMSCREENIO_H */
