/* -*- Mode: C++ ; Coding: euc-japan -*- */
/* Time-stamp: <2013-05-14 00:14:25 cyamauch> */

/**
 * @file   tarray_tstring.cc
 * @brief  ʸ򰷤tarray_tstring饹Υ
 */

#define CLASS_NAME "tarray_tstring"

#include "config.h"

#include "tarray_tstring.h"
#include "heap_mem.h"

#include <stdlib.h>

#include "private/err_report.h"

#include "private/c_memcpy.h"
#include "private/c_strncmp.h"
#include "private/c_isalpha.h"
#include "private/c_regsearchx.h"
#include "private/c_regfatal.h"

/* #define TARRAY_TSTRING__REMOVE_ESCAPE 1 */

/* ɽθλåȤ */
#define REGFUNCS_USING_CACHE 1

namespace sli
{

/* make_accepts_regexp() and is_found() */
#include "private/tstring_regexp_cset.cc"

/*
 * ֥ϡҡפΰݤʤ
 * äơ⤷ʤ obj.elements()  NULL 
 * ֤롥
 *
 * const char tbl[] = {NULL};
 * hoge.init(tbl)  hoge.append(tbl)
 * ФƤϡthis->cstr_ptrs[0] = NULL 롥
 *
 * hoge.init((char **)NULL)
 * Ƚ
 * 
 * hoge.append((char **)NULL) ФƤϡ̵ȿ
 *
 * ֥Ȥ֤ᤷ(ҡפ)ϡ
 * obj = NULL;
 * Ȥ롥
 */

/**
 * @brief  tarray ǿ֥Ȥ˸ƤФؿ
 *
 * @note   private ʴؿǤ
 */
static tstring *tstring_creator(void *ptr)
{
    tstring *p;
    p = new tstring(true);
    return p;
}


/* constructor */

/**
 * @brief  󥹥ȥ饯
 *
 * @throw  Хåեγݤ˼Ԥ
 * @throw  ˲򵯤Ȥ
 */
tarray_tstring::tarray_tstring()
{
    this->arrs_rec.register_creator(&tstring_creator, NULL);
    this->cstr_ptrs_rec.init(sizeof(char *), true);
    this->reg_pos_rec.init(sizeof(size_t), true);
    this->reg_length_rec.init(sizeof(size_t), true);
    return;
}

/* constructor */

/**
 * @brief  󥹥ȥ饯
 *
 *  Ȥʸ elements Ƥǽޤ<br>
 *  elements νüNULLǤʤФʤޤ
 *
 * @param  elements ʸ
 * @throw  Хåեγݤ˼Ԥ
 * @throw  ˲򵯤Ȥ
 */
tarray_tstring::tarray_tstring(const char *const *elements)
{
    this->arrs_rec.register_creator(&tstring_creator, NULL);
    this->cstr_ptrs_rec.init(sizeof(char *), true);
    this->reg_pos_rec.init(sizeof(size_t), true);
    this->reg_length_rec.init(sizeof(size_t), true);
    if ( elements != NULL ) this->assign(elements);
    return;
}

/* constructor */

/**
 * @brief  󥹥ȥ饯
 *
 *  ȤͿ줿ʸǽޤ<br>
 *  κǸɬ NULL Ϳޤ
 * 
 * @param  el0 ʸ
 * @param  el1 ʸ
 * @param  ... ʸγ.
 * @throw  Хåեγݤ˼Ԥ
 * @throw  ˲򵯤Ȥ
 */
tarray_tstring::tarray_tstring(const char *el0, const char *el1, ...)
{
    va_list ap;

    this->arrs_rec.register_creator(&tstring_creator, NULL);
    this->cstr_ptrs_rec.init(sizeof(char *), true);
    this->reg_pos_rec.init(sizeof(size_t), true);
    this->reg_length_rec.init(sizeof(size_t), true);

    va_start(ap, el1);
    try {
	this->vassign( el0, el1, ap );
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vassign() failed");
    }
    va_end(ap);

    return;
}

/* copy constructor */

/**
 * @brief  ԡ󥹥ȥ饯
 *
 *  Ȥ obj Ƥǽޤ
 * 
 * @param  obj tarray_tstringΥ֥
 * @throw  Хåեγݤ˼Ԥ
 * @throw  ˲򵯤Ȥ
 */
tarray_tstring::tarray_tstring(const tarray_tstring &obj)
{
    this->arrs_rec.register_creator(&tstring_creator, NULL);
    this->cstr_ptrs_rec.init(sizeof(char *), true);
    this->reg_pos_rec.init(sizeof(size_t), true);
    this->reg_length_rec.init(sizeof(size_t), true);
    this->init(obj);
    return;
}

/* destructor */

/**
 * @brief  ǥȥ饯
 */
tarray_tstring::~tarray_tstring()
{
    return;
}

/**
 * @brief  ֥ȤΥԡ
 *
 *  黻Ҥα¦() ǻꤵ줿֥ȤƤޤʸ
 *  Ȥޤ
 *
 * @param      obj tarray_tstring饹Υ֥
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::operator=(const tarray_tstring &obj)
{
    this->init(obj);
    return *this;
}

/**
 * @brief  ȤκǸˡʸ(tarray_tstring)ɲ
 *
 *  Ȥˡ黻Ҥα¦() ǻꤵ줿ʸɲäԤޤ
 *
 * @param      obj tarray_tstring饹Υ֥
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::operator+=(const tarray_tstring &obj)
{
    this->append(obj);
    return *this;
}

/**
 * @brief  Ȥˡꤵ줿ʸ(const char *[])
 *
 *  黻Ҥα¦() ǻꤵ줿֥ȤƤޤʸ
 *  Ȥޤ
 *
 * @param      elements ʸΥݥΥɥ쥹(NULL ü)
 * @return     ʸХåեؤΥݥ
 * @throw      Хåեγݤ˼Ԥ
 * 
 */
const char *const *tarray_tstring::operator=(const char *const *elements)
{
    if ( elements == NULL ) {	/* NULLλϤäݤˤ */
        this->init();
    }
    else {
        this->assign(elements);
    }
    return this->cstrarray();
}

/**
 * @brief  ȤκǸˡꤵ줿ʸ(const char *[])ɲ
 *
 *  Ȥˡ黻Ҥα¦() ǻꤵ줿ʸɲäԤޤ
 *
 * @param      elements ʸΥݥΥɥ쥹(NULL ü)
 * @return     ʸХåեؤΥݥ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
const char *const *tarray_tstring::operator+=(const char *const *elements)
{
    if ( elements != NULL ) this->append(elements);
    return this->cstrarray();
}

/**
 * @brief  ȤκǸˡꤵ줿ʸ(const char *)ɲ
 *
 *  Ȥˡ黻Ҥα¦() ǻꤵ줿ʸɲäޤ
 *
 * @param   str ʸΥɥ쥹
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::operator+=(const char *str)
{
    if ( str != NULL ) {
        this->append(str,1);
    }
    return *this;
}

/**
 * @brief  ȤκǸˡꤵ줿ʸ(tstring)ɲ
 *
 *  Ȥˡ黻Ҥα¦() ǻꤵ줿ʸɲäޤ
 *
 * @param   one ʸΥɥ쥹(ޥ˥奢Ǥstr)
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::operator+=(const tstring &one)
{
    if ( one.cstr() != NULL ) {
        this->append(one,1);
    }
    return *this;
}

/*
 * public member functions
 *
 * ˤȤơʸ,ݥ object ǴƤ
 * ΰ褬ͿƤưͤȤ롥
 *
 */

/**
 * @brief  ֥Ȥν
 *
 *  Ȥʸõ֥ȤνԤޤ
 *
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::init()
{
    this->arrs_rec.init();
    this->arrs_rec.register_creator(&tstring_creator, NULL);
    this->cstr_ptrs_rec.init(sizeof(char *), true);
    this->reg_pos_rec.init(sizeof(size_t), true);
    this->reg_length_rec.init(sizeof(size_t), true);
    this->regex_rec.init();

    return *this;
}

/**
 * @brief  ֥ȤΥԡ
 *
 *  ꤵ줿֥ obj Ƥ򼫿Ȥ˥ԡޤ
 *
 * @param      obj tarray_tstring 饹Υ֥
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::init(const tarray_tstring &obj)
{
    if ( &obj == this ) return *this;
    this->arrs_rec.init();
    this->arrs_rec.register_creator(&tstring_creator, NULL);
    this->cstr_ptrs_rec.init(sizeof(char *), true);
    this->reg_pos_rec.init(obj.reg_pos_rec);
    this->reg_length_rec.init(obj.reg_length_rec);
    /* this->regex_rec.init(obj.regex_rec); */
    this->regex_rec.init();
    this->append(obj);

    return *this;
}

/**
 * @brief  Τꤵ줿ʸ(const char *)ǥѥǥ
 *
 *  ȤǤʸ str ǥѥǥ󥰤ޤ
 *
 * @param      str ʸѥǥ󥰤뤿ʸ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::clean(const char *str)
{
    if ( str != NULL ) {
	tstring one = str;
	this->arrs_rec.clean(one);
    }
    return *this;
}

/**
 * @brief  Τꤵ줿ʸ(tstring)ǥѥǥ
 *
 *  ȤǤʸ str ǥѥǥ󥰤ޤ
 *
 * @param      one ʸѥǥ󥰤뤿ʸ(ޥ˥奢Ǥstr)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::clean(const tstring &one)
{
    if ( one.cstr() != NULL ) {
	this->arrs_rec.clean(one);
    }
    return *this;
}

/**
 * @brief  ѥ˥顼Ϥ뤿ΥߡΥдؿ
 * @deprecated  Բġ
 * @note	ΥдؿprivateǤ
 */
tarray_tstring &tarray_tstring::assign( size_t n )
{
    return this->replace(0, this->length(), n);
}

/**
 * @brief  ꤵ줿ʸ(const char *[])򼫿Ȥ
 *
 *  elementsǻꤵ줿ʸ򡤼Ȥޤ
 *
 * @param      elements ǤʸΥݥ(NULL ǽü)
 * @return     Ȥλ
 *
 */
tarray_tstring &tarray_tstring::assign( const char *const *elements )
{
    size_t i;
    if ( elements == NULL ) return this->assign(elements, 0);
    for ( i=0 ; elements[i] != NULL ; i++ );
    return this->assign(elements,i);
}

/**
 * @brief  ꤵ줿ʸ(const char *[])nǤ򼫿Ȥ
 *
 *  elementsǻꤵ줿ʸ n Ĥ򡤼Ȥޤ
 *
 * @param      elements ǤʸΥݥ
 * @param      n elements ǿ
 * @return     Ȥλ
 *
 */
tarray_tstring &tarray_tstring::assign( const char *const *elements, size_t n )
{
    return this->replace(0, this->length(), elements, n);
}

/**
 * @brief  ꤵ줿ʸ(tarray_tstring)()Ǥ򼫿Ȥ
 *
 *  srcǻꤵ줿ʸޤϰ򡤼Ȥޤ
 *
 * @param    src Ȥʤʸtarray_tstring 饹Υ֥
 * @param    idx2 srcǤγϰ(src ʬ)
 * @return   Ȥλ
 *
 */
tarray_tstring &tarray_tstring::assign(const tarray_tstring &src, size_t idx2)
{
    return this->assign(src, idx2, src.length());
}

/**
 * @brief  ꤵ줿ʸ(tarray_tstring)()Ǥ򼫿Ȥ
 *
 *  srcǻꤵ줿ʸޤϰ򡤼Ȥޤ
 *
 * @param    src Ȥʤʸtarray_tstring 饹Υ֥
 * @param    idx2 srcǤγϰ(src ʬ)
 * @param    n2 src ǤθĿ(src ʬ)
 * @return   Ȥλ
 *
 */
tarray_tstring &tarray_tstring::assign( const tarray_tstring &src, 
					size_t idx2, size_t n2 )
{
    return this->replace(0, this->length(), src, idx2, n2);
}

/**
 * @brief  ꤵ줿ʸ(const char *)n Ȥ
 *
 *  ȤǤnĤȤ٤ƤǤ˻ꤵ줿ʸޤ
 *
 * @param      str Ȥʤʸ
 * @param      n ǿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::assign( const char *str, size_t n )
{
    return this->replace(0, this->length(), str, n);
}

/**
 * @brief  ꤵ줿ʸ(tstring)n Ȥ
 *
 *  ȤǤnĤȤ٤ƤǤ˻ꤵ줿ʸޤ
 *
 * @param      one Ȥʤʸ(ޥ˥奢Ǥstr)
 * @param      n ǿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::assign( const tstring &one, size_t n )
{
    return this->replace(0, this->length(), one, n);
}

/**
 * @brief  ꤵ줿ʸ(printf()εˡǻ)n Ȥ
 *
 *  ȤǤnĤȤ٤ƤǤ˻ꤵ줿ʸޤ
 *
 * @param   n ǿ
 * @param   format ȤʤʸΤΥեޥåȻ
 * @param   ... formatбĹγǥǡ
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 * @throw   Ĺγǥǡꤵ줿ѴեޥåȤ
 *          ѴǤʤͤξ
 *
 */
tarray_tstring &tarray_tstring::assignf( size_t n, const char *format, ... )
{
    va_list ap;
    va_start(ap,format);
    try {
	this->vassignf(n,format,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vassignf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿ʸ(printf()εˡǻ)n Ȥ
 *
 *  ȤǤnĤȤ٤ƤǤ˻ꤵ줿ʸޤ
 *
 * @param      n ǿ
 * @param      format ȤʤʸΤΥեޥåȻ
 * @param      ap formatбĹΥꥹ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      Ĺγǥǡꤵ줿ѴեޥåȤ
 *             ѴǤʤͤξ
 *
 */
tarray_tstring &tarray_tstring::vassignf(size_t n, const char *format, va_list ap)
{
    tstring one;

    if ( format == NULL ) return this->assign(format,n);

    try {
	one.vprintf(format,ap);
    }
    catch (...) {
	err_throw(__FUNCTION__,"FATAL","one.vprintf() failed");
    }
    this->assign(one,n);

    return *this;
}

/**
 * @brief  ꤵ줿ʣʸ򼫿Ȥ
 *
 *  Ѱǻꤵ줿ʣʸʸȤƼȤޤ
 *
 * @param      el0 Ǥʸ(0 )
 * @param      el1 Ǥʸ(1 )
 * @param      ... Ǥʸ(2 ܰʹ; NULL ü)
 * @return     Ȥλ
 *
 */
tarray_tstring &tarray_tstring::assign( const char *el0, const char *el1, ... )
{
    va_list ap;
    va_start(ap, el1);
    try {
	this->vassign( el0, el1, ap );
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vassign() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿ʣʸ򼫿Ȥ
 *
 *  Ѱǻꤵ줿ʣʸʸȤƼȤޤ
 *
 * @param      el0 Ǥʸ(0 )
 * @param      el1 Ǥʸ(1 )
 * @param      ap ǤʸβĹΥꥹ(2 ܰʹ; NULL ü)
 * @return     Ȥλ
 *
 */
tarray_tstring &tarray_tstring::vassign( const char *el0, const char *el1, 
					 va_list ap )
{
    heap_mem<const char *> tmp_ptbl;
    size_t element_count, i;
    va_list aq;

    va_copy(aq, ap);

    element_count = 0;
    if ( el0 != NULL ) {
        element_count++;
	if ( el1 != NULL ) {
	    element_count++;
	    while ( 1 ) {
	        const char *elem = va_arg(aq,char *);
		if ( elem == NULL ) break;
		element_count++;
	    }
	}
    }
    va_end(aq);

    if ( tmp_ptbl.allocate(element_count + 1) < 0 ) {
	err_throw(__FUNCTION__,"FATAL","malloc() failed");
    }

    i = 0;
    if ( el0 != NULL ) {
        tmp_ptbl[i] = el0;
        i++;
	if ( el1 != NULL ) {
	    tmp_ptbl[i] = el1;
	    i++;
	    while ( 1 ) {
	        const char *elem = va_arg(ap,char *);
		if ( elem == NULL ) break;
		tmp_ptbl[i] = elem;
		i++;
	    }
	}
    }
    tmp_ptbl[i] = NULL;

    this->assign(tmp_ptbl.ptr());

    return *this;
}


#define LEN_RET_S_STK 512
#define LEN_RET_P_STK 128

/* len_src_str ʾ 0 ˤƤɤ */
inline void explode_php( const char *src_str, size_t len_src_str, 
		   const char *delim, bool zero_str, tarray_tstring *retobjp )
{
    /* Хåե: */
    /* ŪˤϺǽϥåȤ­ʤʤäҡפڤؤ */
    char ret_s_stk[LEN_RET_S_STK];		/* result for temp string */
    char *ret_s_heap = NULL;
    size_t len_ret_s_buf = LEN_RET_S_STK;
    char *ret_s = ret_s_stk;
    size_t ix_ret_s = 0;			/* current index of ret_s */
    size_t ix0_ret_s = 0;			/* first pos of current elem */

    union _ret_p {
	char *ptr;
	size_t offset;
    };
    union _ret_p ret_p_stk[LEN_RET_P_STK];	/* result for temp str ptrs */
    union _ret_p *ret_p_heap = NULL;
    size_t len_ret_p_buf = LEN_RET_P_STK;
    union _ret_p *ret_p = ret_p_stk;
    size_t ix_ret_p = 0;			/* current index of ret_p */

    size_t i;

    if ( src_str == NULL ) {
	retobjp->assign(src_str, 1);
	goto quit;
    }
    if ( delim == NULL ) delim = "";

    /* len_src_str  0 Ǥʤ硤餫­ʤϥҡפڤؤ */
    if ( LEN_RET_S_STK < len_src_str + 1 ) {
	ret_s_heap = (char *)malloc(len_src_str + 1);
	if ( ret_s_heap == NULL ) {
	    err_throw(__FUNCTION__,"FATAL","malloc() failed");
	}
	len_ret_s_buf = len_src_str + 1;
	ret_s = ret_s_heap;
    }

    /*
     * parse src_str
     */

    try {
	i = 0;
	while ( src_str[i] != '\0' ) {
	    char ch = src_str[i];
	    size_t i_step = 1;
	    size_t j;
	    for ( j=0 ; delim[j] != '\0' ; j++ ) {
		if ( src_str[i+j] != delim[j] ) break;
	    }
	    if ( 0 < j && delim[j] == '\0' ) {
		ch = '\0';
		i_step = j;
	    }

	    /* Хåե˳Ǽ */
	    if ( len_ret_s_buf <= ix_ret_s + 1 ) {
		size_t ii, len_realloc;
		if ( len_src_str == 0 ) {
		    /* src_strĹξĴ٤Ƥޤ */
		    for ( ii=0 ; src_str[i + ii] != '\0' ; ii++ );
		    len_realloc = i + ii + 1;
		} else len_realloc = len_src_str + 1;

		if ( ret_s_heap == NULL ) {
		    ret_s_heap = (char *)malloc(len_realloc);
		    if ( ret_s_heap == NULL ) {
			err_throw(__FUNCTION__,"FATAL","malloc() failed");
		    }
		    c_memcpy(ret_s_heap, ret_s, len_ret_s_buf);
		}
		else {
		    void *tmp_ptr = realloc(ret_s_heap, len_realloc);
		    if ( tmp_ptr == NULL ) {
			err_throw(__FUNCTION__,"FATAL","realloc() failed");
		    }
		    ret_s_heap = (char *)tmp_ptr;
		}
		ret_s = ret_s_heap;
		len_ret_s_buf = len_realloc;
	    }
	    ret_s[ix_ret_s] = ch;
	    ix_ret_s ++;
	    
	    /* ڤʸäν: ɥ쥹ơ֥Ͽ */
	    if ( ch == '\0' ) {
		if ( zero_str == true || ix0_ret_s + 1 < ix_ret_s ) {
		    if ( len_ret_p_buf <= ix_ret_p + 2 ) {
			size_t len_realloc = len_ret_p_buf * 2;
			if ( ret_p_heap == NULL ) {
			    ret_p_heap = (union _ret_p *)malloc(sizeof(*ret_p_heap)*len_realloc);
			    if ( ret_p_heap == NULL ) {
				err_throw(__FUNCTION__,"FATAL","malloc() failed");
			    }
			    c_memcpy(ret_p_heap, ret_p, sizeof(*ret_p_heap)*len_ret_p_buf);
			}
			else {
			    void *tmp_ptr = realloc(ret_p_heap, sizeof(*ret_p_heap)*len_realloc);
			    if ( tmp_ptr == NULL ) {
				err_throw(__FUNCTION__,"FATAL","realloc() failed");
			    }
			    ret_p_heap = (union _ret_p *)tmp_ptr;
			}
			ret_p = ret_p_heap;
			len_ret_p_buf = len_realloc;
		    }
		    ret_p[ix_ret_p].offset = ix0_ret_s;
		    ix_ret_p ++;
		}
		ix0_ret_s = ix_ret_s;
	    }
	    i += i_step;
	}
    }
    catch (...) {
	if ( ret_p_heap != NULL ) {
	    free(ret_p_heap);
	    ret_p_heap = NULL;
	}
	if ( ret_s_heap != NULL ) {
	    free(ret_s_heap);
	    ret_s_heap = NULL;
	}
	err_throw(__FUNCTION__,"FATAL","caught exception");
    }
    ret_s[ix_ret_s] = '\0';
    ix_ret_s ++;
    if ( zero_str == true || ix0_ret_s + 1 < ix_ret_s ) {
	ret_p[ix_ret_p].offset = ix0_ret_s;
	ix_ret_p ++;
    }
    ret_p[ix_ret_p].ptr = NULL;
    for ( i=0 ; i < ix_ret_p ; i++ ) {
	size_t off = ret_p[i].offset;
	ret_p[i].ptr = ret_s + off;
    }

    try {
	retobjp->erase();
	retobjp->append((char **)ret_p);
    }
    catch (...) {
	if ( ret_p_heap != NULL ) {
	    free(ret_p_heap);
	    ret_p_heap = NULL;
	}
	if ( ret_s_heap != NULL ) {
	    free(ret_s_heap);
	    ret_s_heap = NULL;
	}
	err_throw(__FUNCTION__,"FATAL","this->append() failed");
    }


 quit:
    if ( ret_p_heap != NULL ) free(ret_p_heap);
    if ( ret_s_heap != NULL ) free(ret_s_heap);
    return;
}


/* len_src_str ʾ 0 ˤƤɤ */
inline void explode_advanced( const char *src_str, size_t len_src_str, 
			      const char *delim, bool zero_str, 
			      const char *quot_bkt, 
			      int escape, bool rm_escape,
			      tarray_tstring *retobjp )
{
    char quot[96];				/* list of quotations */
    char bkt_l[5];				/* list of brackets (left) */
    char bkt_r[5];				/* list of brackets (right) */

    bool prev_escape = false;
    char quot_to_find = '\0';			/* quotation to be found */
    tstring bkt_to_find;			/* Ĥ٤ڥγ */
    size_t depth_bkt = 0;			/* ̤ο */

    /* Хåե: */
    /* ŪˤϺǽϥåȤ­ʤʤäҡפڤؤ */
    char ret_s_stk[LEN_RET_S_STK];		/* result for temp string */
    char *ret_s_heap = NULL;
    size_t len_ret_s_buf = LEN_RET_S_STK;
    char *ret_s = ret_s_stk;
    size_t ix_ret_s = 0;			/* current index of ret_s */
    size_t ix0_ret_s = 0;			/* first pos of current elem */

    union _ret_p {
	char *ptr;
	size_t offset;
    };
    union _ret_p ret_p_stk[LEN_RET_P_STK];	/* result for temp str ptrs */
    union _ret_p *ret_p_heap = NULL;
    size_t len_ret_p_buf = LEN_RET_P_STK;
    union _ret_p *ret_p = ret_p_stk;
    size_t ix_ret_p = 0;			/* current index of ret_p */

    size_t i;

    if ( src_str == NULL ) {
	retobjp->assign(src_str, 1);
	goto quit;
    }
    if ( delim == NULL ) delim = "";

    /* len_src_str  0 Ǥʤ硤餫­ʤϥҡפڤؤ */
    if ( LEN_RET_S_STK < len_src_str + 1 ) {
	ret_s_heap = (char *)malloc(len_src_str + 1);
	if ( ret_s_heap == NULL ) {
	    err_throw(__FUNCTION__,"FATAL","malloc() failed");
	}
	len_ret_s_buf = len_src_str + 1;
	ret_s = ret_s_heap;
    }

    /*
     * setup quotations and bracket info: quot[] bkt_l[] bkt_r[]
     */
    if ( quot_bkt != NULL ) {
	bool b0=false, b1=false, b2=false, b3=false;
	size_t j=0, k=0;
	for ( i=0 ; quot_bkt[i] != '\0' ; i++ ) {
	    const char ch = quot_bkt[i];
	    if ( ch == '[' || ch == ']' ) {
		if ( b0 == false ) {
		    bkt_l[k] = '[';  bkt_r[k] = ']';
		    k++;  b0 = true;
		}
	    }
	    else if ( ch == '{' || ch == '}' ) {
		if ( b1 == false ) {
		    bkt_l[k] = '{';  bkt_r[k] = '}';
		    k++;  b1 = true;
		}
	    }
	    else if ( ch == '(' || ch == ')' ) {
		if ( b2 == false ) {
		    bkt_l[k] = '(';  bkt_r[k] = ')';
		    k++;  b2 = true;
		}
	    }
	    else if ( ch == '<' || ch == '>' ) {
		if ( b3 == false ) {
		    bkt_l[k] = '<';  bkt_r[k] = '>';
		    k++;  b3 = true;
		}
	    }
	    else {
		quot[j] = ch;
		if ( j + 1 < 96 ) j++;
	    }
	}
	quot[j] = '\0';
	bkt_l[k] = '\0';
	bkt_r[k] = '\0';
    }
    else {
	quot[0] = '\0';
	bkt_l[0] = '\0';
	bkt_r[0] = '\0';
    }

    /*
     * parse src_str
     */

    try {
      i = 0;
      while ( src_str[i] != '\0' ) {
	char ch = src_str[i];
	bool cpy_ok = true;
	size_t i_step = 1;
	if ( prev_escape == true ) {		/* chrescapeʸʤ */
	    prev_escape = false;
	}
	else if ( ch == escape ) {		/* chrescapeʸʤ */
	    if ( rm_escape == true ) cpy_ok = false;
	    prev_escape = true;
	}
	else if ( quot_to_find != '\0' ) {	/* ڥ quot 򸫤Ĥ */
	    if ( ch == quot_to_find ) quot_to_find = '\0';
	}
	else {
	    size_t j;
	    /* quot γϤ򸫤Ĥ */
	    for ( j=0 ; quot[j] != '\0' ; j++ ) {
		if ( ch == quot[j] ) {
		    quot_to_find = ch;
		    break;
		}
	    }
	    if ( quot[j] == '\0' ) {
		/* γ̤򸫤Ĥ */
		for ( j=0 ; bkt_l[j] != '\0' ; j++ ) {
		    if ( ch == bkt_l[j] ) {
			bkt_to_find.at(depth_bkt) = bkt_r[j];
			depth_bkt ++;
			break;
		    }
		}
	    }
	    if ( bkt_l[j] == '\0' ) {
		/* ڥγ̤򸫤Ĥ */
		if ( 0 < depth_bkt ) {
		    if ( ch == bkt_to_find.at_cs(depth_bkt-1) ) {
			depth_bkt --;
		    }
		}
		/* 褦䤯ǶڤʸȽ */
		else {
		    for ( j=0 ; delim[j] != '\0' ; j++ ) {
			if ( src_str[i+j] != delim[j] ) break;
		    }
		    if ( 0 < j && delim[j] == '\0' ) {
			ch = '\0';
			i_step = j;
		    }
		}
	    }
	}
	if ( cpy_ok == true ) {

	    /* Хåե˳Ǽ */
	    if ( len_ret_s_buf <= ix_ret_s + 1 ) {
		size_t ii, len_realloc;
		if ( len_src_str == 0 ) {
		    /* src_strĹξĴ٤Ƥޤ */
		    for ( ii=0 ; src_str[i + ii] != '\0' ; ii++ );
		    len_realloc = i + ii + 1;
		} else len_realloc = len_src_str + 1;

		if ( ret_s_heap == NULL ) {
		    ret_s_heap = (char *)malloc(len_realloc);
		    if ( ret_s_heap == NULL ) {
			err_throw(__FUNCTION__,"FATAL","malloc() failed");
		    }
		    c_memcpy(ret_s_heap, ret_s, len_ret_s_buf);
		}
		else {
		    void *tmp_ptr = realloc(ret_s_heap, len_realloc);
		    if ( tmp_ptr == NULL ) {
			err_throw(__FUNCTION__,"FATAL","realloc() failed");
		    }
		    ret_s_heap = (char *)tmp_ptr;
		}
		ret_s = ret_s_heap;
		len_ret_s_buf = len_realloc;
	    }
	    ret_s[ix_ret_s] = ch;
	    ix_ret_s ++;

	    /* ڤʸäν: ɥ쥹ơ֥Ͽ */
	    if ( ch == '\0' ) {
		if ( zero_str == true || ix0_ret_s + 1 < ix_ret_s ) {
		    if ( len_ret_p_buf <= ix_ret_p + 2 ) {
			size_t len_realloc = len_ret_p_buf * 2;
			if ( ret_p_heap == NULL ) {
			    ret_p_heap = (union _ret_p *)malloc(sizeof(*ret_p_heap)*len_realloc);
			    if ( ret_p_heap == NULL ) {
				err_throw(__FUNCTION__,"FATAL","malloc() failed");
			    }
			    c_memcpy(ret_p_heap, ret_p, sizeof(*ret_p_heap)*len_ret_p_buf);
			}
			else {
			    void *tmp_ptr = realloc(ret_p_heap, sizeof(*ret_p_heap)*len_realloc);
			    if ( tmp_ptr == NULL ) {
				err_throw(__FUNCTION__,"FATAL","realloc() failed");
			    }
			    ret_p_heap = (union _ret_p *)tmp_ptr;
			}
			ret_p = ret_p_heap;
			len_ret_p_buf = len_realloc;
		    }
		    ret_p[ix_ret_p].offset = ix0_ret_s;
		    ix_ret_p ++;
		}
		ix0_ret_s = ix_ret_s;
	    }
	}
	i += i_step;
      }
    }
    catch (...) {
	if ( ret_p_heap != NULL ) {
	    free(ret_p_heap);
	    ret_p_heap = NULL;
	}
	if ( ret_s_heap != NULL ) {
	    free(ret_s_heap);
	    ret_s_heap = NULL;
	}
	err_throw(__FUNCTION__,"FATAL","caught exception");
    }
    ret_s[ix_ret_s] = '\0';
    ix_ret_s ++;
    if ( zero_str == true || ix0_ret_s + 1 < ix_ret_s ) {
	ret_p[ix_ret_p].offset = ix0_ret_s;
	ix_ret_p ++;
    }
    ret_p[ix_ret_p].ptr = NULL;
    for ( i=0 ; i < ix_ret_p ; i++ ) {
	size_t off = ret_p[i].offset;
	ret_p[i].ptr = ret_s + off;
    }

    try {
	retobjp->erase();
	retobjp->append((char **)ret_p);
    }
    catch (...) {
	if ( ret_p_heap != NULL ) {
	    free(ret_p_heap);
	    ret_p_heap = NULL;
	}
	if ( ret_s_heap != NULL ) {
	    free(ret_s_heap);
	    ret_s_heap = NULL;
	}
	err_throw(__FUNCTION__,"FATAL","this->append() failed");
    }


 quit:
    if ( ret_p_heap != NULL ) free(ret_p_heap);
    if ( ret_s_heap != NULL ) free(ret_s_heap);
    return;
}


/* len_src_str ʾ 0 ˤƤɤ */
inline void split_simple( const char *src_str, size_t len_src_str, 
		   const char *delims, bool zero_str, tarray_tstring *retobjp )
{
    /* Хåե: */
    /* ŪˤϺǽϥåȤ­ʤʤäҡפڤؤ */
    char ret_s_stk[LEN_RET_S_STK];		/* result for temp string */
    char *ret_s_heap = NULL;
    size_t len_ret_s_buf = LEN_RET_S_STK;
    char *ret_s = ret_s_stk;
    size_t ix_ret_s = 0;			/* current index of ret_s */
    size_t ix0_ret_s = 0;			/* first pos of current elem */

    union _ret_p {
	char *ptr;
	size_t offset;
    };
    union _ret_p ret_p_stk[LEN_RET_P_STK];	/* result for temp str ptrs */
    union _ret_p *ret_p_heap = NULL;
    size_t len_ret_p_buf = LEN_RET_P_STK;
    union _ret_p *ret_p = ret_p_stk;
    size_t ix_ret_p = 0;			/* current index of ret_p */

    bool reg_delims = false;
    tstring accepts;
    bool ac_bl;
    int ac_flg = 0;
    size_t i;

    if ( src_str == NULL ) {
	retobjp->assign(src_str, 1);
	goto quit;
    }
    if ( delims == NULL ) delims = "";

    /* check [A-Z] style */
    if ( delims[0] == '[' ) {
	for ( i=0 ; delims[i] != '\0' ; i++ );
	if ( delims[i-1] == ']' ) {
	    size_t p0 = 0;
	    p0 += make_accepts_regexp(delims, true, accepts, &ac_flg, &ac_bl);
	    if ( p0 != 0 ) reg_delims = true;
	}
    }

    /* len_src_str  0 Ǥʤ硤餫­ʤϥҡפڤؤ */
    if ( LEN_RET_S_STK < len_src_str + 1 ) {
	ret_s_heap = (char *)malloc(len_src_str + 1);
	if ( ret_s_heap == NULL ) {
	    err_throw(__FUNCTION__,"FATAL","malloc() failed");
	}
	len_ret_s_buf = len_src_str + 1;
	ret_s = ret_s_heap;
    }

    /*
     * parse src_str
     */

    try {
	for ( i=0 ; src_str[i] != '\0' ; i++ ) {
	    char ch = src_str[i];
	    size_t j;
	    if ( reg_delims == true ) {
		if ( is_found(ch, accepts.cstr(), ac_flg) == ac_bl ) {
		    ch = '\0';
		}
	    }
	    else {
		for ( j=0 ; delims[j] != '\0' ; j++ ) {
		    if ( ch == delims[j] ) {
			ch = '\0';
			break;
		    }
		}
	    }
	    /* Хåե˳Ǽ */
	    if ( len_ret_s_buf <= ix_ret_s + 1 ) {
		size_t ii, len_realloc;
		if ( len_src_str == 0 ) {
		    /* src_strĹξĴ٤Ƥޤ */
		    for ( ii=0 ; src_str[i + ii] != '\0' ; ii++ );
		    len_realloc = i + ii + 1;
		} else len_realloc = len_src_str + 1;

		if ( ret_s_heap == NULL ) {
		    ret_s_heap = (char *)malloc(len_realloc);
		    if ( ret_s_heap == NULL ) {
			err_throw(__FUNCTION__,"FATAL","malloc() failed");
		    }
		    c_memcpy(ret_s_heap, ret_s, len_ret_s_buf);
		}
		else {
		    void *tmp_ptr = realloc(ret_s_heap, len_realloc);
		    if ( tmp_ptr == NULL ) {
			err_throw(__FUNCTION__,"FATAL","realloc() failed");
		    }
		    ret_s_heap = (char *)tmp_ptr;
		}
		ret_s = ret_s_heap;
		len_ret_s_buf = len_realloc;
	    }
	    ret_s[ix_ret_s] = ch;
	    ix_ret_s ++;
	    
	    /* ڤʸäν: ɥ쥹ơ֥Ͽ */
	    if ( ch == '\0' ) {
		if ( zero_str == true || ix0_ret_s + 1 < ix_ret_s ) {
		    if ( len_ret_p_buf <= ix_ret_p + 2 ) {
			size_t len_realloc = len_ret_p_buf * 2;
			if ( ret_p_heap == NULL ) {
			    ret_p_heap = (union _ret_p *)malloc(sizeof(*ret_p_heap)*len_realloc);
			    if ( ret_p_heap == NULL ) {
				err_throw(__FUNCTION__,"FATAL","malloc() failed");
			    }
			    c_memcpy(ret_p_heap, ret_p, sizeof(*ret_p_heap)*len_ret_p_buf);
			}
			else {
			    void *tmp_ptr = realloc(ret_p_heap, sizeof(*ret_p_heap)*len_realloc);
			    if ( tmp_ptr == NULL ) {
				err_throw(__FUNCTION__,"FATAL","realloc() failed");
			    }
			    ret_p_heap = (union _ret_p *)tmp_ptr;
			}
			ret_p = ret_p_heap;
			len_ret_p_buf = len_realloc;
		    }
		    ret_p[ix_ret_p].offset = ix0_ret_s;
		    ix_ret_p ++;
		}
		ix0_ret_s = ix_ret_s;
	    }
	}
    }
    catch (...) {
	if ( ret_p_heap != NULL ) {
	    free(ret_p_heap);
	    ret_p_heap = NULL;
	}
	if ( ret_s_heap != NULL ) {
	    free(ret_s_heap);
	    ret_s_heap = NULL;
	}
	err_throw(__FUNCTION__,"FATAL","caught exception");
    }
    ret_s[ix_ret_s] = '\0';
    ix_ret_s ++;
    if ( zero_str == true || ix0_ret_s + 1 < ix_ret_s ) {
	ret_p[ix_ret_p].offset = ix0_ret_s;
	ix_ret_p ++;
    }
    ret_p[ix_ret_p].ptr = NULL;
    for ( i=0 ; i < ix_ret_p ; i++ ) {
	size_t off = ret_p[i].offset;
	ret_p[i].ptr = ret_s + off;
    }

    try {
	retobjp->erase();
	retobjp->append((char **)ret_p);
    }
    catch (...) {
	if ( ret_p_heap != NULL ) {
	    free(ret_p_heap);
	    ret_p_heap = NULL;
	}
	if ( ret_s_heap != NULL ) {
	    free(ret_s_heap);
	    ret_s_heap = NULL;
	}
	err_throw(__FUNCTION__,"FATAL","this->append() failed");
    }


 quit:
    if ( ret_p_heap != NULL ) free(ret_p_heap);
    if ( ret_s_heap != NULL ) free(ret_s_heap);
    return;
}

/* len_src_str ʾ 0 ˤƤɤ */
inline void split_advanced( const char *src_str, size_t len_src_str, 
		     const char *delims, bool zero_str, const char *quot_bkt,
		     int escape, bool rm_escape, tarray_tstring *retobjp )
{
    char quot[96];				/* list of quotations */
    char bkt_l[5];				/* list of brackets (left) */
    char bkt_r[5];				/* list of brackets (right) */

    bool prev_escape = false;
    char quot_to_find = '\0';			/* quotation to be found */
    tstring bkt_to_find;			/* Ĥ٤ڥγ */
    size_t depth_bkt = 0;			/* ̤ο */

    /* Хåե: */
    /* ŪˤϺǽϥåȤ­ʤʤäҡפڤؤ */
    char ret_s_stk[LEN_RET_S_STK];		/* result for temp string */
    char *ret_s_heap = NULL;
    size_t len_ret_s_buf = LEN_RET_S_STK;
    char *ret_s = ret_s_stk;
    size_t ix_ret_s = 0;			/* current index of ret_s */
    size_t ix0_ret_s = 0;			/* first pos of current elem */

    union _ret_p {
	char *ptr;
	size_t offset;
    };
    union _ret_p ret_p_stk[LEN_RET_P_STK];	/* result for temp str ptrs */
    union _ret_p *ret_p_heap = NULL;
    size_t len_ret_p_buf = LEN_RET_P_STK;
    union _ret_p *ret_p = ret_p_stk;
    size_t ix_ret_p = 0;			/* current index of ret_p */

    bool reg_delims = false;
    tstring accepts;
    bool ac_bl;
    int ac_flg = 0;
    size_t i;

    if ( src_str == NULL ) {
	retobjp->assign(src_str, 1);
	goto quit;
    }
    if ( delims == NULL ) delims = "";

    /* check [A-Z] style */
    if ( delims[0] == '[' ) {
	for ( i=0 ; delims[i] != '\0' ; i++ );
	if ( delims[i-1] == ']' ) {
	    size_t p0 = 0;
	    p0 += make_accepts_regexp(delims, true, accepts, &ac_flg, &ac_bl);
	    if ( p0 != 0 ) reg_delims = true;
	}
    }

    /* len_src_str  0 Ǥʤ硤餫­ʤϥҡפڤؤ */
    if ( LEN_RET_S_STK < len_src_str + 1 ) {
	ret_s_heap = (char *)malloc(len_src_str + 1);
	if ( ret_s_heap == NULL ) {
	    err_throw(__FUNCTION__,"FATAL","malloc() failed");
	}
	len_ret_s_buf = len_src_str + 1;
	ret_s = ret_s_heap;
    }

    /*
     * setup quotations and bracket info: quot[] bkt_l[] bkt_r[]
     */
    if ( quot_bkt != NULL ) {
	bool b0=false, b1=false, b2=false, b3=false;
	size_t j=0, k=0;
	for ( i=0 ; quot_bkt[i] != '\0' ; i++ ) {
	    const char ch = quot_bkt[i];
	    if ( ch == '[' || ch == ']' ) {
		if ( b0 == false ) {
		    bkt_l[k] = '[';  bkt_r[k] = ']';
		    k++;  b0 = true;
		}
	    }
	    else if ( ch == '{' || ch == '}' ) {
		if ( b1 == false ) {
		    bkt_l[k] = '{';  bkt_r[k] = '}';
		    k++;  b1 = true;
		}
	    }
	    else if ( ch == '(' || ch == ')' ) {
		if ( b2 == false ) {
		    bkt_l[k] = '(';  bkt_r[k] = ')';
		    k++;  b2 = true;
		}
	    }
	    else if ( ch == '<' || ch == '>' ) {
		if ( b3 == false ) {
		    bkt_l[k] = '<';  bkt_r[k] = '>';
		    k++;  b3 = true;
		}
	    }
	    else {
		quot[j] = ch;
		if ( j + 1 < 96 ) j++;
	    }
	}
	quot[j] = '\0';
	bkt_l[k] = '\0';
	bkt_r[k] = '\0';
    }
    else {
	quot[0] = '\0';
	bkt_l[0] = '\0';
	bkt_r[0] = '\0';
    }

    /*
     * parse src_str
     */

    try {
      for ( i=0 ; src_str[i] != '\0' ; i++ ) {
	char ch = src_str[i];
	bool cpy_ok = true;
	if ( prev_escape == true ) {		/* chrescapeʸʤ */
	    prev_escape = false;
	}
	else if ( ch == escape ) {		/* chrescapeʸʤ */
	    if ( rm_escape == true ) cpy_ok = false;
	    prev_escape = true;
	}
	else if ( quot_to_find != '\0' ) {	/* ڥ quot 򸫤Ĥ */
	    if ( ch == quot_to_find ) quot_to_find = '\0';
	}
	else {
	    size_t j;
	    /* quot γϤ򸫤Ĥ */
	    for ( j=0 ; quot[j] != '\0' ; j++ ) {
		if ( ch == quot[j] ) {
		    quot_to_find = ch;
		    break;
		}
	    }
	    if ( quot[j] == '\0' ) {
		/* γ̤򸫤Ĥ */
		for ( j=0 ; bkt_l[j] != '\0' ; j++ ) {
		    if ( ch == bkt_l[j] ) {
			bkt_to_find.at(depth_bkt) = bkt_r[j];
			depth_bkt ++;
			break;
		    }
		}
	    }
	    if ( bkt_l[j] == '\0' ) {
		/* ڥγ̤򸫤Ĥ */
		if ( 0 < depth_bkt ) {
		    if ( ch == bkt_to_find.at_cs(depth_bkt-1) ) {
			depth_bkt --;
		    }
		}
		/* 褦䤯ǶڤʸȽ */
		else {
		    if ( reg_delims == true ) {
			if ( is_found(ch, accepts.cstr(), ac_flg) == ac_bl ) {
			    ch = '\0';
			}
		    }
		    else {
			for ( j=0 ; delims[j] != '\0' ; j++ ) {
			    if ( ch == delims[j] ) {
				ch = '\0';
				break;
			    }
			}
		    }
		}
	    }
	}
	if ( cpy_ok == true ) {

	    /* Хåե˳Ǽ */
	    if ( len_ret_s_buf <= ix_ret_s + 1 ) {
		size_t ii, len_realloc;
		if ( len_src_str == 0 ) {
		    /* src_strĹξĴ٤Ƥޤ */
		    for ( ii=0 ; src_str[i + ii] != '\0' ; ii++ );
		    len_realloc = i + ii + 1;
		} else len_realloc = len_src_str + 1;

		if ( ret_s_heap == NULL ) {
		    ret_s_heap = (char *)malloc(len_realloc);
		    if ( ret_s_heap == NULL ) {
			err_throw(__FUNCTION__,"FATAL","malloc() failed");
		    }
		    c_memcpy(ret_s_heap, ret_s, len_ret_s_buf);
		}
		else {
		    void *tmp_ptr = realloc(ret_s_heap, len_realloc);
		    if ( tmp_ptr == NULL ) {
			err_throw(__FUNCTION__,"FATAL","realloc() failed");
		    }
		    ret_s_heap = (char *)tmp_ptr;
		}
		ret_s = ret_s_heap;
		len_ret_s_buf = len_realloc;
	    }
	    ret_s[ix_ret_s] = ch;
	    ix_ret_s ++;

	    /* ڤʸäν: ɥ쥹ơ֥Ͽ */
	    if ( ch == '\0' ) {
		if ( zero_str == true || ix0_ret_s + 1 < ix_ret_s ) {
		    if ( len_ret_p_buf <= ix_ret_p + 2 ) {
			size_t len_realloc = len_ret_p_buf * 2;
			if ( ret_p_heap == NULL ) {
			    ret_p_heap = (union _ret_p *)malloc(sizeof(*ret_p_heap)*len_realloc);
			    if ( ret_p_heap == NULL ) {
				err_throw(__FUNCTION__,"FATAL","malloc() failed");
			    }
			    c_memcpy(ret_p_heap, ret_p, sizeof(*ret_p_heap)*len_ret_p_buf);
			}
			else {
			    void *tmp_ptr = realloc(ret_p_heap, sizeof(*ret_p_heap)*len_realloc);
			    if ( tmp_ptr == NULL ) {
				err_throw(__FUNCTION__,"FATAL","realloc() failed");
			    }
			    ret_p_heap = (union _ret_p *)tmp_ptr;
			}
			ret_p = ret_p_heap;
			len_ret_p_buf = len_realloc;
		    }
		    ret_p[ix_ret_p].offset = ix0_ret_s;
		    ix_ret_p ++;
		}
		ix0_ret_s = ix_ret_s;
	    }
	}
      }
    }
    catch (...) {
	if ( ret_p_heap != NULL ) {
	    free(ret_p_heap);
	    ret_p_heap = NULL;
	}
	if ( ret_s_heap != NULL ) {
	    free(ret_s_heap);
	    ret_s_heap = NULL;
	}
	err_throw(__FUNCTION__,"FATAL","caught exception");
    }
    ret_s[ix_ret_s] = '\0';
    ix_ret_s ++;
    if ( zero_str == true || ix0_ret_s + 1 < ix_ret_s ) {
	ret_p[ix_ret_p].offset = ix0_ret_s;
	ix_ret_p ++;
    }
    ret_p[ix_ret_p].ptr = NULL;
    for ( i=0 ; i < ix_ret_p ; i++ ) {
	size_t off = ret_p[i].offset;
	ret_p[i].ptr = ret_s + off;
    }

    try {
	retobjp->erase();
	retobjp->append((char **)ret_p);
    }
    catch (...) {
	if ( ret_p_heap != NULL ) {
	    free(ret_p_heap);
	    ret_p_heap = NULL;
	}
	if ( ret_s_heap != NULL ) {
	    free(ret_s_heap);
	    ret_s_heap = NULL;
	}
	err_throw(__FUNCTION__,"FATAL","this->append() failed");
    }


 quit:
    if ( ret_p_heap != NULL ) free(ret_p_heap);
    if ( ret_s_heap != NULL ) free(ret_s_heap);
    return;
}

/* ʰexplode (®) */

/**
 * @brief  ꤵ줿ʸڤʸʬ䤷η̤򼫿Ȥ
 *
 *  ʸsrc_strڤʸdelimʬ䤷η̤ʸȤƼȤ
 *  ޤʸĹǤޤ(csvʬ˻Ȥޤ)<br>
 *  Ūˤϡ::פΤ褦2ʸʾζڤʸλ˻ȤΤǤ
 *
 * @param      src_str ʬоݤʸ
 * @param      delim ڤʸ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @note       ƤꤷƤ뤿ᡤŪ˹®ưޤ
 */
tarray_tstring &tarray_tstring::explode(const char *src_str, const char *delim,
					bool zero_str )
{
    explode_php(src_str, 0, delim, zero_str, this);
    return *this;
}

/**
 * @brief  ꤵ줿ʸڤʸʬ䤷η̤򼫿Ȥ
 *
 *  ʸsrc_strڤʸdelimʬ䤷η̤ʸȤƼȤ
 *  ޤʸĹǤޤ(csvʬ˻Ȥޤ)<br>
 *  Ūˤϡ::פΤ褦2ʸʾζڤʸλ˻ȤΤǤ
 *
 * @param      src_str ʬоݤʸ
 * @param      delim ڤʸ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @note       ƤꤷƤ뤿ᡤŪ˹®ưޤ
 */
tarray_tstring &tarray_tstring::explode(const tstring &src_str, const char *delim,
					bool zero_str )
{
    explode_php(src_str.cstr(), src_str.length(), delim, zero_str, this);
    return *this;
}

/* ¿ǽexplode */

/*
 * New member functions of 1.3.0
 */

/**
 * @brief  ʸڤʸʬ䤷η̤򼫿Ȥ(¿ǽ)
 *
 *  ʸsrc_strڤʸdelimʬ䤷η̤ʸȤƼȤ
 *  ޤʸĹǤޤ(csvʬ˻Ȥޤ)<br>
 *  Ūˤϡ::פΤ褦2ʸʾζڤʸλ˻ȤΤǤ<br>
 *  ơ̤ΡʸפǰϤޤ줿ʸʬ䤷ʤ硤
 *  quot_bkt ˡʸפꤷޤ
 *
 * @param      src_str ʬоݤʸ
 * @param      delim ڤʸ
 * @param      quot_bkt ơ󡦥֥饱åʸޤʸ
 * @param      escape ʸ
 * @param      rm_escape ʸ뤫ɤΥե饰(true/false)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 */
tarray_tstring &tarray_tstring::explode(const char *src_str, const char *delim,
	      bool zero_str, const char *quot_bkt, int escape, bool rm_escape )
{
    explode_advanced(src_str, 0, delim, zero_str,
		     quot_bkt, escape, rm_escape, this);
    return *this;
}

/**
 * @brief  ʸڤʸʬ䤷η̤򼫿Ȥ(¿ǽ)
 *
 *  ʸsrc_strڤʸdelimʬ䤷η̤ʸȤƼȤ
 *  ޤʸĹǤޤ(csvʬ˻Ȥޤ)<br>
 *  Ūˤϡ::פΤ褦2ʸʾζڤʸλ˻ȤΤǤ<br>
 *  ơ̤ΡʸפǰϤޤ줿ʸʬ䤷ʤ硤
 *  quot_bkt ˡʸפꤷޤ
 *
 * @param      src_str ʬоݤʸ
 * @param      delim ڤʸ
 * @param      quot_bkt ơ󡦥֥饱åʸޤʸ
 * @param      escape ʸ
 * @param      rm_escape ʸ뤫ɤΥե饰(true/false)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 */
tarray_tstring &tarray_tstring::explode(const tstring &src_str, const char *delim,
		bool zero_str, const char *quot_bkt, int escape, bool rm_escape )
{
    explode_advanced(src_str.cstr(), src_str.length(), delim, 
		     zero_str, quot_bkt, escape, rm_escape, this);
    return *this;
}


/* ʰsplit (®) */

/**
 * @brief  ꤵ줿ʸڤʸʬ䤷η̤򼫿Ȥ
 *
 *  ʸ src_str ڤʸ delims ʬ䤷η̤ʸȤ
 *  Ȥޤ
 *
 * @param      src_str ʬоݤʸ
 * @param      delims ڤʸޤʸ[A-Z] ȤäɽѲǽ
 * @param      zero_str ʬĹ0 ʸǤݤ(true/false)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @note       ƤꤷƤ뤿ᡤŪ˹®ưޤ
 *
 */
tarray_tstring &tarray_tstring::split( const char *src_str,
				       const char *delims, bool zero_str )
{
    split_simple( src_str, 0, delims, zero_str, this );
    return *this;
}

/**
 * @brief  ꤵ줿ʸڤʸʬ䤷η̤򼫿Ȥ
 *
 *  ʸ src_str ڤʸ delims ʬ䤷η̤ʸȤ
 *  Ȥޤ
 *
 * @param      src_str ʬоݤʸ
 * @param      delims ڤʸޤʸ[A-Z] ȤäɽѲǽ
 * @param      zero_str ʬĹ0 ʸǤݤ(true/false)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @note       ƤꤷƤ뤿ᡤŪ˹®ưޤ
 *
 */
tarray_tstring &tarray_tstring::split( const tstring &src_str,
				       const char *delims, bool zero_str )
{
    split_simple( src_str.cstr(), src_str.length(), delims, zero_str, this );
    return *this;
}


/* ¿ǽsplit */

/*
 * ʸ line ڤʸ delims ʬ䤹롥[A-Z] Ȥäɽ OK
 * [...]ɽˤĤƤϡtstring 饹 strpbrk() 򻲾ȤΤȡ
 *
 * ơȥʸ quot_bkt  escape ꤹ롥
 *
 * [ʬ]
 *   foo name="bar \"hoge\" <xyz>"
 *    fooסname="bar \"hoge\" <xyz>" ʬ
 *
 * zero_str  length=0 ʸɤtrue ξ硤"a,,c" ξ硤
 * "a", "", "c" Τ褦ʬ䤵롥
 *
 * quot_bkt  Version 1.3.0 ֥饱åȤˤбΤ褦ʬOK
 *   1,2,{3,4,5}
 *    1ס2ס{3,4,5}
 * ֥饱åȤμϡ[] {} () <> 4 quot_bkt  "[]{}" Τ褦˻
 * 롥̤ΥơȺơ"'\"[]{}" Τ褦ˤƤɤ
 * ϡơͥ٤⤤ΤȤư롥
 *
 * split() κǽΰϡNULL Ǥɤξ硤el=cstringarray() Ȥ
 * 硤el[0]  "" ˤʤ롥
 *
 * [1]
 *   tarray_tstring sobj;
 *   sobj.split(str, " \t", false, "\"", '\\');
 *   for ( i=0 ; i < sobj.length() ; i++ ) {
 *       printf("%d: [%s]\n", i, sobj.cstr(i));
 *   }
 */

/**
 * @brief  ʸڤʸʬ䤷η̤򼫿Ȥ(¿ǽ)
 *
 *  ʸ src_str ڤʸ delims ʬ䤷η̤ʸȤ
 *  Ȥޤ<br>
 *  ơ̤ΡʸפǰϤޤ줿ʸʬ䤷ʤ硤
 *  quot_bkt ˡʸפꤷޤ
 *
 * @param      src_str ʬоݤʸ
 * @param      delims ڤʸޤʸ[A-Z] ȤäɽѲǽ
 * @param      zero_str ʬĹ0 ʸǤݤ(true/false)
 * @param      quot_bkt ơ󡦥֥饱åʸޤʸ
 * @param      escape ʸ
 * @param      rm_escape ʸ뤫ɤΥե饰(true/false)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::split( const char *src_str, const char *delims,
				       bool zero_str, const char *quot_bkt,
				       int escape, bool rm_escape )
{
    split_advanced( src_str, 0, delims, zero_str, 
		    quot_bkt, escape, rm_escape, this );
    return *this;
}

/**
 * @brief  ʸڤʸʬ䤷η̤򼫿Ȥ(¿ǽ)
 *
 *  ʸ src_str ڤʸ delims ʬ䤷η̤ʸȤ
 *  Ȥޤ<br>
 *  ơ̤ΡʸפǰϤޤ줿ʸʬ䤷ʤ硤
 *  quot_bkt ˡʸפꤷޤ
 *
 * @param      src_str ʬоݤʸ
 * @param      delims ڤʸޤʸ[A-Z] ȤäɽѲǽ
 * @param      zero_str ʬĹ0 ʸǤݤ(true/false)
 * @param      quot_bkt ơ󡦥֥饱åʸޤʸ
 * @param      escape ʸ
 * @param      rm_escape ʸ뤫ɤΥե饰(true/false)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::split( const tstring &src_str, 
				       const char *delims,
				       bool zero_str, const char *quot_bkt,
				       int escape, bool rm_escape )
{
    split_advanced( src_str.cstr(), src_str.length(), delims, zero_str, 
		    quot_bkt, escape, rm_escape, this );
    return *this;
}


/* regassign */

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pat ʸѥ(ɽ)
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const char *src_str, const char *pat )
{
    tstring one = src_str;
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(one, 0, this->regex_rec, NULL);
    return *this;
}    

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      pat ʸѥ(ɽ)
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const char *src_str, size_t pos,
					   const char *pat )
{
    tstring one = src_str;
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(one, pos, this->regex_rec, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      pat ʸѥ(ɽ)
 * @param      nextpos pos
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const char *src_str, size_t pos,
					   const char *pat, size_t *nextpos )
{
    tstring one = src_str;
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(one, pos, this->regex_rec, nextpos);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pat ʸѥ(ɽ)
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign(const tstring &src_str, const char *pat)
{
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(src_str, 0, this->regex_rec, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      pat ʸѥ(ɽ)
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const tstring &src_str, size_t pos,
					   const char *pat )
{
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(src_str, pos, this->regex_rec, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      pat ʸѥ(ɽ)
 * @param      nextpos pos
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const tstring &src_str, size_t pos,
					   const char *pat, size_t *nextpos )
{
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(src_str, pos, this->regex_rec, nextpos);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pat ʸѥ(ɽ)
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign(const char *src_str, const tstring &pat)
{
    tstring one = src_str;
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(one, 0, this->regex_rec, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      pat ʸѥ(ɽ)
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const char *src_str, size_t pos,
					   const tstring &pat )
{
    tstring one = src_str;
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(one, pos, this->regex_rec, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      pat ʸѥ(ɽ)
 * @param      nextpos pos
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const char *src_str, size_t pos,
					  const tstring &pat, size_t *nextpos )
{
    tstring one = src_str;
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(one, pos, this->regex_rec, nextpos);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pat ʸѥ(ɽ)
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const tstring &src_str, 
					   const tstring &pat)
{
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(src_str, 0, this->regex_rec, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      pat ʸѥ(ɽ)
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const tstring &src_str, size_t pos,
					   const tstring &pat )
{
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(src_str, pos, this->regex_rec, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      pat ʸѥ(ɽ)
 * @param      nextpos pos
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const tstring &src_str, size_t pos,
					  const tstring &pat, size_t *nextpos )
{
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    this->regexp_match_advanced(src_str, pos, this->regex_rec, nextpos);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      tregex 饹ɽѥѥ֥
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign(const char *src_str, const tregex &pat)
{
    tstring one = src_str;
    this->regexp_match_advanced(one, 0, pat, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      tregex 饹ɽѥѥ֥
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const char *src_str, size_t pos,
					   const tregex &pat )
{
    tstring one = src_str;
    this->regexp_match_advanced(one, pos, pat, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      tregex 饹ɽѥѥ֥
 * @param      nextpos pos
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const char *src_str, size_t pos,
					   const tregex &pat, size_t *nextpos )
{
    tstring one = src_str;
    this->regexp_match_advanced(one, pos, pat, nextpos);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      tregex 饹ɽѥѥ֥
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const tstring &src_str,
					   const tregex &pat )
{
    this->regexp_match_advanced(src_str, 0, pat, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      tregex 饹ɽѥѥ֥
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const tstring &src_str, size_t pos,
					   const tregex &pat )
{
    this->regexp_match_advanced(src_str, pos, pat, NULL);
    return *this;
}

/**
 * @brief  ʸɽޥåԤȤޤ̤򼫿Ȥ˳Ǽ
 *
 *  ʸsrc_strФpatǻꤵ줿POSIX ĥɽ(ʲɽ)
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 *
 * @param      src_str ޥåоݤʸ
 * @param      pos ʸޥåγϰ
 * @param      tregex 饹ɽѥѥ֥
 * @param      nextpos pos
 * @return     Ȥλ
 * @throw      regex롼󤬥Ȥ̤Ƥ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      ˲򵯤
 *
 */
tarray_tstring &tarray_tstring::regassign( const tstring &src_str, size_t pos,
					   const tregex &pat, size_t *nextpos )
{
    this->regexp_match_advanced(src_str, pos, pat, nextpos);
    return *this;
}

/**
 * @brief  ѥ˥顼Ϥ뤿ΥߡΥдؿ
 * @deprecated  Բġ
 * @note	ΥдؿprivateǤ
 */
tarray_tstring &tarray_tstring::append( size_t n )
{
    return this->replace(this->length(),0, n);
}

/**
 * @brief  ꤵ줿ʸ(const char *[])򡤼ȤκǸɲ
 *
 *  elementsǻꤵ줿ʸ򡤼ȤκǸʹߤɲäޤ
 *
 * @param      elements ǤʸΥݥ(NULL ǽü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::append( const char *const *elements )
{
    size_t i;
    if ( elements == NULL ) return this->append(elements, 0);
    for ( i=0 ; elements[i] != NULL ; i++ );
    return this->append(elements,i);
}

/**
 * @brief  ʸ(const char *[])nǤ򡤼ȤκǸɲ
 *
 *  elementsǻꤵ줿ʸ򡤼ȤκǸʹߤɲäޤ
 *
 * @param      elements ǤʸΥݥ
 * @param      n elements ǿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::append( const char *const *elements, size_t n )
{
    return this->replace(this->length(), 0, elements, n);
}

/**
 * @brief  ʸ(tarray_tstring)()Ǥ򡤼ȤκǸɲ
 *
 *  srcǻꤵ줿ʸ򡤼ȤκǸʹߤɲäޤ
 *
 * @param     src Ȥʤʸtarray_tstring 饹Υ֥
 * @param     idx2 src Ǥγϰ
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::append(const tarray_tstring &src, size_t idx2)
{
    return this->append(src, idx2, src.length());
}

/**
 * @brief  ʸ(tarray_tstring)()Ǥ򡤼ȤκǸɲ
 *
 *  srcǻꤵ줿ʸ򡤼ȤκǸʹߤɲäޤ
 *
 * @param    src Ȥʤʸtarray_tstring 饹Υ֥
 * @param    idx2 srcǤγϰ
 * @param    n2 src ǤθĿ
 * @return   Ȥλ
 * @throw    Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::append( const tarray_tstring &src, 
					size_t idx2, size_t n2 )
{
    return this->replace(this->length(), 0, src, idx2, n2);
}

/**
 * @brief  ȤκǸˡꤵ줿ʣʸɲ
 *
 *  Ѱǻꤵ줿ʣʸ򡤼ȤκǸʹߤɲäޤ
 *
 * @param      el0 Ȥʤʸ(0 )
 * @param      el1 Ȥʤʸ(1 )
 * @param      ... Ȥʤʸ(2 ܰʹ; NULL ü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::append( const char *el0, const char *el1, ... )
{
    va_list ap;
    va_start(ap, el1);
    try {
	this->vappend( el0, el1, ap );
    }
    catch (...) {
	va_end(ap);
	err_throw(__FUNCTION__,"FATAL","this->vappend() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ȤκǸˡꤵ줿ʣʸɲ
 *
 *  Ѱǻꤵ줿ʣʸ򡤼ȤκǸʹߤɲäޤ
 *
 * @param      el0 Ȥʤʸ(0 )
 * @param      el1 Ȥʤʸ(1 )
 * @param      ap ȤʤʸβĹΥꥹ(2 ܰʹ; NULL ü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::vappend( const char *el0, const char *el1,
					 va_list ap )
{
    heap_mem<const char *> tmp_ptbl;
    size_t element_count, i;
    va_list aq;

    va_copy(aq, ap);

    element_count = 0;
    if ( el0 != NULL ) {
        element_count++;
	if ( el1 != NULL ) {
	    element_count++;
	    while ( 1 ) {
	        const char *elem = va_arg(aq,char *);
		if ( elem == NULL ) break;
		element_count++;
	    }
	}
    }
    va_end(aq);

    if ( tmp_ptbl.allocate(element_count + 1) < 0 ) {
	err_throw(__FUNCTION__,"FATAL","malloc() failed");
    }

    i = 0;
    if ( el0 != NULL ) {
        tmp_ptbl[i] = el0;
        i++;
	if ( el1 != NULL ) {
	    tmp_ptbl[i] = el1;
	    i++;
	    while ( 1 ) {
	        const char *elem = va_arg(ap,char *);
		if ( elem == NULL ) break;
		tmp_ptbl[i] = elem;
		i++;
	    }
	}
    }
    tmp_ptbl[i] = NULL;

    this->append(tmp_ptbl.ptr());

    return *this;
}

/**
 * @brief  ȤκǸˡꤵ줿ʸ(const char *)nɲ
 *
 *  ȤκǸˡꤵ줿ʸnĤɲäޤ
 *
 * @param      str Ȥʤʸ
 * @param      n ɲǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::append( const char *str, size_t n )
{
    return this->replace(this->length(), 0, str, n);
}

/**
 * @brief  ȤκǸˡꤵ줿ʸ(tstring)nɲ
 *
 *  ȤκǸˡꤵ줿ʸnĤɲäޤ
 *
 * @param      one Ȥʤʸ(ޥ˥奢Ǥstr)
 * @param      n ɲǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::append( const tstring &one, size_t n )
{
    return this->replace(this->length(), 0, one, n);
}

/**
 * @brief  ȤκǸˡꤵ줿ʸ(printf()εˡǻ)nɲ
 *
 *  ȤκǸˡꤵ줿ʸnĤɲäޤ
 *
 * @param      n ɲǤθĿ
 * @param      format ȤʤʸΤΥեޥåȻ
 * @param      ... formatбĹγǥǡ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      Ĺγǥǡꤵ줿ѴեޥåȤѴ
 *             Ǥʤͤξ
 *
 */
tarray_tstring &tarray_tstring::appendf( size_t n, const char *format, ... )
{
    va_list ap;
    va_start(ap,format);
    try {
	this->vappendf(n,format,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vappendf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ȤκǸˡꤵ줿ʸ(printf()εˡǻ)nɲ
 *
 *  ȤκǸˡꤵ줿ʸnĤɲäޤ
 *
 * @param      n ɲǤθĿ
 * @param      format ȤʤʸΤΥեޥåȻ
 * @param      ... formatбĹγǥǡ
 * @param      ap formatбĹΥꥹ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      Ĺγǥǡꤵ줿ѴեޥåȤ
 *             ѴǤʤͤξ
 *
 */
tarray_tstring &tarray_tstring::vappendf(size_t n, const char *format, va_list ap)
{
    tstring one;

    if ( format == NULL ) return this->append(format,n);

    try {
	one.vprintf(format,ap);
    }
    catch (...) {
	err_throw(__FUNCTION__,"FATAL","one.vprintf() failed");
    }
    this->append(one,n);

    return *this;
}

/**
 * @brief  ѥ˥顼Ϥ뤿ΥߡΥдؿ
 * @deprecated  Բġ
 * @note	ΥдؿprivateǤ
 */
tarray_tstring &tarray_tstring::insert( size_t index, size_t n )
{
    return this->replace(index,0, n);
}

/**
 * @brief  ꤵ줿ʸ(const char *[])򡤼Ȥλ֤
 *
 *  elementsǻꤵ줿ʸ򡤼Ȥʸλindex
 *  ޤ
 *
 * @param      index Ȥ
 * @param      elements ȤʤʸΥݥ(NULL ǽü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::insert( size_t index, 
					const char *const *elements )
{
    size_t i;
    if ( elements == NULL ) return this->insert(index,elements, 0);
    for ( i=0 ; elements[i] != NULL ; i++ );
    return this->insert(index,elements,i);
}

/**
 * @brief  ʸ(const char *[])nǤ򡤼Ȥλ֤
 *
 *  elementsǻꤵ줿ʸ򡤼Ȥʸλindex
 *  ޤ
 *
 * @param      index Ȥ
 * @param      elements ȤʤʸΥݥ
 * @param      n elements ǿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::insert( size_t index, 
					const char *const *elements, size_t n )
{
    return this->replace(index, 0, elements, n);
}

/**
 * @brief  ʸ(tarray_tstring)()Ǥ򡤼Ȥλ֤
 *
 *  srcǻꤵ줿ʸ򡤼Ȥʸλindexޤ
 *
 * @param     index Ȥ
 * @param     src Ȥʤʸtarray_tstring 饹Υ֥
 * @param     idx2 src Ǥγϰ
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::insert( size_t index,
					const tarray_tstring &src, size_t idx2)
{
    return this->insert(index, src, idx2, src.length());
}

/**
 * @brief  ʸ(tarray_tstring)()Ǥ򡤼Ȥλ֤
 *
 *  srcǻꤵ줿ʸ򡤼Ȥʸλindexޤ
 *
 * @param     index Ȥ
 * @param     src Ȥʤʸtarray_tstring 饹Υ֥
 * @param     idx2 src Ǥγϰ
 * @param     n2 src ǤθĿ
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::insert( size_t index, 
					const tarray_tstring &src, 
					size_t idx2, size_t n2 )
{
    return this->replace(index, 0, src, idx2, n2);
}

/**
 * @brief  ꤵ줿ʣʸ򡤼Ȥλ֤
 *
 *  Ѱǻꤵ줿ʸ򡤼Ȥʸλindex
 *  ޤ
 *
 * @param      index Ȥ
 * @param      el0 Ȥʤʸ(0 )
 * @param      el1 Ȥʤʸ(1 )
 * @param      ... Ȥʤʸ(2 ܰʹ; NULL ü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::insert( size_t index, 
					const char *el0, const char *el1, ... )
{
    va_list ap;
    va_start(ap, el1);
    try {
	this->vinsert( index, el0, el1, ap );
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vinsert() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿ʣʸ򡤼Ȥλ֤
 *
 *  Ѱǻꤵ줿ʸ򡤼Ȥʸλindex
 *  ޤ
 *
 * @param      index Ȥ
 * @param      el0 Ȥʤʸ(0 )
 * @param      el1 Ȥʤʸ(1 )
 * @param      ap ȤʤʸβĹΥꥹ(2 ܰʹ; NULL ü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::vinsert( size_t index, 
				 const char *el0, const char *el1, va_list ap )
{
    heap_mem<const char *> tmp_ptbl;
    size_t element_count, i;
    va_list aq;

    va_copy(aq, ap);

    element_count = 0;
    if ( el0 != NULL ) {
        element_count++;
	if ( el1 != NULL ) {
	    element_count++;
	    while ( 1 ) {
	        const char *elem = va_arg(aq,char *);
		if ( elem == NULL ) break;
		element_count++;
	    }
	}
    }
    va_end(aq);

    if ( tmp_ptbl.allocate(element_count + 1) < 0 ) {
	err_throw(__FUNCTION__,"FATAL","malloc() failed");
    }

    i = 0;
    if ( el0 != NULL ) {
        tmp_ptbl[i] = el0;
        i++;
	if ( el1 != NULL ) {
	    tmp_ptbl[i] = el1;
	    i++;
	    while ( 1 ) {
	        const char *elem = va_arg(ap,char *);
		if ( elem == NULL ) break;
		tmp_ptbl[i] = elem;
		i++;
	    }
	}
    }
    tmp_ptbl[i] = NULL;

    this->insert(index, tmp_ptbl.ptr());

    return *this;
}

/**
 * @brief  Ȥλ֤ˡꤵ줿ʸ(const char *)n
 *
 *  Ȥʸֹindexΰ֤ˡꤵ줿ʸnĤ
 *  ޤ
 *
 * @param      index Ȥ
 * @param      str Ȥʤʸ
 * @param      n ɲǤθĿ
 * @return     Ȥλ
 *
 */
tarray_tstring &tarray_tstring::insert( size_t index, 
					const char *str, size_t n )
{
    return this->replace(index, 0, str, n);
}

/**
 * @brief  Ȥλ֤ˡꤵ줿ʸ(tstring)n
 *
 *  Ȥʸֹindexΰ֤ˡꤵ줿ʸnĤ
 *  ޤ
 *
 * @param      index Ȥ
 * @param      one Ȥʤʸ(ޥ˥奢Ǥstr)
 * @param      n ɲǤθĿ
 * @return     Ȥλ
 *
 */
tarray_tstring &tarray_tstring::insert( size_t index, 
					const tstring &one, size_t n )
{
    return this->replace(index, 0, one, n);
}

/**
 * @brief  Ȥλ֤ˡꤵ줿ʸ(printf()εˡ)n
 *
 *  Ȥʸֹindexΰ֤ˡꤵ줿ʸnĤ
 *  ޤ
 *
 * @param      index Ȥ
 * @param      n ɲǤθĿ
 * @param      format ȤʤʸΤΥեޥåȻ
 * @param      ... format бĹγǥǡ
 * @return     Ȥλ
 *
 */
tarray_tstring &tarray_tstring::insertf( size_t index, 
					 size_t n, const char *format, ...)
{
    va_list ap;
    va_start(ap,format);
    try {
	this->vinsertf(index,n,format,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vinsertf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  Ȥλ֤ˡꤵ줿ʸ(printf()εˡ)n
 *
 *  Ȥʸֹindexΰ֤ˡꤵ줿ʸnĤ
 *  ޤ
 *
 * @param      index Ȥ
 * @param      n ɲǤθĿ
 * @param      format ȤʤʸΤΥեޥåȻ
 * @param      ap format бĹΥꥹ
 * @return     Ȥλ
 *
 */
tarray_tstring &tarray_tstring::vinsertf( size_t index, 
					size_t n, const char *format, va_list ap )
{
    tstring one;

    if ( format == NULL ) return this->insert(index,format,n);

    try {
	one.vprintf(format,ap);
    }
    catch (...) {
	err_throw(__FUNCTION__,"FATAL","one.vprintf() failed");
    }
    this->insert(index,one,n);

    return *this;
}

/**
 * @brief  ѥ˥顼Ϥ뤿ΥߡΥдؿ
 * @deprecated  Բġ
 * @note	ΥдؿprivateǤ 
 */
tarray_tstring &tarray_tstring::replace( size_t idx1, size_t n1, size_t n2 )
{
    static tstring one(true);

    this->arrs_rec.replace(idx1,n1, one,n2);

    this->update_cstr_ptrs_rec();

    return *this;
}

/**
 * @brief  ΰޤ򡤻ꤵ줿ʸ(const char *[])ִ
 *
 *  Ȥʸֹidx1n1ĤǤelementsǻꤵ줿
 *  ʸִޤ
 *
 * @param      idx1 Ȥγϰ
 * @param      n1 ִǿ
 * @param      elements ȤʤʸΥݥ(NULL ǽü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::replace( size_t idx1, size_t n1,
					 const char *const *elements )
{
    size_t i;
    if ( elements == NULL ) return this->replace(idx1,n1, elements,0);
    for ( i=0 ; elements[i] != NULL ; i++ );
    return this->replace(idx1,n1, elements,i);
}

/**
 * @brief  ΰޤ򡤻ꤵ줿ʸ(const char *[])ִ
 *
 *  Ȥʸֹidx1n1ĤǤelementsǻꤵ줿
 *  ʸִޤ
 *
 * @param      idx1 Ȥγϰ
 * @param      n1 ִǿ
 * @param      elements ȤʤʸΥݥ(NULL ǽü)
 * @param      n2 elements ǿޤsrc ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::replace( size_t idx1, size_t n1,
				       const char *const *elements, size_t n2 )
{
    size_t i;
    tarray<tstring> tmp_src;

    if ( 0 < n2 && elements == NULL ) return *this;

    /* n2 꾮б */
    for ( i=0 ; i < n2 && elements[i] != NULL ; i++ );
    n2 = i;

    /* elements ʸ˼ȤƤʸäƤ뤫ɤ
       this->is_my_buffer(elements) ǤϴĴ٤ʤΤԡ */
    if ( 0 < n2 ) {
	tmp_src.resize(n2);
	for ( i=0 ; i < n2 ; i++ ) tmp_src[i] = elements[i];
    }

    this->arrs_rec.replace(idx1,n1, tmp_src,0,n2);

    this->update_cstr_ptrs_rec();

    return *this;
}

/**
 * @brief  ΰޤ򡤻ꤵ줿ʸ(tarray_tstring)ִ
 *
 *  ȤǤΰidx1n1ĤǤsrcǻꤵ줿ʸ
 *  ִޤ
 *
 * @param     idx1 Ȥγϰ
 * @param     n1 ִǿ
 * @param     src Ȥʤʸtarray_tstring 饹Υ֥
 * @param     idx2 src Ǥγϰ
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::replace( size_t idx1, size_t n1,
				       const tarray_tstring &src, size_t idx2 )
{
    return this->replace(idx1, n1, src, idx2, src.length());
}

/**
 * @brief  ΰޤ򡤻ꤵ줿ʸ(tarray_tstring)ִ
 *
 *  ȤǤΰidx1n1ĤǤsrcǻꤵ줿ʸ
 *  ִޤ
 *
 * @param     idx1 Ȥγϰ
 * @param     n1 ִǿ
 * @param     src Ȥʤʸtarray_tstring 饹Υ֥
 * @param     idx2 srcǤγϰ
 * @param     n2 srcǤθĿ
 * @return    Ȥλ
 * @throw     Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::replace( size_t idx1, size_t n1,
					 const tarray_tstring &src, 
					 size_t idx2, size_t n2 )
{
    this->arrs_rec.replace(idx1,n1, src.arrs_rec,idx2,n2);

    this->update_cstr_ptrs_rec();

    return *this;
}

/**
 * @brief  ΰޤ򡤻ꤵ줿ʣʸִ
 *
 *  ȤǤΰidx1n1ĤǤ򡤲Ѱǻꤵ줿
 *  ʣʸǻꤵ줿ʸִޤ
 *
 * @param      idx1 Ȥγϰ
 * @param      n1 ִǿ
 * @param      el0 Ȥʤʸ(0 )
 * @param      el1 Ȥʤʸ(1 )
 * @param      ... Ȥʤʸ(2 ܰʹ; NULL ü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::replace( size_t idx1, size_t n1, 
					const char *el0, const char *el1, ... )
{
    va_list ap;
    va_start(ap, el1);
    try {
	this->vreplace( idx1, n1, el0, el1, ap );
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vreplace() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ΰޤ򡤻ꤵ줿ʣʸִ
 *
 *  ȤǤΰidx1n1ĤǤ򡤲Ѱǻꤵ줿
 *  ʣʸǻꤵ줿ʸִޤ
 *
 * @param      idx1 Ȥγϰ
 * @param      n1 ִǿ
 * @param      el0 Ȥʤʸ(0 )
 * @param      el1 Ȥʤʸ(1 )
 * @param      ap ȤʤʸβĹΥꥹ(2 ܰʹ; NULL ü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::vreplace( size_t idx1, size_t n1, 
				 const char *el0, const char *el1, va_list ap )
{
    heap_mem<const char *> tmp_ptbl;
    size_t element_count, i;
    va_list aq;

    va_copy(aq, ap);

    element_count = 0;
    if ( el0 != NULL ) {
        element_count++;
	if ( el1 != NULL ) {
	    element_count++;
	    while ( 1 ) {
	        const char *elem = va_arg(aq,char *);
		if ( elem == NULL ) break;
		element_count++;
	    }
	}
    }
    va_end(aq);

    if ( tmp_ptbl.allocate(element_count + 1) < 0 ) {
	err_throw(__FUNCTION__,"FATAL","malloc() failed");
    }

    i = 0;
    if ( el0 != NULL ) {
        tmp_ptbl[i] = el0;
        i++;
	if ( el1 != NULL ) {
	    tmp_ptbl[i] = el1;
	    i++;
	    while ( 1 ) {
	        const char *elem = va_arg(ap,char *);
		if ( elem == NULL ) break;
		tmp_ptbl[i] = elem;
		i++;
	    }
	}
    }
    tmp_ptbl[i] = NULL;

    this->replace(idx1,n1, tmp_ptbl.ptr());

    return *this;
}

/**
 * @brief  ΰޤ򡤻ꤵ줿ʸ(const char *)ִ
 *
 *  ȤǤΰidx1n1ĤǤ򡤻ꤵ줿ʸ
 *  n2Ĥִޤ
 *
 * @param      idx1 Ȥγϰ
 * @param      n1 ִǿ
 * @param      str Ȥʤʸ
 * @param      n2 ꤵ줿ʸǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::replace( size_t idx1, size_t n1, 
					 const char *str, size_t n2 )
{
    tstring one = str;
    return this->replace(idx1,n1, one,n2);
}

/**
 * @brief  ΰޤ򡤻ꤵ줿ʸ(tstring)ִ
 *
 *  ȤǤΰidx1n1ĤǤ򡤻ꤵ줿ʸ
 *  n2Ĥִޤ
 *
 * @param      idx1 Ȥγϰ
 * @param      n1 ִǿ
 * @param      one Ȥʤʸ(ޥ˥奢Ǥstr)
 * @param      n2 ꤵ줿ʸǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::replace( size_t idx1, size_t n1, 
					 const tstring &one, size_t n2 )
{
    if ( one.cstr() != NULL ) {
	this->arrs_rec.replace(idx1,n1, one,n2);

	this->update_cstr_ptrs_rec();
    }
    return *this;
}

/**
 * @brief  ΰޤ򡤻ꤵ줿ʸ(printf()εˡ)ִ
 *
 *  ȤǤΰidx1n1ĤǤ򡤻ꤵ줿ʸ
 *  n2Ĥִޤ
 *
 * @param      idx1 Ȥγϰ
 * @param      n1 ִǿ
 * @param      n2 ꤵ줿ʸǤθĿ
 * @param      format ȤʤʸΤΥեޥåȻ
 * @param      ... formatбĹγǥǡ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      Ĺγǥǡꤵ줿ѴեޥåȤ
 *             ѴǤʤͤξ
 *
 */
tarray_tstring &tarray_tstring::replacef( size_t idx1, size_t n1, 
					  size_t n2, const char *format, ...)
{
    va_list ap;
    va_start(ap,format);
    try {
	this->vreplacef(idx1,n1,n2,format,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vreplacef() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ΰޤ򡤻ꤵ줿ʸ(printf()εˡ)ִ
 *
 *  ȤǤΰidx1n1ĤǤ򡤻ꤵ줿ʸ
 *  n2Ĥִޤ
 *
 * @param      idx1 Ȥγϰ
 * @param      n1 ִǿ
 * @param      n2 ꤵ줿ʸǤθĿ
 * @param      format ȤʤʸΤΥեޥåȻ
 * @param      ap formatбĹΥꥹ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      Ĺγǥǡꤵ줿ѴեޥåȤ
 *             ѴǤʤͤξ
 *
 */
tarray_tstring &tarray_tstring::vreplacef( size_t idx1, size_t n1, size_t n2,
					   const char *format, va_list ap )
{
    tstring one;

    if ( format == NULL ) return this->replace(idx1,n1,format,n2);

    try {
	one.vprintf(format,ap);
    }
    catch (...) {
	err_throw(__FUNCTION__,"FATAL","one.vprintf() failed");
    }
    this->replace(idx1,n1,one,n2);

    return *this;
}

/**
 * @brief  ѥ˥顼Ϥ뤿ΥߡΥдؿ
 * @deprecated  Բġ
 * @note	ΥдؿprivateǤ
 */
tarray_tstring &tarray_tstring::put( size_t index, size_t n )
{
    static tstring one(true);

    this->arrs_rec.put(index, one,n);

    this->update_cstr_ptrs_rec();

    return *this;
}

/**
 * @brief  ꤵ줿ʸ(const char *[])򡤼Ȥλ֤˾
 *
 *  elementsǻꤵ줿ʸ򡤼Ȥǰindex
 *  ޤ
 *
 * @param      index Ȥν񤭹߰
 * @param      elements ȤʤʸΥݥ(NULLǽü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * 
 */
tarray_tstring &tarray_tstring::put( size_t index, 
				     const char *const *elements )
{
    size_t i;
    if ( elements == NULL ) return this->put(index,elements, 0);
    for ( i=0 ; elements[i] != NULL ; i++ );
    return this->put(index,elements,i);
}

/**
 * @brief  ꤵ줿ʸ(const char *[])򡤼Ȥλ֤˾
 *
 *  elementsǻꤵ줿ʸ򡤼Ȥǰindex
 *  ޤ
 *
 * @param      index Ȥν񤭹߰
 * @param      elements ȤʤʸΥݥ
 * @param      n elements ǿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * 
 */
tarray_tstring &tarray_tstring::put( size_t index, 
				     const char *const *elements, size_t n )
{
    heap_mem<const char *> tmp_ptbl;
    size_t i;

    if ( 0 < n && elements == NULL ) return *this;

    /* n 꾮б */
    for ( i=0 ; i < n && elements[i] != NULL ; i++ );
    n = i;

    if ( 0 < n && this->is_my_buffer(elements) == true ) {
	/* elements  this->cstr_ptrs_rec ͳξ
	   ɥ쥹ơ֥򥳥ԡ (step1 ǤΥꥵΤ) */
	if ( tmp_ptbl.allocate(n) < 0 ) {
	    err_throw(__FUNCTION__,"FATAL","malloc() failed");
	}
	tmp_ptbl.copyfrom(elements, n);
	elements = tmp_ptbl.ptr();
    }

    if ( this->length() < index + n ) {
	this->replace(this->length(),0, (index + n) - this->length());
    }
    this->replace(index, n, elements, n);

    return *this;
}

/**
 * @brief  ꤵ줿ʸ(tarray_tstring)򡤼Ȥλ֤˾
 *
 *  srcǻꤵ줿ʸ򡤼Ȥǰindex񤭤ޤ
 *
 * @param    index Ȥν񤭹߰
 * @param    src Ȥʤʸtarray_tstring 饹Υ֥
 * @param    idx2 srcǤγϰ
 * @return   Ȥλ
 * @throw    Хåեγݤ˼Ԥ
 * 
 */
tarray_tstring &tarray_tstring::put( size_t index,
				     const tarray_tstring &src, size_t idx2)
{
    return this->put(index, src, idx2, src.length());
}

/**
 * @brief  ꤵ줿ʸ(tarray_tstring)򡤼Ȥλ֤˾
 *
 *  srcǻꤵ줿ʸ򡤼Ȥǰindex񤭤ޤ
 *
 * @param    index Ȥν񤭹߰
 * @param    src Ȥʤʸtarray_tstring 饹Υ֥
 * @param    idx2 srcǤγϰ
 * @param    n2 src ǤθĿ
 * @return   Ȥλ
 * @throw    Хåեγݤ˼Ԥ
 * 
 */
tarray_tstring &tarray_tstring::put( size_t index, 
				     const tarray_tstring &src, 
				     size_t idx2, size_t n2 )
{
    this->arrs_rec.put(index, src.arrs_rec,idx2,n2);

    this->update_cstr_ptrs_rec();

    return *this;
}

/**
 * @brief  ꤵ줿ʣʸ򡤼Ȥλ֤˾
 *
 *  Ѱǻꤵ줿ʣʸ򡤼Ȥǰ index 
 *  񤭤ޤ
 *
 * @param      idx1 Ȥν񤭹߰
 * @param      el0 Ȥʤʸ(0 )
 * @param      el1 Ȥʤʸ(1 )
 * @param      ... Ȥʤʸ(2 ܰʹ; NULL ü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::put( size_t index, 
				     const char *el0, const char *el1, ... )
{
    va_list ap;
    va_start(ap, el1);
    try {
	this->vput( index, el0, el1, ap );
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vput() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿ʣʸ򡤼Ȥλ֤˾
 *
 *  Ѱǻꤵ줿ʣʸ򡤼Ȥǰ index 
 *  񤭤ޤ
 *
 * @param      idx1 Ȥν񤭹߰
 * @param      el0 Ȥʤʸ(0 )
 * @param      el1 Ȥʤʸ(1 )
 * @param      ap ȤʤʸβĹΥꥹ(2 ܰʹ; NULL ü)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::vput( size_t index, 
				 const char *el0, const char *el1, va_list ap )
{
    heap_mem<const char *> tmp_ptbl;
    size_t element_count, i;
    va_list aq;

    va_copy(aq, ap);

    element_count = 0;
    if ( el0 != NULL ) {
        element_count++;
	if ( el1 != NULL ) {
	    element_count++;
	    while ( 1 ) {
	        const char *elem = va_arg(aq,char *);
		if ( elem == NULL ) break;
		element_count++;
	    }
	}
    }
    va_end(aq);

    if ( tmp_ptbl.allocate(element_count + 1) < 0 ) {
	err_throw(__FUNCTION__,"FATAL","malloc() failed");
    }

    i = 0;
    if ( el0 != NULL ) {
        tmp_ptbl[i] = el0;
        i++;
	if ( el1 != NULL ) {
	    tmp_ptbl[i] = el1;
	    i++;
	    while ( 1 ) {
	        const char *elem = va_arg(ap,char *);
		if ( elem == NULL ) break;
		tmp_ptbl[i] = elem;
		i++;
	    }
	}
    }
    tmp_ptbl[i] = NULL;

    this->put(index, tmp_ptbl.ptr());

    return *this;
}

/**
 * @brief  ꤵ줿ʸ(const char *)ǡȤλ֤nľ
 *
 *  Ȥֹindexΰ֤顤ꤵ줿ʸnĤ
 *  񤭤ޤ
 *
 * @param      index Ȥν񤭹߰
 * @param      str Ȥʤʸ
 * @param      n ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::put( size_t index, const char *str, size_t n )
{
    tstring one = str;
    return this->put(index, one, n);
}

/**
 * @brief  ꤵ줿ʸ(tstring)ǡȤλ֤nľ
 *
 *  Ȥֹindexΰ֤顤ꤵ줿ʸnĤ
 *  񤭤ޤ
 *
 * @param      index Ȥν񤭹߰
 * @param      one Ȥʤʸ(ޥ˥奢Ǥstr)
 * @param      n ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::put(size_t index, const tstring &one, size_t n)
{
    if ( one.cstr() != NULL ) {
	this->arrs_rec.put(index, one,n);

	this->update_cstr_ptrs_rec();
    }
    return *this;
}

/**
 * @brief  ꤵ줿ʸ(printf()εˡ)ǡλ֤nľ
 *
 *  Ȥֹindexΰ֤顤ꤵ줿ʸnĤ
 *  񤭤ޤ
 *
 * @param      index Ȥν񤭹߰
 * @param      n ǤθĿ
 * @param      format ȤʤʸΤΥեޥåȻ
 * @param      ... formatбĹγǥǡ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      Ĺγǥǡꤵ줿ѴեޥåȤѴ
 *             Ǥʤͤξ
 *
 */
tarray_tstring &tarray_tstring::putf( size_t index, 
				      size_t n, const char *format, ...)
{
    va_list ap;
    va_start(ap,format);
    try {
	this->vputf(index,n,format,ap);
    }
    catch (...) {
	va_end(ap);
        err_throw(__FUNCTION__,"FATAL","this->vputf() failed");
    }
    va_end(ap);
    return *this;
}

/**
 * @brief  ꤵ줿ʸ(printf()εˡ)ǡλ֤nľ
 *
 *  Ȥֹindexΰ֤顤ꤵ줿ʸnĤ
 *  񤭤ޤ
 *
 * @param      index Ȥν񤭹߰
 * @param      n ǤθĿ
 * @param      format ȤʤʸΤΥեޥåȻ
 * @param      ap format бĹΥꥹ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * @throw      Ĺγǥǡꤵ줿ѴեޥåȤѴ
 *             Ǥʤͤξ
 *
 */
tarray_tstring &tarray_tstring::vputf( size_t index, size_t n,
				       const char *format, va_list ap )
{
    tstring one;

    if ( format == NULL ) return this->put(index,format,n);

    try {
	one.vprintf(format,ap);
    }
    catch (...) {
	err_throw(__FUNCTION__,"FATAL","one.vprintf() failed");
    }
    this->put(index,one,n);

    return *this;
}

/**
 * @brief  ʬξõ
 *
 *  Ȥֹ idx  len ĤǤˤޤ
 *
 * @param      idx ڤФǤγϰ
 * @param      len ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * 
 */
tarray_tstring &tarray_tstring::crop( size_t idx, size_t len )
{
    size_t max_n;
    if ( this->length() < idx ) idx = this->length();
    max_n = this->length() - idx;
    if ( max_n < len ) len = max_n;
    this->erase(0, idx);
    this->erase(len, this->length() - len);
    return *this;
}

/**
 * @brief  ʬξõ
 *
 *  Ȥֹidx ʹߤˤޤ
 *
 * @param      idx ڤФǤγϰ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * 
 */
tarray_tstring &tarray_tstring::crop( size_t idx )
{
    if ( this->length() < idx ) idx = this->length();
    return this->crop(idx, this->length() - idx);
}

/**
 * @brief  Ǥκ
 *
 *  ȤʸǤޤ
 *
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * 
 */
tarray_tstring &tarray_tstring::erase()
{
    return this->erase(0,this->length());
}

/**
 * @brief  Ǥκ
 *
 *  ȤʸǤޤ
 *
 * @param      index ֹ
 * @param      num_elements ǤθĿ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * 
 */
tarray_tstring &tarray_tstring::erase( size_t index, size_t num_elements )
{
    return this->replace(index,num_elements, (size_t)0);
}

/**
 * @brief  Ĺѹ
 *
 *  ȤʸĹ new_num_elements ѹޤ
 *
 * @param      new_num_elements ѹʸĹ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * 
 */
tarray_tstring &tarray_tstring::resize( size_t new_num_elements )
{
    if ( new_num_elements < this->length() ) {
        this->replace( new_num_elements, 
		       this->length() - new_num_elements,
		       (size_t)0 );
    }
    else {
	this->replace( this->length(), (size_t)0,
		       new_num_elements - this->length() );
    }
    return *this;
}

/**
 * @brief  ĹŪѹ
 *
 *  ȤʸĹ len Ĺʬѹޤ
 *
 * @param      len Ĺʬʬ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 * 
 */
tarray_tstring &tarray_tstring::resizeby( ssize_t len )
{
    size_t new_len, a_len;
    a_len = ((len < 0) ? -len : len);
    if ( len < 0 ) {
	if ( a_len < this->length() ) 
	    new_len = this->length() - a_len;
	else
	    new_len = 0;
    }
    else {
	new_len = this->length() + a_len;
    }

    return this->resize(new_len);
}

/**
 * @brief  Ǥ̥֥Ȥإԡ
 *
 *  ȤʸΤ٤Ƥޤϰdest ǻꤵ줿֥Ȥ
 *  ԡޤ
 *
 * @param      index ԡ()Ǥΰ
 * @param      n ԡǿ
 * @param      dest ԡtarray_tstring 饹Υ֥
 * @return     <br>
 *             Ԥ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
ssize_t tarray_tstring::copy( size_t index, size_t n,
			      tarray_tstring *dest ) const
{
    if ( dest == NULL ) return -1;

    size_t len = this->length();

    if ( len < index ) {
	dest->erase();
	return -1;
    }
    if ( this->cstrarray() == NULL ) {
	dest->erase();
	return 0;
    }

    if ( len - index < n ) n = len - index;

    dest->replace(0, dest->length(), *this, index, n);

    return n;
}

/**
 * @brief  Ǥ̥֥Ȥإԡ
 *
 *  ȤʸΤ٤Ƥޤϰdest ǻꤵ줿֥Ȥ
 *  ԡޤ
 *
 * @param      index ԡ()Ǥΰ
 * @param      dest ԡtarray_tstring 饹Υ֥
 * @return     <br>
 *             Ԥ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
ssize_t tarray_tstring::copy( size_t index, tarray_tstring *dest ) const
{
    if ( dest == NULL ) return -1;
    return this->copy(index, this->length(), dest);
}

/**
 * @brief  ȤƤ̥֥Ȥإԡ
 *
 *  ȤʸΤ٤Ƥdest ǻꤵ줿֥Ȥ˥ԡޤ
 *
 * @param      dest ԡtarray_tstring 饹Υ֥
 * @return     <br>
 *             Ԥ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
ssize_t tarray_tstring::copy( tarray_tstring *dest ) const
{
    if ( dest == NULL ) return -1;
    return this->copy(0, this->length(), dest);
}

/**
 * @brief  Ǥ̥֥Ȥإԡ (侩)
 * @deprecated 侩<br>
 * ssize_t tarray_tstring::copy(size_t, size_t, tarray_tstring *) const <br>
 * 򤪻Ȥ
 */
ssize_t tarray_tstring::copy( size_t index, size_t n, 
			      tarray_tstring &dest ) const
{
    return this->copy(index, n, &dest);
}

/**
 * @brief  Ǥ̥֥Ȥإԡ (侩)
 * @deprecated 侩<br>
 * ssize_t tarray_tstring::copy(size_t, tarray_tstring *) const <br>
 * 򤪻Ȥ
 */
ssize_t tarray_tstring::copy( size_t index, tarray_tstring &dest ) const
{
    return this->copy(index, this->length(), &dest);
}

/**
 * @brief  ȤƤ̥֥Ȥإԡ (侩)
 * @deprecated 侩<br>
 * ssize_t tarray_tstring::copy(tarray_tstring *) const <br>
 * 򤪻Ȥ
 */
ssize_t tarray_tstring::copy( tarray_tstring &dest ) const
{
    return this->copy(0, this->length(), &dest);
}

/**
 * @brief  2ĤΥ֥ȴ֤ǤƤΥå
 *
 *  ֥sobj ƤȼȤƤȤؤޤ
 *
 * @param      sobj Ƥؤ tarray_tstring 饹Υ֥
 * @return     Ȥλ
 * 
 */
tarray_tstring &tarray_tstring::swap( tarray_tstring &sobj )
{
    if ( &sobj == this ) return *this;

    this->arrs_rec.swap(sobj.arrs_rec);
    this->cstr_ptrs_rec.swap(sobj.cstr_ptrs_rec);
    this->reg_pos_rec.swap(sobj.reg_pos_rec);
    this->reg_length_rec.swap(sobj.reg_length_rec);
    this->regex_rec.swap(sobj.regex_rec);

    return *this;
}

/**
 * @brief  ǤˤĤƤñʸ󸡺ִ
 *
 *  ȤʸǤˤĤơʸκ¦ʸ org_str 򸡺
 *  Ĥäʸ new_str ֤ޤ
 *
 * @param      org_str Фʸ
 * @param      new_str ִθȤʤʸ
 * @param      all ִΥե饰
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::strreplace( const char *org_str,
					    const char *new_str, bool all )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).strreplace(org_str,new_str,all);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤñʸ󸡺ִ
 *
 *  ȤʸǤˤĤơʸκ¦ʸ org_str 򸡺
 *  Ĥäʸ new_str ֤ޤ
 *
 * @param      org_str Фʸ
 * @param      new_str ִθȤʤʸ
 * @param      all ִΥե饰
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::strreplace( const tstring &org_str,
					    const char *new_str, bool all )
{
    return this->strreplace(org_str.cstr(), new_str, all);
}

/**
 * @brief  ǤˤĤƤñʸ󸡺ִ
 *
 *  ȤʸǤˤĤơʸκ¦ʸ org_str 򸡺
 *  Ĥäʸ new_str ֤ޤ
 *
 * @param      org_str Фʸ
 * @param      new_str ִθȤʤʸ
 * @param      all ִΥե饰
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::strreplace( const char *org_str,
					    const tstring &new_str, bool all )
{
    return this->strreplace(org_str, new_str.cstr(), all);
}

/**
 * @brief  ǤˤĤƤñʸ󸡺ִ
 *
 *  ȤʸǤˤĤơʸκ¦ʸ org_str 򸡺
 *  Ĥäʸ new_str ֤ޤ
 *
 * @param      org_str Фʸ
 * @param      new_str ִθȤʤʸ
 * @param      all ִΥե饰
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::strreplace( const tstring &org_str,
					    const tstring &new_str, bool all )
{
    return this->strreplace(org_str.cstr(), new_str.cstr(), all);
}

/**
 * @brief  ǤˤĤƤʸν
 *
 *  ȤǤʸޤ
 * 
 * @return Ȥλ
 * @throw Хåեγݤ˼Ԥ
 */
tarray_tstring &tarray_tstring::chop()
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).chop();
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤαüβʸν
 *
 *  ȤʸǤαüβʸޤ
 *
 * @param      rs ʸ (ά)
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::chomp( const char *rs )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).chomp(rs);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤαüβʸν
 *
 *  ȤʸǤαüβʸޤ
 *
 * @param      rs ʸ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::chomp( const tstring &rs )
{
    return this->chomp(rs.cstr());
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤʸǤˤĤơʸξüˤǤʸޤ
 *
 * @param      side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::trim( const char *side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).trim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤʸǤˤĤơʸξüˤǤʸޤ
 *
 * @param      side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::trim( const tstring &side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).trim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤʸǤˤĤơʸξüˤǤʸޤ
 *
 * @param      side_space оݤʸ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::trim( int side_space )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).trim(side_space);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤʸǤˤĤơʸüˤǤʸޤ
 *
 * @param      side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::ltrim( const char *side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).ltrim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤʸǤˤĤơʸüˤǤʸޤ
 *
 * @param      side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::ltrim( const tstring &side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).ltrim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤʸǤˤĤơʸüˤǤʸޤ
 *
 * @param      side_space оݤʸ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::ltrim( int side_space )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).ltrim(side_space);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤʸǤˤĤơʸüˤǤʸޤ
 *
 * @param      side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::rtrim( const char *side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).rtrim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤʸǤˤĤơʸüˤǤʸޤ
 *
 * @param      side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::rtrim( const tstring &side_spaces )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).rtrim(side_spaces);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸüʸν
 *
 *  ȤʸǤˤĤơʸüˤǤʸޤ
 *
 * @param      side_space оݤʸ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::rtrim( int side_space )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).rtrim(side_space);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤʸǤˤĤơʸξüˤǤʸޤ
 *
 * @param      side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::strtrim( const char *side_spaces )
{
    return this->trim(side_spaces);
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤʸǤˤĤơʸξüˤǤʸޤ
 *
 * @param      side_spaces оݤʸåȡ[A-Z] ȤäɽѲǽ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::strtrim( const tstring &side_spaces )
{
    return this->trim(side_spaces);
}

/**
 * @brief  ǤˤĤƤʸξüʸν
 *
 *  ȤʸǤˤĤơʸξüˤǤʸޤ
 *
 * @param      side_space оݤʸ
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::strtrim( int side_space )
{
    return this->trim(side_space);
}

/**
 * @brief  ǤˤĤʸʸѴ
 *
 *  ȤʸǤΥե٥åȤʸʸѴޤ
 *
 * @return     Ȥλ
 *
 */
tarray_tstring &tarray_tstring::tolower()
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).tolower();
    }
    return *this;
}

/**
 * @brief  ǤˤĤƾʸʸѴ
 *
 *  ȤʸǤΥե٥åȤξʸʸѴޤ
 *
 * @return     Ȥλ
 *
 */
tarray_tstring &tarray_tstring::toupper()
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).toupper();
    }
    return *this;
}

/**
 * @brief  ǤˤĤƥʸ·ƶʸִ
 *
 *  ȤʸǤˤĤơʿʸ '\t' tab_width ͤ
 *  ·򤷤ƶʸִޤ
 *
 * @param      tab_width ά8
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::expand_tabs( size_t tab_width )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).expand_tabs(tab_width);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƶʸ·ƥʸִ
 *
 *  ȤʸǤˤĤơ2ʸʾϢ³ʸ ' ' ٤Ƥ
 *  оݤˤꤵ줿 tab_width Ƿ· '\t' ִޤ
 *
 * @param      tab_width ά8
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::contract_spaces( size_t tab_width )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).contract_spaces(tab_width);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤʸǤˤĤơpat ǻꤵ줿 POSIX ĥɽ
 *  (ʲɽ) ǥޥåʬʸ new_str ֤ޤ
 *
 * @param      pat ʸѥ(ɽ)
 * @param      new_str ִʸ
 * @param      all ִΥե饰
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::regreplace( const char *pat, 
					    const char *new_str, bool all )
{
    size_t i;
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).regreplace(this->regex_rec, new_str, all);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤʸǤˤĤơpat ǻꤵ줿 POSIX ĥɽ
 *  (ʲɽ) ǥޥåʬʸ new_str ֤ޤ
 *
 * @param      pat ʸѥ(ɽ)
 * @param      new_str ִʸ
 * @param      all ִΥե饰
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::regreplace( const tstring &pat, 
					    const char *new_str, bool all )
{
    size_t i;
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).regreplace(this->regex_rec, new_str, all);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤʸǤˤĤơpat ǻꤵ줿 POSIX ĥɽ
 *  (ʲɽ) ǥޥåʬʸ new_str ֤ޤ
 *
 * @param      pat tregex 饹Υѥѥ֥
 * @param      new_str ִʸ
 * @param      all ִΥե饰
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::regreplace( const tregex &pat, 
					    const char *new_str, bool all )
{
    size_t i;
    for ( i=0 ; i < this->length() ; i++ ) {
	this->at(i).regreplace(pat,new_str,all);
    }
    return *this;
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤʸǤˤĤơpat ǻꤵ줿 POSIX ĥɽ
 *  (ʲɽ) ǥޥåʬʸ new_str ֤ޤ
 *
 * @param      pat ʸѥ(ɽ)
 * @param      new_str ִʸ
 * @param      all ִΥե饰
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::regreplace( const char *pat, 
					    const tstring &new_str, bool all )
{
    return this->regreplace(pat, new_str.cstr(), all);
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤʸǤˤĤơpat ǻꤵ줿 POSIX ĥɽ
 *  (ʲɽ) ǥޥåʬʸ new_str ֤ޤ
 *
 * @param      pat ʸѥ(ɽ)
 * @param      new_str ִʸ
 * @param      all ִΥե饰
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::regreplace( const tstring &pat, 
					    const tstring &new_str, bool all )
{
    return this->regreplace(pat, new_str.cstr(), all);
}

/**
 * @brief  ǤˤĤƤɽˤִ
 *
 *  ȤʸǤˤĤơpat ǻꤵ줿 POSIX ĥɽ
 *  (ʲɽ) ǥޥåʬʸ new_str ֤ޤ
 *
 * @param      pat tregex 饹Υѥѥ֥
 * @param      new_str ִʸ
 * @param      all ִΥե饰
 * @return     Ȥλ
 * @throw      Хåեγݤ˼Ԥ
 *
 */
tarray_tstring &tarray_tstring::regreplace( const tregex &pat, 
					    const tstring &new_str, bool all )
{
    return this->regreplace(pat, new_str.cstr(), all);
}

/**
 * @brief  ¦Ǥδ׸
 *
 *  ȤǤκ¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      str Фͤ˰פʸ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_elem( const char *str ) const
{
    return this->find_elem((size_t)0, str, (size_t *)NULL);
}

/**
 * @brief  ¦Ǥδ׸
 *
 *  ȤǤκ¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_elem( size_t idx, const char *str ) const
{
    return this->find_elem(idx, str, (size_t *)NULL);
}

/**
 * @brief  Ϣ³Ūʺ¦Ǥδ׸
 *
 *  ȤǤκ¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ
 * @param      nextidx idx
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_elem( size_t idx, const char *str, 
				   size_t *nextidx ) const
{
    if ( idx < this->length() && str != NULL ) {
	size_t i;
	for ( i=idx ; i < this->length() ; i++ ) {
	    if ( this->at_cs(i).compare(str) == 0 ) {
		if ( nextidx != NULL ) {
		    *nextidx = i + 1;
		}
		return i;
	    }
	}
    }
    /* */
    if ( nextidx != NULL ) *nextidx = this->length();
    return -1;
}

/**
 * @brief  ¦Ǥδ׸
 *
 *  ȤǤκ¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      str Фͤ˰פʸ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_elem( const tstring &str ) const
{
    return this->find_elem(str.cstr());
}

/**
 * @brief  ¦Ǥδ׸
 *
 *  ȤǤκ¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_elem( size_t idx, const tstring &str ) const
{
    return this->find_elem(idx, str.cstr());
}

/**
 * @brief  Ϣ³Ūʺ¦Ǥδ׸
 *
 *  ȤǤκ¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ
 * @param      nextidx idx
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_elem( size_t idx, const tstring &str,
				   size_t *nextidx ) const
{
    return this->find_elem(idx, str.cstr(), nextidx);
}

/**
 * @brief  ¦Ǥδ׸
 *
 *  ȤǤα¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      str Фͤ˰פʸ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind_elem( const char *str ) const
{
    if ( this->length() < 1 ) return -1;
    return this->rfind_elem(this->length() - 1, str, (size_t *)NULL);
}

/**
 * @brief  ¦Ǥδ׸
 *
 *  ȤǤα¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind_elem( size_t idx, const char *str ) const
{
    return this->rfind_elem(idx, str, (size_t *)NULL);
}

/**
 * @brief  Ϣ³Ūʱ¦Ǥδ׸
 *
 *  ȤǤα¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ
 * @param      nextidx idx
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind_elem( size_t idx, const char *str,
				    size_t *nextidx ) const
{
    if ( idx < this->length() && str != NULL ) {
	size_t i;
	for ( i=idx+1 ; 0 < i ; ) {
	    i--;
	    if ( this->at_cs(i).compare(str) == 0 ) {
		if ( nextidx != NULL ) {
		    if ( 0 < i ) *nextidx = i - 1;
		    else *nextidx = this->length();
		}
		return i;
	    }
	}
    }
    /* */
    if ( nextidx != NULL ) *nextidx = this->length();
    return -1;
}

/**
 * @brief  ¦Ǥδ׸
 *
 *  ȤǤα¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      str Фͤ˰פʸ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind_elem( const tstring &str ) const
{
    return this->rfind_elem(str.cstr());
}

/**
 * @brief  ¦Ǥδ׸
 *
 *  ȤǤα¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind_elem( size_t idx, const tstring &str ) const
{
    return this->rfind_elem(idx, str.cstr());
}

/**
 * @brief  Ϣ³Ūʱ¦Ǥδ׸
 *
 *  ȤǤα¦ʸ str ˴˰פǤ򸡺
 *  ĤäϤֹ֤Ĥʤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ
 * @param      nextidx idx
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind_elem( size_t idx, const tstring &str,
				    size_t *nextidx ) const
{
    return this->rfind_elem(idx, str.cstr(), nextidx);
}

/**
 * @brief  ¦Ǥʬ׸
 *
 *  ȤǤκ¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find( const char *str, ssize_t *pos_r ) const
{
    return this->find((size_t)0, (size_t)0, str, 
		      pos_r, (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  ¦Ǥʬ׸
 *
 *  ȤǤκ¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find( size_t idx, size_t pos, const char *str,
			      ssize_t *pos_r ) const
{
    return this->find(idx, pos, str, pos_r, (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  Ϣ³Ūʺ¦Ǥʬ׸
 *
 *  ȤǤκ¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @param      nextidx idx
 * @param      nextpos pos
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find( size_t idx, size_t pos, const char *str,
			      ssize_t *pos_r,
			      size_t *nextidx, size_t *nextpos ) const
{
    ssize_t f_pos = -1;
    size_t a_length = this->length();
    if ( idx < a_length && pos <= this->at_cs(idx).length() && str != NULL) {
	size_t i;
	for ( i=idx ; i < a_length ; i++ ) {
	    if ( 0 <= (f_pos=this->at_cs(i).find(pos, str, &pos)) ) {
		if ( pos_r != NULL ) *pos_r = f_pos;
		if ( nextidx != NULL ) {
		    if ( this->at_cs(i).length() < pos ) *nextidx = i + 1;
		    else *nextidx = i;		/* keep */
		}
		if ( nextpos != NULL ) {
		    if ( i + 1 < a_length ) {	/* not last */
			if ( this->at_cs(i).length() < pos ) *nextpos = 0;
			else *nextpos = pos;
		    }
		    else *nextpos = pos;
		}
		return i;
	    }
	    pos = 0;	/* reset */
	}
    }
    /* not found */
    if ( pos_r != NULL ) *pos_r = f_pos;
    if ( nextidx != NULL ) *nextidx = a_length;
    if ( nextpos != NULL ) {
	*nextpos = (0 < a_length) ? this->at_cs(a_length - 1).length() + 1 : 1;
    }
    return -1;
}

/**
 * @brief  ¦Ǥʬ׸
 *
 *  ȤǤκ¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find( const tstring &str, ssize_t *pos_r ) const
{
    return this->find(str.cstr(), pos_r);
}

/**
 * @brief  ¦Ǥʬ׸
 *
 *  ȤǤκ¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find( size_t idx, size_t pos, const tstring &str,
			      ssize_t *pos_r) const
{
    return this->find(idx, pos, str.cstr(), pos_r);
}

/**
 * @brief  Ϣ³Ūʺ¦Ǥʬ׸
 *
 *  ȤǤκ¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @param      nextidx idx
 * @param      nextpos pos
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find( size_t idx, size_t pos, const tstring &str,
			      ssize_t *pos_r, 
			      size_t *nextidx, size_t *nextpos) const
{
    return this->find(idx, pos, str.cstr(), pos_r, nextidx, nextpos);
}

/**
 * @brief  ¦Ǥʬ׸
 *
 *  ȤǤα¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind( const char *str, ssize_t *pos_r ) const
{
    size_t a_length = this->length();
    if ( a_length < 1 ) return -1;
    return this->rfind(a_length - 1, this->at_cs(a_length - 1).length(), str, 
		       pos_r, (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  ¦Ǥʬ׸
 *
 *  ȤǤα¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind( size_t idx, size_t pos, const char *str,
			       ssize_t *pos_r ) const
{
    return this->rfind(idx, pos, str, pos_r, (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  Ϣ³Ūʱ¦Ǥʬ׸
 *
 *  ȤǤα¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @param      nextidx idx
 * @param      nextpos pos
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind( size_t idx, size_t pos, const char *str,
			       ssize_t *pos_r,
			       size_t *nextidx, size_t *nextpos ) const
{
    ssize_t f_pos = -1;
    size_t a_length = this->length();
    if ( idx < a_length && pos <= this->at_cs(idx).length() && str != NULL) {
	size_t i;
	for ( i=idx+1 ; 0 < i ; ) {
	    i--;
	    if ( 0 <= (f_pos=this->at_cs(i).rfind(pos, str, &pos)) ) {
		if ( pos_r != NULL ) *pos_r = f_pos;
		if ( nextidx != NULL ) {
		    if ( this->at_cs(i).length() < pos ) {
			if ( 0 < i ) *nextidx = i - 1;
			else *nextidx = a_length;
		    }
		    else *nextidx = i;		/* keep */
		}
		if ( nextpos != NULL ) {
		    if ( 0 < i ) {	/* not last */
			if ( this->at_cs(i).length() < pos ) {
			    *nextpos = this->at_cs(i-1).length();
			}
			else *nextpos = pos;
		    }
		    else *nextpos = pos;
		}
		return i;
	    }
	    if ( 0 < i ) pos = this->at_cs(i-1).length();	/* reset */
	}
    }
    /* not found */
    if ( pos_r != NULL ) *pos_r = f_pos;
    if ( nextidx != NULL ) *nextidx = a_length;
    if ( nextpos != NULL ) {
	*nextpos = (0 < a_length) ? this->at_cs((size_t)0).length() + 1 : 1;
    }
    return -1;
}

/**
 * @brief  ¦Ǥʬ׸
 *
 *  ȤǤα¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind( const tstring &str, ssize_t *pos_r ) const
{
    return this->rfind(str.cstr(), pos_r);
}

/**
 * @brief  ¦Ǥʬ׸
 *
 *  ȤǤα¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind( size_t idx, size_t pos, const tstring &str,
			       ssize_t *pos_r) const
{
    return this->rfind(idx, pos, str.cstr(), pos_r);
}

/**
 * @brief  Ϣ³Ūʱ¦Ǥʬ׸
 *
 *  ȤǤα¦ʸ str ޤǤ򸡺дؿ֤ͤ
 *  ơĤäϤֹ֤Ĥʤ֤ޤ
 *  ƱˡĤä pos_r ؤѿˡǤˤʸΰ
 *  ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      str Фʸ
 * @param      pos_r Ĥä硤Ǥˤʸΰ
 * @param      nextidx idx
 * @param      nextpos pos
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::rfind( size_t idx, size_t pos, const tstring &str,
			       ssize_t *pos_r, 
			       size_t *nextidx, size_t *nextpos) const
{
    return this->rfind(idx, pos, str.cstr(), pos_r, nextidx, nextpos);
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_str( const char *str ) const
{
    return this->find_matched_str((size_t)0, str, (size_t *)NULL);
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_str( size_t idx, const char *str ) const
{
    return this->find_matched_str(idx, str, (size_t *)NULL);
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @param      nextidx idx
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_str( size_t idx, const char *str, 
					  size_t *nextidx ) const
{
    if ( idx < this->length() && str != NULL ) {
	size_t i;
	for ( i=idx ; i < this->length() ; i++ ) {
	    if ( this->at_cs(i).strmatch(str) == 0 ) {
		if ( nextidx != NULL ) {
		    *nextidx = i + 1;
		}
		return i;
	    }
	}
    }
    /* */
    if ( nextidx != NULL ) *nextidx = this->length();
    return -1;
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_str( const tstring &str ) const
{
    return this->find_matched_str(str.cstr());
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_str(size_t idx, const tstring &str) const
{
    return this->find_matched_str(idx, str.cstr());
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @param      nextidx idx
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_str( size_t idx, const tstring &str,
					  size_t *nextidx ) const
{
    return this->find_matched_str(idx, str.cstr(), nextidx);
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ե̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_fn( const char *str ) const
{
    return this->find_matched_fn((size_t)0, str, (size_t *)NULL);
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ե̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_fn( size_t idx, const char *str ) const
{
    return this->find_matched_fn(idx, str, (size_t *)NULL);
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ե̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @param      nextidx idx
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_fn( size_t idx, const char *str, 
					  size_t *nextidx ) const
{
    if ( idx < this->length() && str != NULL ) {
	size_t i;
	for ( i=idx ; i < this->length() ; i++ ) {
	    if ( this->at_cs(i).fnmatch(str) == 0 ) {
		if ( nextidx != NULL ) {
		    *nextidx = i + 1;
		}
		return i;
	    }
	}
    }
    /* */
    if ( nextidx != NULL ) *nextidx = this->length();
    return -1;
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ե̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_fn( const tstring &str ) const
{
    return this->find_matched_fn(str.cstr());
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ե̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_fn(size_t idx, const tstring &str) const
{
    return this->find_matched_fn(idx, str.cstr());
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ե̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @param      nextidx idx
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_fn( size_t idx, const tstring &str,
					  size_t *nextidx ) const
{
    return this->find_matched_fn(idx, str.cstr(), nextidx);
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ѥ̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_pn( const char *str ) const
{
    return this->find_matched_pn((size_t)0, str, (size_t *)NULL);
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ѥ̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_pn( size_t idx, const char *str ) const
{
    return this->find_matched_pn(idx, str, (size_t *)NULL);
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ѥ̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @param      nextidx idx
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_pn( size_t idx, const char *str, 
					  size_t *nextidx ) const
{
    if ( idx < this->length() && str != NULL ) {
	size_t i;
	for ( i=idx ; i < this->length() ; i++ ) {
	    if ( this->at_cs(i).pnmatch(str) == 0 ) {
		if ( nextidx != NULL ) {
		    *nextidx = i + 1;
		}
		return i;
	    }
	}
    }
    /* */
    if ( nextidx != NULL ) *nextidx = this->length();
    return -1;
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ѥ̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_pn( const tstring &str ) const
{
    return this->find_matched_pn(str.cstr());
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ѥ̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_pn(size_t idx, const tstring &str) const
{
    return this->find_matched_pn(idx, str.cstr());
}

/**
 * @brief  Υ磻ɥɥѥѤʸޥå(ѥ̾)
 *
 *  ȤǤκ¦ˡΥ磻ɥɥѥѤʸ
 *  ޥåԤޥåֹ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      str Фͤ˰פʸ(ޥ˥奢Ǥpat)
 * @param      nextidx idx
 * @return     <br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::find_matched_pn( size_t idx, const tstring &str,
					  size_t *nextidx ) const
{
    return this->find_matched_pn(idx, str.cstr(), nextidx);
}

#ifdef REGFUNCS_USING_CACHE
/* ˥㥹Ȥؿ */
static tregex *coerce_into_casting( const tregex *in )
{ 
    return (tregex *)in;
} 
#endif

/**
 * @brief  ǤФɽޥå
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥå pos_rspan_r ؤѿˡǤˤޥå
 *  ʬʸ֤Ĺ֤ޤ
 *
 * @param      pat ˻Ȥɽ
 * @param      pos_r ޥå硤Ǥˤޥåʬʸ
 * @param      span_r ޥå硤ǤˤޥåʬʸĹ
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( const char *pat,
				  ssize_t *pos_r, size_t *span_r ) const
{
    return this->regmatch((size_t)0, (size_t)0, pat, pos_r, span_r,
			  (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  ǤФɽޥå
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥå pos_rspan_r ؤѿˡǤˤޥå
 *  ʬʸ֤Ĺ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      pos_r ޥå硤Ǥˤޥåʬʸ
 * @param      span_r ޥå硤ǤˤޥåʬʸĹ
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const char *pat,
				  ssize_t *pos_r, size_t *span_r ) const
{
    return this->regmatch(idx, pos, pat, pos_r, span_r,
			  (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  Ϣ³ŪǤФɽޥå
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥå pos_rspan_r ؤѿˡǤˤޥå
 *  ʬʸ֤Ĺ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      pos_r ޥå硤Ǥˤޥåʬʸ
 * @param      span_r ޥå硤ǤˤޥåʬʸĹ
 * @param      nextidx idx
 * @param      nextpos pos
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const char *pat,
				  ssize_t *pos_r, size_t *span_r,
				  size_t *nextidx, size_t *nextpos ) const
{
    tregex *epat_p;
#ifdef REGFUNCS_USING_CACHE
    epat_p = coerce_into_casting(&(this->regex_rec));
#else
    tregex epat;
    epat_p = &epat;
#endif
    if ( epat_p->compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",epat_p->cerrstr());
    }
    return this->regmatch(idx, pos, *epat_p, pos_r, span_r,
			  nextidx, nextpos);
}

/**
 * @brief  ǤФɽޥå
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥå pos_rspan_r ؤѿˡǤˤޥå
 *  ʬʸ֤Ĺ֤ޤ
 *
 * @param      pat ˻Ȥɽ
 * @param      pos_r ޥå硤Ǥˤޥåʬʸ
 * @param      span_r ޥå硤ǤˤޥåʬʸĹ
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( const tstring &pat,
				  ssize_t *pos_r, size_t *span_r ) const
{
    return this->regmatch(0, 0, pat, pos_r, span_r,
			  (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  ǤФɽޥå
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥå pos_rspan_r ؤѿˡǤˤޥå
 *  ʬʸ֤Ĺ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      pos_r ޥå硤Ǥˤޥåʬʸ
 * @param      span_r ޥå硤ǤˤޥåʬʸĹ
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tstring &pat,
				  ssize_t *pos_r, size_t *span_r ) const
{
    return this->regmatch(idx, pos, pat, pos_r, span_r,
			  (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  Ϣ³ŪǤФɽޥå
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥå pos_rspan_r ؤѿˡǤˤޥå
 *  ʬʸ֤Ĺ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      pos_r ޥå硤Ǥˤޥåʬʸ
 * @param      span_r ޥå硤ǤˤޥåʬʸĹ
 * @param      nextidx idx
 * @param      nextpos pos
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tstring &pat,
				  ssize_t *pos_r, size_t *span_r,
				  size_t *nextidx, size_t *nextpos ) const
{
    tregex *epat_p;
#ifdef REGFUNCS_USING_CACHE
    epat_p = coerce_into_casting(&(this->regex_rec));
#else
    tregex epat;
    epat_p = &epat;
#endif
    if ( epat_p->compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",epat_p->cerrstr());
    }
    return this->regmatch(idx, pos, *epat_p, pos_r, span_r,
			  nextidx, nextpos);
}

/**
 * @brief  ǤФɽޥå
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥå pos_rspan_r ؤѿˡǤˤޥå
 *  ʬʸ֤Ĺ֤ޤ
 *
 * @param      pat ˻Ȥɽ
 * @param      pos_r ޥå硤Ǥˤޥåʬʸ
 * @param      span_r ޥå硤ǤˤޥåʬʸĹ
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( const tregex &pat,
				  ssize_t *pos_r, size_t *span_r ) const
{
    return this->regmatch(0, 0, pat, pos_r, span_r, NULL, NULL);
}

/**
 * @brief  ǤФɽޥå
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥå pos_rspan_r ؤѿˡǤˤޥå
 *  ʬʸ֤Ĺ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      pos_r ޥå硤Ǥˤޥåʬʸ
 * @param      span_r ޥå硤ǤˤޥåʬʸĹ
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tregex &pat,
				  ssize_t *pos_r, size_t *span_r ) const
{
    return this->regmatch(idx, pos, pat, pos_r, span_r, NULL, NULL);
}

/**
 * @brief  Ϣ³ŪǤФɽޥå
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥå pos_rspan_r ؤѿˡǤˤޥå
 *  ʬʸ֤Ĺ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      pos_r ޥå硤Ǥˤޥåʬʸ
 * @param      span_r ޥå硤ǤˤޥåʬʸĹ
 * @param      nextidx idx
 * @param      nextpos pos
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tregex &pat,
				  ssize_t *pos_r, size_t *span_r,
				  size_t *nextidx, size_t *nextpos ) const
{
    ssize_t f_pos = -1;
    size_t a_length = this->length();
    if ( idx < a_length && pos <= this->at_cs(idx).length() ) {
	size_t i;
	for ( i=idx ; i < a_length ; i++ ) {
	    if (0 <= (f_pos=this->at_cs(i).regmatch(pos, pat, span_r, &pos))) {
		if ( pos_r != NULL ) *pos_r = f_pos;
		if ( nextidx != NULL ) {
		    if ( this->at_cs(i).length() < pos ) *nextidx = i + 1;
		    else *nextidx = i;		/* keep */
		}
		if ( nextpos != NULL ) {
		    if ( i + 1 < a_length ) {	/* not last */
			if ( this->at_cs(i).length() < pos ) *nextpos = 0;
			else *nextpos = pos;
		    }
		    else *nextpos = pos;
		}
		return i;
	    }
	    pos = 0;	/* reset */
	}
    }
    /* not found */
    if ( pos_r != NULL ) *pos_r = f_pos;
    if ( nextidx != NULL ) *nextidx = a_length;
    if ( nextpos != NULL ) {
	*nextpos = (0 < a_length) ? this->at_cs(a_length - 1).length() + 1 : 1;
    }
    return -1;
}

/**
 * @brief  ǤФɽޥåԤȤޤ
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥåʸ󥪥֥ result ˡǤˤޥå
 *  ʬθȤޤ֤ޤ
 *
 * @param      pat ˻Ȥɽ
 * @param      result ޥå硤Ǥˤޥåʬη̾
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( const char *pat,
				  tarray_tstring *result )
{
    if ( result == NULL ) return -1;
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    return this->regmatch(0, 0, this->regex_rec, result,
			  (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  ǤФɽޥåԤȤޤ
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥåʸ󥪥֥ result ˡǤˤޥå
 *  ʬθȤޤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      result ޥå硤Ǥˤޥåʬη̾
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const char *pat,
				  tarray_tstring *result )
{
    if ( result == NULL ) return -1;
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    return this->regmatch(idx, pos, this->regex_rec, result,
			  (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  Ϣ³ŪǤؤɽޥåԤȤޤ
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥåʸ󥪥֥ result ˡǤˤޥå
 *  ʬθȤޤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      result ޥå硤Ǥˤޥåʬη̾
 * @param      nextidx idx
 * @param      nextpos pos
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const char *pat,
				  tarray_tstring *result,
				  size_t *nextidx, size_t *nextpos )
{
    if ( result == NULL ) return -1;
    if ( this->regex_rec.compile(pat) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    return this->regmatch(idx, pos, this->regex_rec, result, nextidx, nextpos);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥåʸ󥪥֥ result ˡǤˤޥå
 *  ʬθȤޤ֤ޤ
 *
 * @param      pat ˻Ȥɽ
 * @param      result ޥå硤Ǥˤޥåʬη̾
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( const tstring &pat,
				  tarray_tstring *result )
{
    if ( result == NULL ) return -1;
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    return this->regmatch(0, 0, this->regex_rec, result,
			  (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥåʸ󥪥֥ result ˡǤˤޥå
 *  ʬθȤޤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      result ޥå硤Ǥˤޥåʬη̾
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tstring &pat,
				  tarray_tstring *result )
{
    if ( result == NULL ) return -1;
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    return this->regmatch(idx, pos, this->regex_rec, result,
			  (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  Ϣ³ŪǤؤɽޥåԤȤޤ
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥåʸ󥪥֥ result ˡǤˤޥå
 *  ʬθȤޤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      result ޥå硤Ǥˤޥåʬη̾
 * @param      nextidx idx
 * @param      nextpos pos
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tstring &pat,
				  tarray_tstring *result,
				  size_t *nextidx, size_t *nextpos )
{
    if ( result == NULL ) return -1;
    if ( this->regex_rec.compile(pat.cstr()) < 0 ) {
	err_report1(__FUNCTION__,"ERROR","%s",this->regex_rec.cerrstr());
    }
    return this->regmatch(idx, pos, this->regex_rec, result, nextidx, nextpos);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥåʸ󥪥֥ result ˡǤˤޥå
 *  ʬθȤޤ֤ޤ
 *
 * @param      pat ˻Ȥɽ
 * @param      result ޥå硤Ǥˤޥåʬη̾
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( const tregex &pat,
				  tarray_tstring *result ) const
{
    if ( result == NULL ) return -1;
    return this->regmatch(0, 0, pat, result,
			  (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥåʸ󥪥֥ result ˡǤˤޥå
 *  ʬθȤޤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      result ޥå硤Ǥˤޥåʬη̾
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tregex &pat,
				  tarray_tstring *result ) const
{
    if ( result == NULL ) return -1;
    return this->regmatch(idx, pos, pat, result,
			  (size_t *)NULL, (size_t *)NULL);
}

/**
 * @brief  Ϣ³ŪǤؤɽޥåԤȤޤ
 *
 *  ȤǤκ¦顤pat ǻꤵ줿 POSIX ĥɽ(ʲ
 *  ɽ)˥ޥåʬޤǤ򸡺дؿ֤ͤȤơޥå
 *  Ϥֹ֤ޥåʤ֤ޤƱˡ
 *  ޥåʸ󥪥֥ result ˡǤˤޥå
 *  ʬθȤޤ֤ޤ
 *
 * @param      idx Ǥθϰ
 * @param      pos ʸθϰ
 * @param      pat ˻Ȥɽ
 * @param      result ޥå硤Ǥˤޥåʬη̾
 * @param      nextidx idx
 * @param      nextpos pos
 * @return     ֹ<br>
 *             Ԥ
 *
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tregex &pat,
				  tarray_tstring *result,
				  size_t *nextidx, size_t *nextpos ) const
{
    if ( result == NULL ) return -1;
    size_t a_length = this->length();
    if ( result != this && idx < a_length && pos <= this->at_cs(idx).length() ) {
	size_t i;
	for ( i=idx ; i < a_length ; i++ ) {
	    result->regassign(this->at_cs(i), pos, pat, &pos);
	    if ( 0 < result->length() ) {
		if ( nextidx != NULL ) {
		    if ( this->at_cs(i).length() < pos ) *nextidx = i + 1;
		    else *nextidx = i;		/* keep */
		}
		if ( nextpos != NULL ) {
		    if ( i + 1 < a_length ) {	/* not last */
			if ( this->at_cs(i).length() < pos ) *nextpos = 0;
			else *nextpos = pos;
		    }
		    else *nextpos = pos;
		}
		return i;
	    }
	    pos = 0;	/* reset */
	}
    }
    /* not found */
    if ( nextidx != NULL ) *nextidx = a_length;
    if ( nextpos != NULL ) {
	*nextpos = (0 < a_length) ? this->at_cs(a_length - 1).length() + 1 : 1;
    }
    return -1;
}

/**
 * @brief  ǤؤɽޥåԤȤޤ(侩)
 * @deprecated  侩
 */
ssize_t tarray_tstring::regmatch( const char *pat,
				  tarray_tstring &result )
{
    return this->regmatch(pat, &result);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ(侩)
 * @deprecated  侩
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const char *pat,
				  tarray_tstring &result )
{
    return this->regmatch(idx, pos, pat, &result);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ(侩)
 * @deprecated  侩
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const char *pat,
				  tarray_tstring &result,
				  size_t *nextidx, size_t *nextpos )
{
    return this->regmatch(idx, pos, pat, &result, nextidx, nextpos);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ(侩)
 * @deprecated  侩
 */
ssize_t tarray_tstring::regmatch( const tstring &pat,
				  tarray_tstring &result )
{
    return this->regmatch(pat, &result);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ(侩)
 * @deprecated  侩
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tstring &pat,
				  tarray_tstring &result )
{
    return this->regmatch(idx, pos, pat, &result);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ(侩)
 * @deprecated  侩
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tstring &pat,
				  tarray_tstring &result,
				  size_t *nextidx, size_t *nextpos )
{
    return this->regmatch(idx, pos, pat, &result, nextidx, nextpos);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ(侩)
 * @deprecated  侩
 */
ssize_t tarray_tstring::regmatch( const tregex &pat,
				  tarray_tstring &result ) const
{
    return this->regmatch(pat, &result);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ(侩)
 * @deprecated  侩
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tregex &pat,
				  tarray_tstring &result ) const
{
    return this->regmatch(idx, pos, pat, &result);
}

/**
 * @brief  ǤؤɽޥåԤȤޤ(侩)
 * @deprecated  侩
 */
ssize_t tarray_tstring::regmatch( size_t idx, size_t pos, const tregex &pat,
				  tarray_tstring &result,
				  size_t *nextidx, size_t *nextpos ) const
{
    return this->regmatch(idx, pos, pat, &result, nextidx, nextpos);
}

/**
 * @brief  ʸγХåեؤΥԡ
 *
 *  indexǻꤵ줿Ǥʸ򡤳Хåե˥ԡޤ
 * 
 * @param   index ֹ
 * @param   dest_buf ХåեΥɥ쥹
 * @param   buf_size ХåեΥ
 * 
 * @return  : ХåեĹʬʾ,ԡǤʸ<br>
 *          (顼): dest_strNULLꤷbuf_size0ʳͤ
 *          .
 * @throw   ĹʾIndexꤵ줿
 */
ssize_t tarray_tstring::getstr( size_t index, 
				char *dest_buf, size_t buf_size ) const
{
    if ( index < 0 || this->length() <= index ) {
	return -1;
    }
    else {
        return this->arrs_rec.at_cs(index).getstr(dest_buf,buf_size);
    }
}

static void dump_tstring( const tstring &src )
{
    if ( 0 <= src.strchr('"') ) {
	size_t j;
	sli__eprintf("\"");
	for ( j=0 ; j < src.length() ; j++ ) {
	    int ch = src.cchr(j);
	    if ( ch == '"' ) sli__eprintf("\\\"");
	    else sli__eprintf("%c", ch);
	}
	sli__eprintf("\"");
    }
    else {
	sli__eprintf("\"%s\"", src.cstr());
    }
    return;
}

/**
 * @brief  ɽޥå̤Υޥå֤
 *
 *  ¸줿ɽޥå̤Ρޥåʬΰ֤֤ޤ
 * 
 * @param  idx 0: ޥåʸΤξ<br>
 *             1ʹ: ɽ줾˥ޥåʬʸξ
 * 
 * @return ¸줿ޥåʬΰ
 */
size_t tarray_tstring::reg_pos( size_t idx ) const
{
    if ( idx < this->reg_pos_rec.length() )
	return this->reg_pos_rec.z_cs(idx);
    else 
	return 0;
}

/**
 * @brief  ƥݥꥪ֥ȤΤshallow copy°Ϳ (̤)
 * @deprecated  ̤
 */
/* : Ȥ֤Ȥreturn ʸǤȥ󥹥 */
/*       2󥳥ԡȤʻˤʤΤ void ˤʤäƤ */
void tarray_tstring::set_scopy_flag()
{
    return;
}

/**
 * @brief  ֥Ⱦɸ२顼Ϥؽ
 *
 *  ȤΥ֥Ⱦɸ२顼ϤؽϤޤ
 *
 */
void tarray_tstring::dprint( const char *msg ) const
{
    size_t i;
    if ( msg != NULL ) {
	sli__eprintf("%s sli::%s[obj=0x%zx] = {",
		     msg, CLASS_NAME, (const size_t)this);
    }
    else {
	sli__eprintf("sli::%s[obj=0x%zx] = {",CLASS_NAME,(const size_t)this);
    }
    for ( i=0 ; i < this->length() ; i++ ) {
	if ( i != 0 ) sli__eprintf(", ");
	dump_tstring(this->at_cs(i));
    }
    sli__eprintf("}\n");
    return;
}


/*
 * private member functions
 */
 
/**
 * @brief   cstr_ptrs_rec 򹹿
 * 
 * @return  Ȥλ
 * @throw   Хåեγݤ˼Ԥ
 * @note    ΥдؿprivateǤ 
 */
 tarray_tstring &tarray_tstring::update_cstr_ptrs_rec()
{
    size_t i;
    const char **ptrs;
    this->cstr_ptrs_rec.resize(this->arrs_rec.length() + 1);
    ptrs = (const char **)(this->cstr_ptrs_rec.data_ptr());
    for ( i=0 ; i < this->arrs_rec.length() ; i++ ) {
	this->arrs_rec[i].register_extptr(ptrs + i);
	ptrs[i] = this->arrs_rec[i].cstr();
    }
    ptrs[i] = NULL;

    return *this;
}

/**
 * @brief   ptrؤɥ쥹ȤʸǤå
 * 
 * @param   ptr ɥ쥹
 * @return  ȤΰλϿ<br>
 *          ʳλϵ
 * @note    ΥдؿprivateǤ 
 */
bool tarray_tstring::is_my_buffer( const char *const *ptr ) const
{
    const char *const *cstr_ptrs = this->cstrarray();
    if ( ptr == NULL || cstr_ptrs == NULL ) return false;
    if ( cstr_ptrs <= ptr && ptr < cstr_ptrs + this->length() + 1 )
	return true;
    else
	return false;
}

/**
 * @brief  ɽˤޥå(private)
 *
 *  ʸ target Фregex_ref ǻꤵ줿 POSIX ĥɽ
 *  ˤʸޥåԤʸȤƼȤ˳Ǽޤ
 * 
 * @param   target ޥåоݤtstring֥
 * @param   pos ʸޥåγϰ
 * @param   regex_ref tregex 饹Υѥѥ֥
 * @param   nextpos pos
 * @return  ǽ˥ޥå<br>
 *          Ԥ
 * @throw   regex롼󤬥Ȥ̤Ƥ
 * @throw   Хåեγݤ˼Ԥ
 * @throw   ˲򵯤
 * @note    ΥдؿprivateǤ
 */
ssize_t tarray_tstring::regexp_match_advanced( const tstring &target,
					       size_t pos,
					       const tregex &regex_ref,
					       size_t *nextpos )
{
    int status;
    size_t to_append, n_result, i, len_target_str = 0;
    const char *str_ptr;
    const char *target_str;
    tstring bak_target;

    /* ȤݻʸξϥԡΤоݤˤ */
    for ( i=0 ; i < this->length() ; i++ ) {
	if ( &(this->at_cs(i)) == &target ) break;
    }
    if ( i < this->length() ) {	/* Ĥä */
	bak_target.init(target);
	target_str = bak_target.cstr();
	len_target_str = bak_target.length();
    }
    else {
	target_str = target.cstr();
	len_target_str = target.length();
    }

    this->erase();

    if ( target_str == NULL ) goto quit;
    if ( len_target_str < pos ) goto quit;
    if ( regex_ref.cregex() == NULL ) goto quit;

    to_append = 1;
    str_ptr = regex_ref.cstr();
    /* '(' θĿɲʬˤ롥'\\(' ⥫Ȥ뤬OK */
    if ( str_ptr != NULL ) {
	for ( i=0 ; str_ptr[i] != '\0' ; i++ ) {
	    if ( str_ptr[i] == '(' ) to_append++;
	}
    }

    this->reg_pos_rec.resize(1);
    this->reg_length_rec.resize(1);
    do {
	this->reg_pos_rec.resizeby(to_append);
	this->reg_length_rec.resizeby(to_append);
	/* */
	status = c_regsearchx(regex_ref.cregex(), target_str + pos, 
			      (0 < pos), false, 
			      this->reg_pos_rec.length(),
			      (size_t *)(this->reg_pos_rec.data_ptr()),
			      (size_t *)(this->reg_length_rec.data_ptr()),
			      &n_result);
	if ( status != 0 ) {
	   this->init_reg_results();
	   if ( c_regfatal(status) ) {
	     err_throw(__FUNCTION__,"FATAL","Out of memory in c_regsearchx()");
	   }
	   goto quit;
	}
	if ( n_result == 0 ) {	/* never */
	    goto quit;
	}
    } while ( this->reg_pos_rec.length() <= n_result );

    this->reg_pos_rec.resize(n_result);
    this->reg_length_rec.resize(n_result);
    this->resize(n_result);

    for ( i=0 ; i < n_result ; i++ ) {
	this->reg_pos_rec.z(i) += pos;
	this->at(i).assign(target_str + this->reg_pos_rec.z(i),
			   this->reg_length_rec.z(i));
    }

    if ( 0 < n_result ) {
	ssize_t ret = this->reg_pos_rec.z(0);
	size_t span = this->reg_length_rec.z(0);
	if ( nextpos != NULL ) {
	    size_t add_span = ((span == 0) ? 1 : span);
	    if ( 0 <= ret ) *nextpos = ret + add_span;
	    else *nextpos = len_target_str + 1;
	}
	return ret;
    }

 quit:
    if ( nextpos != NULL ) *nextpos = len_target_str + 1;
    this->init_reg_results();
    return -1;
}

/**
 * @brief  ɽη̤γǼ
 *
 * @note   ΥдؿprivateǤ 
 */
void tarray_tstring::init_reg_results()
{
    this->reg_pos_rec.init(sizeof(size_t), true);
    this->reg_length_rec.init(sizeof(size_t), true);
    return;
}

static const tstring junk;

/**
 * @brief  at() ѤΥдؿ (private)
 *
 * @note   ΥдؿprivateǤ 
 */
tstring &tarray_tstring::tstring_ref_after_resize( size_t index )
{
    this->resize(index + 1);
    return this->arrs_rec.at(index);
}

/**
 * @brief  at() ѤΥдؿ (private)
 *
 * @note   ΥдؿprivateǤ 
 */
const tstring &tarray_tstring::err_throw_const_tstring_ref( const char *fnc,
					const char *lv, const char *mes ) const
{
    err_throw(fnc,lv,mes);
    return junk;		/* never */
}

}	/* namespace sli */


#include "private/c_memcpy.cc"
#include "private/c_strncmp.cc"
#include "private/c_isalpha.cc"
#include "private/c_regsearchx.c"
#include "private/c_regfatal.c"

